1999-12-31  Richard M. Stallman  <rms@gnu.org>

	* echistory.el (electric-command-history): Call Command-history-setup
	and command-history-mode using their new conventions.

	* chistory.el (Command-history-setup): Don't switch buffers.  Take
	no args, and do not set major-mode, mode-name or the local map.
	(command-history-mode): New function, does some of those things
	Command-history-setup used to do.
	(list-command-history): Call command-history-mode, not
	Command-history-setup.
	(command-history): Renamed from command-history-mode.

1999-12-31  Richard M. Stallman  <rms@gnu.org>

	* arc-mode.el (archive-mode-map): Bind q to quit-window.

1999-12-31  William M. Perry  <wmperry@aventail.com>

	* image.el (defimage): Images with the `:data' keyword should be
	considered valid as well.

1999-12-31  Richard M. Stallman  <rms@gnu.org>

	* dired.el (dired-get-filename): Don't call file-name-absolute-p
	with FILE if FILE is nil.

1999-12-30  Richard M. Stallman  <rms@gnu.org>

	* simple.el (choose-completion-string): In minibuffer,
	do not delete the prompt string.

1999-12-30  Gerd Moellmann  <gerd@gnu.org>

	* bindings.el (make-mode-line-mouse-sensitive): Copy keymap
	assigned to mode-line-mode-menu because bindings.el is dumped with
	Emacs, and thus the lists used for menu-item definition will be
	copied to pure space.  Emacs' menu code (parse_menu_item) doesn't
	like pure menu item definitions.

	* expand.el (expand-abbrev-hook): Return t if expansion was
	done, nil otherwise.

1999-12-29  Richard M. Stallman  <rms@gnu.org>

	* tar-mode.el (tar-mode-map): Bind q to quit-window, not tar-quit.
	(tar-quit): Function deleted.

1999-12-29  Thien-Thi Nguyen  <ttn@delysid.gnu.org>

	* progmodes/hideshow.el (hs-minor-mode-menu): Fix omission bug;
	was used but not declared.

	(hs-discard-overlays, hs-isearch-show, hs-isearch-show-temporary,
	hs-find-block-beginning): Add or modify docstrings.

	(hs-isearch-show): Rewrite.

1999-12-28  Gerd Moellmann  <gerd@gnu.org>

	* icomplete.el (icomplete-exhibit): Adapt to prompt in buffer.

	* progmodes/cc-cmds.el (c-fill-paragraph): Don't delete white
	space in front of a C-style comment end.

1999-12-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* startup.el (command-line-1): Make mode line mouse-sensitive for
	the MS-DOS version as well.

1999-12-28  Gerd Moellmann  <gerd@gnu.org>

	* bs.el: New file.

1999-12-28  Richard M. Stallman  <rms@gnu.org>

	* textmodes/ispell.el (ispell-process-line):
	Add local var line-offset to adjust for the change
	in positions within the line, due to previous replacements.

1999-12-27  Richard M. Stallman  <rms@gnu.org>

	* lpr.el (lpr-buffer, print-buffer, lpr-region, print-region):
	Doc fixes.

1999-12-27  Gerd Moellmann  <gerd@gnu.org>

	* add-log.el (change-log-version-number-regexp-list)
	(change-log-version-info-enabled): Change :version to 21.1.
	(toplevel): Require CL when compiling.

1999-12-27  Jari Aalto  <jari.aalto@poboxes.com>

	* add-log.el (change-log-version-number-regexp-list): Added tag
	:version 20.6
	(change-log-version-info-enabled): Added tag :version 20.6

1999-12-27  Jari Aalto  <jari.aalto@poboxes.com>

	* add-log.el: More general version number search with
	user-configurable regexp list.
	(change-log-version-number-regexp-list): New user variable.
	(change-log-find-version): Rewritten.  Use user-configurable
	version numbering regexp list
	change-log-version-number-regexp-list.
	(change-log-find-version): Renamed to
	change-log-version-number-search
	(add-log-file-name-function): New.
	(change-log-search-vc-number): Added END paramaeter.  Added doc
	string to function.
	(change-log-version-rcs): Renamed.  Was
	change-log-search-vc-number.

1999-12-26  Thien-Thi Nguyen  <ttn@delysid.gnu.org>

	* progmodes/compile.el (compilation-goto-locus): Delete hideshow
	overlays if they interfere.
	(compilation-find-file): Make intangible overlays tangible.

	* progmodes/hideshow.el: Generally, synch w/ maintainer
	version 5.9.

	(hs-show-hidden-short-form): Delete var; hard-code uses as `t'.

	(hs-minor-mode-hook): Don't initialize.

	(hs-special-modes-alist): Rewrite value and docstring.

	(hs-minor-mode-prefix): Delete unused var.

	(hs-block-start-mdata-select): New var, buffer local.

	(hs-headline): New var.

	(hs-match-data, hs-forward-sexp): New funcs.

	(hs-hide-comment-region): New func.

	(hs-discard-overlays, hs-flag-region, hs-hide-block-at-point)
	(hs-safety-is-job-n, hs-hide-initial-comment-block)
	(hs-inside-comment-p, hs-grok-mode-type, hs-find-block-beginning)
	(hs-hide-level-recursive, hs-life-goes-on, hs-already-hidden-p)
	(hs-c-like-adjust-block-beginning, hs-hide-all, hs-show-all)
	(hs-hide-block, hs-show-block, hs-show-region, hs-hide-level)
	(hs-mouse-toggle-hiding, hs-minor-mode): Rewrite.

	(hs-isearch-show): Renamed from `hs-isearch-open-invisible'.
	(hs-isearch-show-temporary): New funcs.

	(hs-show-block-at-point, java-hs-forward-sexp): Delete funcs.

	(hs-hide-all, hs-mouse-toggle-hiding): Don't autoload.

	When constructing menu, use `[(shift button2)]' notation.

1999-12-25  Richard M. Stallman  <rms@gnu.org>

	* jka-compr.el (jka-compr-info-file-magic-bytes): New function.
	(jka-compr-compression-info-list): Add new elt to each vector.
	(jka-compr-write-region): Don't compress the data if it is
	already compressed.

	* jka-compr.el (jka-compr-really-do-compress): New variable.
	(jka-compr-insert-file-contents): Set jka-compr-really-do-compress
	if visiting.
	(jka-compr-write-region): Set jka-compr-really-do-compress
	if visiting.  Test it when deciding to compress.

1999-12-22  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/sh-script.el (sh-mode): Don't call sh-set-shell
	with third argument t.

1999-12-21  Christoph Wedler  <Christoph.Wedler@sap.com>

	* antlr-mode.el: Version 1.2 is released.
	(antlr): This package has a web page.

1999-12-21  Christoph Wedler  <Christoph.Wedler@sap.com>

	* antlr-mode.el: Menu/keymap additions for commenting/uncommenting
	regions.  Suggested by Dale Davis <Dale_Davis@securify.com>.
	(antlr-mode-map): New binding [C-c C-c].
	(antlr-mode-menu): New entries.

1999-12-21  Christoph Wedler  <Christoph.Wedler@sap.com>

	* antlr-mode.el: Respect Emacs conventions.
	((require 'cl)): Only use during compilation.
	(antlr-language-for-option): New function to avoid using `find'.
	(antlr-mode): Use it.
	(antlr-with-syntax-table): Define new instead using XEmacs' one.
	(antlr-imenu-create-index-function): Change accordingly.
	(antlr-inside-rule-p): Ditto.
	(antlr-end-of-rule): Ditto.
	(antlr-end-of-body): Ditto.
	(antlr-beginning-of-rule): Ditto.
	(antlr-indent-line): Ditto.

1999-11-21  Christoph Wedler  <Christoph.Wedler@sap.com>

	* antlr-mode.el: Really use `antlr-tab-offset-alist'.
	(antlr-set-tabs): Don't use hard-coded values.

	* antlr-mode.el: Minor navigation changes.  Not perfect, but this
	won't be possible without a huge time penalty.
	(antlr-skip-exception-part): Be more specific.
	(antlr-skip-file-prelude): Don't skip action prelude of next rule.
	Renamed from `antlr-skip-grammar-header'.
	(antlr-next-rule): Change accordingly.
	(antlr-end-of-body): Ditto.  Better error message.
	(antlr-beginning-of-body): Better error message.
	(antlr-imenu-create-index-function): Skip rule action prelude.

	* antlr-mode.el: Minor syntax highlighting changes.
	(antlr-font-lock-default-face): Deletia.
	(antlr-font-lock-tokendef-face): Changed color.
	(antlr-font-lock-tokenref-face): Changed color.
	(antlr-font-lock-literal-face): Changed color.
	(antlr-font-lock-additional-keywords): Minor changes.

1999-12-20  Carsten Dominik  <cd@gnu.org>

	* progmodes/idlwave.el: New file.

	* progmodes/idlwave-rinfo.el: New file.

	* progmodes/idlwave-shell.el: New file.

	* progmodes/idlwave-toolbar.el: New file.

	* files.el (auto-mode-alist): idlwave-mode default for .pro files.

1999-12-21  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/cwarn.el: New file.

1999-12-19  Gerd Moellmann  <gerd@gnu.org>

	* bindings.el (completion-ignored-extensions): Add .pdf.

1999-12-19  Eli Zaretskii  <eliz@is.elta.co.il>

	* version.el: Put the version info into binary on MS-DOS as well.

1999-12-19  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/debug.el (debugger-continue): Don't continue if
	debugger-may-continue is nil.

1999-12-18  Dave Love  <fx@gnu.org>

	* emacs-lisp/cl-macs.el: Remove conditional definition of
	eval-when-compile.  Don't specify abs, expt, gethash,
	hash-table-count, hash-table-p as side-effect-free here.
	(cl-emacs-type): Don't declare.
	(cl-compile-time-init): Remove Emacs 18 compiler patch.
	(cl-parse-loop-clause): Remove compatibility code.

	* emacs-lisp/byte-opt.el: Don't put optimization info on `eql'.
	(side-effect-free-fns): Add gethash, hash-table-count.
	(side-effect-and-error-free-fns): Add hash-table-p.

	* emacs-lisp/cl.el: Remove Emacs 18 compatibility code.  Prepend
	`cl-' to autoload names for some hash functions.  Don't autoload
	eval-when-compile.  Don't provide mini-cl.
	(cl-emacs-type): Remove.
	(cl-map-extents): Remove compatibility code.

	* emacs-lisp/float.el: Bind free variables.

	* emacs-lisp/bytecomp.el (byte-compile-constp): Include keywords.

1999-12-16  Gerd Moellmann  <gerd@gnu.org>

	* bindings.el (completion-ignored-extensions): Add .tfm.

1999-12-16  Dave Love  <fx@gnu.org>

	* faces.el (set-face-attribute): Purecopy the attributes set.

	* custom.el (custom-declare-variable): Purecopy value.

	* emacs-lisp/bytecomp.el (byte-compile-bound-variables): Doc fix.
	(byte-extrude-byte-code-vectors): Use remprop.
	(byte-compile-lambda): Check that arg is a lambda.

1999-11-16  Anders Lindgren  <AndersL@andersl.com>

	* font-lock.el: System for adding and removing keywords.
	Both local (previously added keyword) and global keywords
	can be removed.
	(font-lock-remove-keywords): New user-level function.
	(font-lock-update-removed-keyword-alist): New internal function.
	(font-lock-removed-keywords-alist): New variable.
	(font-lock-add-keywords): Updates `font-lock-removed-keywords-alist'.
	Empty `font-lock-keywords-alist' when `append' is `set' to avoid
	growing datastructures.
	(font-lock-set-defaults): Removes keywords stored in
	`font-lock-removed-keywords-alist' after local keywords added.

1999-12-16  Anders Lindgren  <andersl@andersl.com>

	* font-lock.el (c-keywords, c++-keywords): Better "case" support for
	complex constant expressions, e.g. "case 1<<A_BIT_NO:".

	* font-lock.el (c-keywords): Only highlight preprocessor
	directives when spelled correctly.

	* font-lock.el (font-lock-match-c++-structor-declaration,
	c++-keywords): Fontify constructors and destructors with function
	face inside C++ class declarations.

1999-12-16  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/sh-script.el (sh-mode): If there is no #!-line, use
	the shell from sh-shell-file.

	* font-lock.el (java-keywords): Add Javadoc tags as of JDK 1.2.1.

1999-12-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* ls-lisp.el (ls-lisp-insert-directory): Print an explicit message
	if one of the files specified cannot be accessed by
	file-attributes.  Do not strip any leading directories from the
	file names, to behave more like `ls' does.

	* dired.el (dired-get-filename): Handle absolute file names.
	(dired-readin-insert): If argument is a cons, don't print
	"wildcard" on the ``total'' line.

1999-12-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* faces.el (face-read-integer, read-face-attribute)
	(color-defined-p, color-values): Allow color values unspecified-fg
	and unspecified-bg, handle them as unspecified.

1999-12-15  Carsten Dominik  <dominik@astro.uva.nl>

	* textmodes/reftex.el (reftex-compile-variables): Respect new
	structure of `reftex-index-macro'
	(reftex-compile-variables): Use the changed structure of
	`reftex-label-alist'.

	* textmodes/reftex-vars.el (reftex-index-math-format)
	(reftex-toc-max-level): New option.
	(reftex-index-phrases-search-whole-words)
	(reftex-index-phrases-case-fold-search)
	(reftex-index-phrases-skip-indexed-matches)
	(reftex-index-phrases-wrap-long-lines)
	(reftex-index-phrases-sort-prefers-entry)
	(reftex-index-phrases-sort-in-blocks): New options.
	(reftex-index-macros): Option structure changed.
	(reftex-index-macros-builtin): Added `repeat' item to each entry.
	(reftex-label-alist): Additional item in each entry to specify if
	the environment should be listed in the TOC.
	(eval-when-compile (require 'cl)) added.

	* textmodes/reftex-index.el (reftex-index-selection-or-word):
	No longer deals with "repeat".
	(reftex-index): "repeat property in `reftex-index-macro-alist'
	is now used.
	(reftex-index-phrases-comment-regexp)
	(reftex-index-phrases-macrodef-regexp)
	(reftex-index-phrases-phrase-regexp1)
	(reftex-index-phrases-phrase-regexp2)
	(reftex-index-phrases-phrase-regexp12, reftex-index-phrases-help):
	New constants.
	(reftex-index-phrases-macro-data, reftex-index-phrases-files)
	(reftex-index-phrases-font-lock-keywords)
	(reftex-index-phrases-font-lock-defaults, reftex-index-phrases-map)
	(reftex-index-phrases-restrict-file): New variables.
	(reftex-index-phrase-selection-or-word)
	(reftex-index-visit-phrases-buffer)
	(reftex-index-initialize-phrases-buffer)
	(reftex-index-phrases-save-and-return, reftex-index-phrases-mode)
	(reftex-index-next-phrase, reftex-index-this-phrase)
	(reftex-index-all-phrases, reftex-index-region-phrases)
	(reftex-index-phrases-parse-header)
	(reftex-index-phrases-toggle-restricted, reftex-index-new-phrase)
	(reftex-index-find-next-conflict-phrase, reftex-index-phrases-info)
	(reftex-index-phrases-set-macro-key, reftex-index-sort-phrases)
	(reftex-compare-phrase-lines, reftex-index-make-phrase-regexp)
	(reftex-index-simplify-phrase, reftex-index-phrases-find-dup-re)
	(reftex-index-make-replace-string)
	(reftex-query-index-phrase-globally, reftex-query-index-phrase)
	(reftex-index-phrase-match-is-indexed)
	(reftex-index-phrases-fixup-line)
	(reftex-index-phrases-replace-space)
	(reftex-index-select-phrases-macro): New functions.
	(reftex-index-globalize, reftex-index-globally): Functions removed;
	(eval-when-compile (require 'cl)) added.

	* textmodes/reftex-toc.el (reftex-toc-mode): Create new indicator
	for max level.
	(reftex-toc-max-level-indicator): New variable.
	(reftex-toc-max-level): New command.
	(reftex-toc-map): New keybinding `t'.
	(reftex-toc-help): Constant updated.
	(eval-when-compile (require 'cl)) added.

	* textmodes/reftex-ref.el (reftex-offer-label-menu): Prefix to
	`t' command key can change `reftex-toc-max-level';
	(eval-when-compile (require 'cl)) added.

	* textmode/reftex-sel.el (reftex-insert-docstruct): Respect
	`reftex-toc-max-level'.  (eval-when-compile (require 'cl)) added.

	* textmodes/reftex-auc.el: (eval-when-compile (require 'cl)) added.

	* textmodes/reftex-vcr.el: (eval-when-compile (require 'cl)) added.

	* textmodes/reftex-cite.el (reftex-citep, reftex-citet): New commands.
	(reftex-citation, reftex-do-citation, reftex-figure-out-cite-format):
	Additional argument FORMAT-KEY to preselect a citation format;
	(eval-when-compile (require 'cl)) added.

	* textmodes/reftex-parse.el (reftex-context-substring): Optional
	parameter to-end.
	(reftex-section-info): Deal with environment matches;
	(eval-when-compile (require 'cl)) added.

	* reftex-global.el: (eval-when-compile (require 'cl)) added.

1999-12-15  Kenichi Handa  <handa@etl.go.jp>

	The following changes are for the new composition mechanism.  We
	have deleted `composition' charset and composite characters,
	instead introduced a special text property `composition'.

	* composite.el: New file.

	* ps-mule.el: Define encode-composition-rule and find-composition
	for Emacs 20.4 and the earlier versions.
	(ps-mule-init-external-library): Just require a feature for
	external libraries.
	(ps-mule-prologue): Postscript code modified for new composition.
	(ps-mule-find-wrappoint): New arg COMPOSITION.
	(ps-mule-plot-string): Delete code for composite characaters.
	(ps-mule-plot-composition): New funcion.
	(ps-mule-prepare-font-for-components): New function.
	(ps-mule-plot-components): New function.
	(ps-mule-composition-prologue-generated): Renamed from
	ps-mule-cmpchar-prologue-generated.
	(ps-mule-composition-prologue): New named from
	ps-mule-cmpchar-prologue.  Modified for new composition.
	(ps-mule-plot-rule-cmpchar, ps-mule-plot-cmpchar,
	ps-mule-prepare-cmpchar-font): Deleted.
	(ps-mule-string-encoding): New arg NO-SETFONT.
	(ps-mule-bitmap-prologue): In Postscript code of BuildGlyphCommon,
	check Composing, not Cmpchar
	(ps-mule-initialize): Set ps-mule-composition-prologue-generated
	to nil.
	(ps-mule-begin-job): Check existence of new composition.

	* ps-print.el (ps-plot-region): Handle new composition.

	* simple.el (what-cursor-position): Show "(composed)" if the
	character is composed.

	* international/characters.el: Fix cateogries of Lao symbols.

	* international/fontset.el (vertical-centering-font-regexp):
	New variable.

	* international/mule.el (mule-version): Updated to 5.0 (AOI).
	(mule-version-date): Updated to 1999.12.7.
	(with-category-table): New macro.

	* international/mule-cmds.el (encode-coding-char): Don't check
	composite character.

	* international/mule-conf.el (iso-2022-7bit, iso-2022-7bit-ss2)
	(iso-2022-7bit-lock, iso-2022-7bit-lock-ss2, iso-2022-8bit-ss2)
	(x-ctext): Give `composition' property t.

	* international/mule-util.el (set-nested-alist): Set BRANCHES (if
	non-nil) at the tail of ALIST.
	(compose-region, decompose-region, decompose-string)
	(reference-point-alist, compose-chars): Moved to composite.el.
	(compose-chars-component, compose-chars-rule, decompose-composite-char):
	Deleted.

	* international/quail.el (quail-install-map): New optional arg NAME.
	(quail-get-translation): If DEF is a symbol but not a function,
	ignore it.
	(quail-start-translation): Put a key sequence undefined in the
	translation keymap in unread-command-events, not generated-events.
	Return parameterized event (compose-last-chars N) if the input
	characters should be composed.
	(quail-map-definition): If DEF is t, treat it as nil.
	(quail-delete-last-char): Delete the quail region.
	(quail-show-translations): Don't show list of translations if the
	quail package is deterministic.
	(quail-completion-max-depth): New variable.
	(quail-completion-1): Pay attention to the above variable.
	Fix for the case that a translation is a function.
	(quail-map-from-table, quail-map-from-table-1)
	(quail-map-from-table-2): New functions.
	(quail-lookup-map-and-concat): New function.

	* language/devan-util.el: Mostly rewritten.

	* language/lao.el: Register lao-composition-function in
	composition-function-table.

	* language/lao-util.el: Mostly rewritten.

	* language/thai.el: Register thai-composition-function in
	composition-function-table.
	(thai-tis620): Delete `pre-write-conversion' property.

	* language/thai-util.el (thai-category-table): Make it by
	make-category-table.
	(thai-composition-pattern): New variable.
	(thai-compose-region, thai-compose-string): Use
	with-category-table.
	(thai-post-read-conversion): Just call thai-compose-region.
	(thai-pre-write-conversion): Deleted.
	(thai-composition-function): New funciton.

	* language/tibet-util.el: Most functions rewritten.
	(tibetan-char-p): Renamed from tibetan-char-examin.
	(tibetan-composable-examin, tibetan-complete-char-examin)
	(tibetan-vertical-stacking, tibetan-composition): Deleted.
	(tibetan-add-components): New function.
	(tibetan-composition-function): New function.

	* language/tibetan.el: Register tibetan-composition-function in
	composition-function-table.
	(tibetan-composable-pattern): New variable.
	(tibetan-subjoined-transcription-alist): Change key "R" to "+R".
	(tibetan-precomposition-rule-alist): Move punctuations to
	tibetan-punctuation-transcription-alist and
	tibetan-obsolete-glyphs.
	(tibetan-punctuation-transcription-alist): New variable.
	(tibetan-obsolete-glyphs): New variable.
	(tibetan-regexp): Improve the initialization code.

	* textmodes/fill.el (fill-find-break-point): Delete codes for
	composite characters.
	(fill-region-as-paragraph): Likewise.

1999-12-14  Gerd Moellmann  <gerd@gnu.org>

	* international/mule-cmds.el (default-input-method): Specify
	that it should be set after current-language-environment.

	* custom.el (custom-handle-keyword): Add :set-after.
	(custom-add-dependencies): New function.
	(custom-set-variables): Take dependencies between args into account.

	* battery.el (battery): Doc fix.

1999-12-12  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/cc-make.el: Removed.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Release of cc-mode 5.26

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-forward-conditional): Handle an arbitrary
	target depth.  Optionally count #else lines as clause limits,
	as suggested by don provan <provan@lucent.com>.  #elif
	handling fixed.

	* cc-cmds.el (c-up-conditional-with-else, c-down-conditional)
	(c-down-conditional-with-else): New commands that uses the
	added functionality in `c-forward-conditional'.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-comment): Preserve the alignment with
	a comment on the previous line instead of preserving the
	comment-column.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	Fixes to IDL mode after input from Eric Eide <eeide@cs.utah.edu>:
	* cc-engine.el (c-beginning-of-statement-1): Allow
	`c-conditional-key' to be nil, for the benefit of IDL mode.
	* cc-engine.el (c-guess-basic-syntax): Ditto.
	cc-langs.el (C-IDL-class-key): Fixed.  Don't match `class'
	but do match CORBA 2.3 `valuetype'.
	* cc-langs.el (c-IDL-access-key): New defconst.  Should be nil
	for IDL.
	* cc-langs.el (c-IDL-conditional-key): New defconst.  Should
	be nil for IDL.
	* cc-langs.el (c-IDL-comment-start-regexp): New defconst.
	Like C++.
	* cc-mode.el (idl-mode): Use new `c-IDL-*' defconsts.  Also,
	set `c-method-key' and `c-baseclass-key' to nil.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-menus.el (cc-imenu-c++-generic-expression): Match classes
	with nonhanging open braces.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el: Added docstrings to all lineup functions.

	* cc-align.el (c-lineup-java-throws): Handle a hanging throws
	keyword.

	* cc-align.el (c-lineup-C-comments): Handle free form text
	comments.  Use c-comment-prefix-regexp and comment-start-skip
	instead of hardcoded regexps.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-beginning-of-defun, c-end-of-defun): Fixed eob
	behavior and return value as documented.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	Changes for new style variable init system:
	* cc-langs.el (c-common-init): Dito.
	* cc-styles.el: c-offsets-alist moved to cc-vars.el since it's
	now customizable.
	* cc-vars.el: Style variables may now take a value
	'set-from-style to make them take their value from the style
	system. This value is now the default on all these variables.
	* cc-vars.el (c-valid-offset): New function to verify a
	syntactic symbol offset setting.
	* cc-vars.el (c-offsets-alist): Variable moved from
	cc-styles.el since it's now customizable in a similar way to
	the other style variables.
	* cc-vars.el (c-old-style-variable-behavior): New variable to
	revert to the old style init behavior.

	* cc-vars.el (c-file-style, c-file-offsets): Made always
	buffer local.

	* cc-menus.el (cc-imenu-c++-generic-expression): Don't match
	the throws clause that might follow the function prototype in
	C++.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-beginning-of-macro): Fixed bug where point
	could move forward for macros that doesn't start in column 0.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-indent-multi-line-block,
	c-lineup-whitesmith-in-block): Two new lineup functions for
	use in whitesmith style.

	* cc-styles.el (c-style-alist): More fixes to whitesmith
	style.  It should now handle all different braces uniformly in
	both hanging and non-hanging cases.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-exp): Use a marker to save point to
	make it stay in the same position relative to the surrounding
	text.

	* cc-cmds.el (c-fill-paragraph): Force the line comment prefix
	when adaptive-fill-mode doesn't manage to get it correct.

	* cc-menus.el (cc-imenu-java-generic-expression): Handle types
	with dotted notation, e.g. foo.bar.Gnu.

	* cc-mode.el (c-initialize-cc-mode): Wrap all function calls
	within unwind-protect (previously only some were wrapped so it
	would be possible to register mode initialization when full
	initialization did not finish).

	* cc-styles.el (c-style-alist): Corrected the brace placement
	in the whitesmith style.  Thanks to Sean Luke
	<seanl@cs.umd.edu>.  Also extended the bsd and whitesmith
	styles with consistent brace placement for all constructs.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-context-line-break): Continue C++ comments too
	when point is in the middle of them.

	* cc-cmds.el: Line breaking and paragraph filling code
	rewritten:
	(c-guess-fill-prefix): New function that uses various
	heuristics to guess the comment prefix.
	(c-fill-paragraph): Rewritten to use `c-guess-fill-prefix'.
	It now assumes adaptive filling is active to preserve the line
	prefix inside comments.
	(c-indent-new-comment-line): Replacement for the now
	obsolete `c-comment-line-break-function' that uses
	`c-guess-fill-prefix' when appropriate.  It now observes the
	setting of `comment-multi-line', which has effect in C-style
	block comments.

	* cc-cmds.el (c-context-line-break): New function intended to
	be put on RET.  It's essentially `newline-and-indent', but
	continues C block comments with the appropriate line prefix.

	* cc-cmds.el (c-do-auto-fill): New function put on
	`normal-auto-fill-function' to implement the
	`c-ignore-auto-fill' variable.

	* cc-cmds.el (c-beginning-of-statement): Use
	`c-comment-prefix-regexp' to avoid ending up inside the
	comment prefix.  Better handling of comment starters and
	enders. Catch comments better when traversing code.  Stop at
	preprocessor directives.

	* cc-defs.el (c-forward-comment): New subst to hide platform
	dependent quirks in `forward-comment'.

	* cc-engine.el (c-literal-limits): Added NOT-IN-DELIMITER
	argument.
	(c-literal-limits-fast): Implemented NEAR and NOT-IN-DELIMITER
	arguments. Activate this function by default when
	`parse-partial-sexp' supports it (currently Emacs 20.x).

	* cc-engine.el (c-guess-basic-syntax): Anchor the `c' syntax
	on the comment opener to make constants usable as lineup
	arguments.

	* cc-align.el (c-lineup-C-comments): Fixes to handle the
	changed anchor position in the `c' syntactic symbol.  Handle
	more than stars in the comment prefix; use the new variable
	`c-comment-prefix-regexp'.  Don't indent text not preceded by
	a comment prefix to the right of the comment opener if it's
	long.

	* cc-langs.el: Fixes to mode initialization for new line
	breaking and paragraph filling method.  Adaptive fill mode is
	now activated at startup instead of deactivated.  The
	variables used for adaptive filling and paragraph movement are
	also changed to incorporate the value of
	`c-comment-prefix-regexp'.  `substitute-key-definition' is
	used to override some functions in the global map instead of
	overriding their default bindings.

	* cc-mode.el (java-mode): Modify `paragraph-start' for the
	javadoc markup at mode init.

	* cc-mode.el (c-setup-filladapt): A new convenience function
	to configure Kyle E. Jones' Filladapt mode for CC Mode.  This
	function is intended to be used explicitly by the end user
	only.

	* cc-vars.el (c-comment-prefix-regexp): New variable used to
	recognize the comment fill prefix inside comments.
	(c-block-comment-prefix): New name for
	`c-comment-contiuation-stars', which is now obsolete.  It's
	generalized to handle any character sequence.
	(c-ignore-auto-fill): New variable used to selectively disable
	Auto Fill mode in specific contexts.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-comment-indent): Leave at least one space
	between the comment and the last nonblank character in the
	case where we look at the indentation of the comment on the
	previous line (case 4).

	* cc-engine.el (c-beginning-of-statement-1): Added ``' to the
	list of characters that may start a statement (it's a sort of
	prefix operator in Pike, and isn't used at all in any of the
	other languages).

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Report brace list opens
	inside continued statements as statement-cont instead of
	brace-list-open.  The reason is that one normally adjusts
	brace-list-open for brace lists as top-level constructs, and
	brace lists inside statements is a completely different
	context.  Case 10B.2 changed.  Also changed (the somewhat
	esoteric) case 9A to cope with this.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Added electric handling of
	the open brace for brace-elseif-brace.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-with-syntax-table): New macro to easily switch
	syntax tables temporarily.

	* cc-engine.el (c-guess-basic-syntax): Handle template and
	member init argument lists split over several lines.  Case 5D
	changed.

	* cc-langs.el (c-Java-javadoc-paragraph-start): Added new tag
	@throws introduced in Javadoc 1.2.

	* cc-menus.el (cc-imenu-java-generic-expression): Applied
	patch from RMS to avoid infinite backtracking.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-arglist): Handle "arglists" surrounded
	by [ ].

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-dont-change): Compensate properly for
	the column in langelem.

	* cc-engine.el (c-syntactic-information-on-region): New
	function to help debugging the syntactic analysis.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-template-args): Handle nested template
	arglists.

	* cc-langs.el (c++-template-syntax-table): New syntax table
	that makes `<' and `>' parenthesis characters, which is useful
	to switch to temporarily when analyzing template arglists.

	* cc-styles.el: Changed default alignment of labels in the
	java style to conform to the examples in the Java Language
	Specification.

	* cc-styles.el (c-offsets-alist): Use `c-lineup-template-args'
	by default.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Pike allows a comma
	immediately before the closing paren in an arglist, so don't
	check that in Pike mode.  Case 7A changed.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-region): Fixed bug where comment-only
	lines were ignored under certain conditions.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-template-args): New function for
	aligning continued template argument lists.

	* cc-engine.el (c-guess-basic-syntax): Fix for member init
	lists containing function arglists split over several lines.
	Case 5D.1 changed.

	* cc-engine.el (c-guess-basic-syntax): Fixed bug where
	template-args-cont didn't get recognized when the first
	arglist opener line doesn't contain a template argument.  New
	case 5K.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-point): Changed from subst to macro for
	efficiency.
	(c-beginning-of-defun-1, c-end-of-defun-1): New
	beginning-of-defun/end-of-defun wrappers separated from
	c-point.

	* cc-menus.el (imenu-generic-expression,
	imenu-case-fold-search, imenu-progress-message): Dummy
	definitions to avoid compiler warnings if imenu can't be
	loaded.
	* cc-menus.el (cc-imenu-init): New function called at mode
	init.
	* cc-mode.el (c-mode, c++-mode, objc-mode, java-mode): Moved
	imenu initializations to cc-imenu-init.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Slightly better check
	for lambda-intro-cont in Pike mode.  Case 6 changed.

	* cc-engine.el (c-looking-at-inexpr-block): Fixed bug where
	anything following "new Foo()" was considered an anonymous
	class body in Java mode.

1999-12-12  Barry A. Warsaw  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-comment-line-break-function): When breaking in
	a string, don't insert a new line.

1999-12-12  Barry A. Warsaw  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-at-toplevel-p): New interface function which
	returns information useful to add-on authors.  It tells you
	whether you're at a toplevel statement or not.

1999-12-12  Barry A. Warsaw  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-comment-line-break-function): It is possible
	that forward-line does not land us at the bol, say if we're on
	the last line in a file.  In that case, do a
	back-to-indentation instead of a forward-comment -1.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Don't catch
	"default:" as normal label in case 4.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Use c-bitfield-key to
	recognize continued bitfield declarations.  Case 5D.1 changed.
	* cc-langs.el: New variable c-bitfield-key.
	* cc-mode.el: New variable c-bitfield-key.

1999-12-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-inside-bracelist-p): Tighter test for Java
	anonymous array expressions (i.e. "new Foo[] {.. bracelist
	..}").

1999-12-12  Dave Love  <fx@gnu.org>

	* mail/footnote.el: Require cl when compiling.  Don't autoload
	keymap and minor-mode-alist stuff.  Don't set zmacs-region-stays.
	(footnote-insert-text-marker, Footnote-insert-pointer-marker):
	Avoid `acons'.
	(footnote-mode-line-string, Footnote-add-footnote): Remove
	autoload cookie.

1999-12-12  Richard Sharman  <rsharman@pobox.com>

	* sh-script.el: Fix for when font-lock mode is active.
	(sh-font-lock-unfontify-region-function): New function.

1999-12-12  Eli Zaretskii  <eliz@is.elta.co.il>

	* menu-bar.el (menu-bar-edit-menu): Define the Spell submenu even
	if start-process is not bound, since Ispell now supports such
	platforms as well.

1999-12-12  Gerd Moellmann  <gerd@gnu.org>

	* mail/rmailsum.el (rmail-summary-mode-map): Bind RET to
	rmail-summary-goto-msg.

	* files.el (after-find-file): Fix previous change.

1999-12-11  Dave Love  <fx@gnu.org>

	* help.el (where-is): Use `commandp' as predicate for
	`completing-read'

1999-12-10  Richard M. Stallman  <rms@gnu.org>

	* cus-edit.el (custom-save-delete): Delete all occurrences,
	leave point where the first occurrence was.
	(custom-save-faces): Insert a newline at the end of the comment.
	Avoid a double newline there.
	If final closeparen is at bol, put a space before it.
	(custom-save-variables): Likewise.
	(custom-file): Doc fix.

1999-12-10  Gerd Moellmann  <gerd@gnu.org>

	* dos-w32.el (file-name-buffer-file-type-alist): Add `$' at end of
	regexp matching image and audio files.

1999-12-09  Dave Love  <fx@gnu.org>

	* mail/footnote.el: New file.

1999-12-09  Gerd Moellmann  <gerd@gnu.org>

	* files.el (after-find-file): Use auto-save-visited-file-name if
	set.

	* mail/feedmail.el (feedmail-find-eoh): Take
	feedmail-queue-alternative-mail-header-separator into account.

1999-12-09  Stefan Monnier  <monnier@cs.yale.edu>

	* smerge-mode.el: New file.

	* font-lock.el (font-lock-multiline): New variable.
	(font-lock-add-keywords): Rename `major-mode' into `mode'.
	(font-lock-remove-keywords): Added a dummy `mode' argument for
	potential future support.
	(font-lock-fontify-anchored-keywords,
	(font-lock-fontify-keywords-region): Only handle multiline strings
	if necessary (avoids a pathological behavior in (f.ex) diff-mode).

1999-12-08  Richard M. Stallman  <rms@gnu.org>

	* bookmark.el (bookmark-bmenu-mode-map): Bind RET like f.

	* dired-aux.el (dired-insert-subdir): Add autoload cookie.

1999-12-07  Dave Love  <fx@gnu.org>

	* help.el (view-emacs-problems): New command, bound to C-h P.

	* menu-bar.el (menu-bar-manuals-menu): Add view-emacs-problems.

1999-12-07  Stefan Monnier  <monnier@cs.yale.edu>

	* diff-mode.el (diff-mode-shared-map): Fset'd and doc change.
	(diff-minor-mode, diff-minor-mode-prefix, diff-minor-mode-map):
	New code to support the minor mode version.
	(diff-recenter): New function.
	(diff-next-hunk, diff-next-file): Use it.
	(diff-remembered-files-alist): New var.
	(diff-merge-strings): New function.
	(diff-find-file-name): Make it smarter and use the user's input more.
	(diff-mode): Cosmetic changes.

	* files.el (save-some-buffers): Turn EXITING into the more general
	PRED argument to allow specifying a subset of buffers.

	* simple.el (kill-region): Use the new `delete-and-extract-region'
	rather than the undo log (which is incorrect with *-change-functions).

	* font-lock.el (font-lock-default-fontify-region): Fix subtle
	off-by-one problem that could force re-fontifying the whole buffer.
	(font-lock-remove-keywords): New function.
	(font-lock-add-keywords): Use the new function to ensure idempotence.

1999-12-06  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-cmd.el (viper-minibuffer-standard-hook,
	viper-minibuffer-real-start): Mew functions.
	(viper-read-string-with-history,viper-file-add-suffix,
	viper-trim-replace-chars-to-delete-if-necessary): Adapt to the
	change in the status of the minibuffer prompt.

1999-12-06  Gerd Moellmann  <gerd@gnu.org>

	* comint.el (comint-redirect-results-list)
	(comint-redirect-results-list-from-process): Remove interactive
	spec.

1999-12-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* info.el (info-node, info-menu-5, info-xref): Define colors for
	Info faces if the display supports them.

1999-12-06  Eli Zaretskii  <eliz@is.elta.co.il>

	Changes for automatic remapping of X colors on terminal frames:

	* term/pc-win.el (msdos-setup-initial-frame): New function, run by
	term-setup-hook.  Call msdos-remember-default-colors and
	msdos-handle-reverse-video.
	(msdos-face-setup): Parts of code moved to
	msdos-setup-initial-frame.
	(msdos-handle-reverse-video): New function, modeled after
	x-handle-reverse-video.
	(make-msdos-frame): Don't use initial-frame-alist and
	default-frame-alist.  Call msdos-handle-reverse-video.
	(msdos-color-aliases): Remove.
	(msdos-color-translate, msdos-approximate-color): Remove.
	(msdos-color-values): Use 16-bit RGB values.  RGB values updated
	for better approximation of X colors.
	(msdos-face-setup): Call tty-color-clear.  Remove code that sets
	up tty-color-alist (it is now on startup.el).
	(x-display-color-p, x-color-defined-p, x-color-values,
	x-defined-colors, face-color-supported-p, face-color-gray-p):
	Remove.

	* facemenu.el (facemenu-read-color, list-colors-display): Use
	defined-colors for all frame types.
	(facemenu-color-equal): Use color-values for all frame types.

	* faces.el (read-face-attribute): For :foreground and :background
	attributes and frames on character terminals, translate the color
	to the closest supported one before looking it up in the list of
	valid values.
	(face-valid-attribute-values): Call defined-colors for all types
	of frames.
	(defined-colors, color-defined-p, color-values, display-color-p):
	New finctions.
	(x-defined-colors, x-color-defined-p, x-color-values,
	x-display-color-p): Aliases for the above.

	* startup.el (command-line): Register terminal colors for frame
	types other than x and w32, but only if the terminal supports
	colors.  Call tty-color-define instead of face-register-tty-color.

	* term/x-win.el (xw-defined-colors): Renamed from
	x-defined-colors.
	* term/w32-win.el (xw-defined-colors): Likewise.

	* term/tty-colors.el: New file.
	* loadup.el: Load term/tty-colors.

1999-12-06  Dave Love  <fx@gnu.org>

	* ffap.el: Autoload the ffap alias directly.

1999-12-06  Inge Frick  <inge@nada.kth.se>

	* dired-aux.el (dired-do-shell-command): Changed documentation.
	(dired-shell-stuff-it): A `?' in COMMAND has now the same
	meaning as `*'.

1999-12-06  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (insert-buffer): Doc fix.

	* apropos.el (apropos-mode): Add autoload cookie.

1999-12-06  Sam Steingold  <sds@goems.com>

	* progmodes/etags.el (etags-tags-completion-table): Modified the
	regexp to allow for the CL symbols starting with `+*'.
	(tags-completion-table): Doc fix (it's an obarray, not an alist).
	(tags-completion-table, tags-recognize-empty-tags-table): Remove
	`function' quoting lambda.
	(tags-with-face): New macro.
	(list-tags, tags-apropos): Use it.
	(tags-apropos-additional-actions): New user option.
	(etags-tags-apropos-additional): Use it.
	(tags-apropos): Call etags-tags-apropos-additional.
	(tags-apropos-verbose): New user option.
	(etags-tags-apropos): Use it.
	(visit-tags-table-buffer, next-file): Use `unless'.
	(recognize-empty-tags-table): Renamed to
	tags-recognize-empty-tags-table.
	(complete-tag): Call tags-complete-tag bypassing try-completion.

1999-12-06  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (set-buffer-file-coding-system): Docstring
	modified.

1999-12-05  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* textmodes/bibtex.el (bibtex-hs-forward-sexp): Added to support
	using the hideshow package.
	(hs-special-modes-alist): Added entry for bibtex to allow the use
	of the hideshow package.
	(bibtex-hide-entry-bodies): Deleted as hiding of entry bodies is
	not longer provided by bibtex.el directly.  Instead the hideshow
	package should be used.
	(bibtex-mode-map, bibtex-edit-menu, bibtex-mode): Delete
	references to bibtex-hide-entry-bodies.

1999-12-05  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* textmodes/bibtex.el: Copyright notice is up to date.  Moved
	maintainer information closer to the beginning of the bibtex.el
	file.
	(bibtex-maintainer-salutation): New constant.
	(bibtex-version): New constant.
	(bibtex-submit-bug-report): Use bibtex-version and
	bibtex-maintainer-salutation.
	(bibtex-entry-field-alist): Made booktitle field optional for
	@inproceedings entries when crossreferenced.
	(bibtex-entry-field-alist): Added booktitle field to proceedings
	entry type (for cross referencing). Thanks to Wagner Toledo Correa
	for the suggestion.
	(bibtex-string-file-path): Fixed typo.

1999-12-05  Carsten Dominik  <dominik@strw.leidenuniv.nl>

	* textmodes/bibtex.el (bibtex-mode-map): Reserved the key `C-c &'
	for reftex.el.
	(bibtex-edit-menu): Added `reftex-view-crossref-from-bibtex' to menu.

1999-12-04  Dave Love  <fx@gnu.org>

	* delsel.el: Revert previous change -- region is significant to
	skeleton.

1999-12-04  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-cmd.el (viper-change-state): Use
	viper-ESC-moves-cursor-back to decide whether to move the cursor
	back.

1999-12-03  Kenichi Handa  <handa@mule.m17n.org>

	* international/mule-util.el (truncate-string-to-width): Docsting
	fixed.

1999-12-02  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/lisp-mnt.el (lm-header-multiline): Fix spurious
	use of `cond'.
	(lm-with-file): Move all the find-file...kill-buffer stuff into
	this macro.  Make it use `find-file-noselect' and make it kill
	the buffer only if it wasn't already displayed somewhere.
	(lm-summary, lm-authors, lm-maintainer, lm-creation-date)
	(lm-last-modified-date, lm-version, lm-keywords, lm-adapted-by)
	(lm-commentary, lm-verify, lm-synopsis): Use lm-with-file.
	(lm-commentary): Fix to handle the case when the change log is
	at the end of the file.

1999-12-02  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (charsetp): Fix typo in docstring.

	* international/mule-diag.el (list-coding-categories): Fix typo;
	automatic -> autoload.

1999-12-02  Gerd Moellmann  <gerd@gnu.org>

	* vc.el (vc-update-change-log): Look for rcs2log under
	exec-directory.

	* emacs-lisp/lisp-mode.el (lisp-mode-variables): Change
	outline-regexp, add outline-level.
	(lisp-outline-level): New.

	* calendar/appt.el (appt-convert-time): Handle "12:MMam",
	remove extraneous string-match.

	* finder.el (finder-commentary): Activate Finder mode.

1999-12-01  Anders Lindgren  <andersl@andersl.com>

	* autorevert.el (auto-revert-buffers): Auto-revert mode was turned
	off when reverting buffers that contained mode specifiers.
	`revert-buffer' is now called with non-nil PRESERVE-MODES
	argument.

1999-12-01  Dave Love  <fx@gnu.org>

	* delsel.el: Grok skeleton-pair-insert-maybe.

1999-11-30  Richard M. Stallman  <rms@gnu.org>

	* progmodes/cperl-mode.el (cperl-under-as-char):
	Use nil as default.

1999-11-30  Gerd Moellmann  <gerd@gnu.org>

	* speedbar.el (toplevel): Remove compatibility code for Emacs
	versions without custom.el.

1999-11-30  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el (fortran-strip-sequence-nos): New command.

	* autoinsert.el: Minor doc fixes.
	(auto-insert): Return nil.

	* faces.el (set-face-documentation): Purecopy STRING.

1999-11-29  Dave Love  <fx@gnu.org>

	* derived.el: Doc fixes, remove old backquote syntax.

	* cus-edit.el (custom-save-variables, custom-save-faces): Write a
	comment warning about editing.

	* help.el (help-mode-hook): Define.

1999-11-29  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/edebug.el (edebug-make-enter-wrapper): Correct
	invalid translation of old-style backquote syntax to new syntax.

1999-11-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* Makefile (DONTCOMPILE): Add term/internal.el.

1999-11-26  Dave Love  <fx@gnu.org>

	* comint.el: Fix last change.

	* emacs-lisp/advice.el: Fix last change.

1999-11-26  Richard M. Stallman  <rms@gnu.org>

	* cus-edit.el (Custom-reset-standard): Doc fix.
	(custom-variable-reset-standard): Doc fix.
	(custom-face-reset-standard): Doc fix.
	(custom-face-menu): "Reset to Standard" => "Erase Customization".
	(custom-variable-menu): Likewise.
	(custom-reset-menu): Likewise.
	(custom-buffer-create-internal): Likewise.

1999-11-26  Dave Love  <fx@gnu.org>

	* progmodes/make-mode.el (makefile-mode-hook): Customize.

	* font-lock.el: Doc fixes.

	* menu-bar.el (menu-bar-mode): Customize.

	* cus-start.el: Add use-dialog-box.

	* add-log.el (change-log-mode-hook): Customize.
	(add-log-current-defun): Use
	fortran-{beginning,end}-of-subprogram.

1999-11-26  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/advice.el: Many doc fixes.

	* comint.el (comint-preoutput-filter-functions): Doc fix.

1999-11-26  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/checkdoc.el (checkdoc-this-string-valid-engine):
	Improve messages for capitalization of arg names,
	for flag variables, for t and nil, for imperatives.
	Call them imperatives rather than infinitives sans "to".
	(checkdoc-common-verbs-wrong-voice): Add "moves".
	(checkdoc-message-text-engine): Improve messages for y-or-n-p.

	* emacs-lisp/checkdoc.el (checkdoc-file-comments-engine):
	Don't convert comments from 3-semicolon to 2-semicolon.
	That is a matter of style.
	(checkdoc-triple-semi-comment-check-flag): Variable deleted.
	(checkdoc-comments): Don't bind that variable.

1999-11-26  Richard M. Stallman  <rms@gnu.org>

	* files.el (write-file-hooks): Doc fix.

1999-11-26  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/f90.el (f90-abbrev-start): Use `eq' instead of `='.

1999-11-25  Dave Love  <fx@gnu.org>

	* hippie-exp.el: Require comint when compiling.
	(hippie-expand): Add :links.
	(hippie-expand-try-functions-list): Customize.

1999-11-24  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper*.el: Replaced old-style backquotes.

	* ediff*.el: Replaced old-style backquotes.

	* ediff-merge.el (ediff-looks-like-combined-merge)
	(ediff-get-combined-region):
	Changed to support the new format for ediff-combination-pattern.

	* ediff-diff.el (ediff-set-fine-overlays-in-one-buffer):
	Changed to support the new format for ediff-combination-pattern.

1999-11-24  Dave Love  <fx@gnu.org>

	* custom.el (custom-declare-group): Purecopy DOC.
	(custom-handle-keyword): Purecopy VALUE.
	(custom-add-link): Purecopy WIDGET.
	(custom-add-version): Purecopy VERSION.
	(custom-add-load): Purecopy LOAD.

	* cus-face.el (custom-declare-face): Purecopy DOC.

	* info.el:
	(Info-build-node-completions, Info-search, Info-follow-reference)
	(Info-complete-menu-item, Info-menu, Info-index, Info-get-token)
	(Info-find-emacs-command-nodes): Avoid properties on matched text
	which may appear in minibuffer.

1999-11-24  Gerd Moellmann  <gerd@gnu.org>

	* locate.el (locate-with-filter): Doc fix.

1999-11-24  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-find-sqli-buffer): New function.
	(sql-set-sqli-buffer-generally): New function.
	(sql-set-sqli-buffer): Better checking of new-buffer.
	(sql-copy-column): Add comma after INTO clause, too.

1999-11-24  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-imenu-generic-expression): New, used to set
	imenu-generic-expression.

	* sql.el (sql-mode): Use ?_ and ?. instead of 95 and 46 when
	setting font-lock-defaults' SYNTAX-ALIST.  Set
	imenu-generic-expression, imenu-case-fold-search, and
	imenu-syntax-alist.

	* sql.el (sql-interactive-mode): Use ?_ and ?. instead of 95
	and 46 when setting font-lock-defaults' SYNTAX-ALIST.

1999-11-23  Andrew Innes  <andrewi@gnu.org>

	* w32-win.el (w32-drag-n-drop): Load files in current window, if
	drop coords aren't over a specific window.

1999-11-23  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Define mule funs without checking if mule package is
	loaded.
	(ps-print-version): New version number (5.0.1).
	(ps-header-dirpart): Now uses abbreviate-file-name.

1999-11-23  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el (fortran-comment-line-start): Renamed from
	comment-line-start.
	(fortran-comment-line-start-skip): Renamed from
	comment-line-start-skip.
	(fortran-mode-map): Use renamed functions.  Add manual and custom
	entries to menu.
	(fortran-mode-hook): Customize.
	(fortran-comment-indent-function): Renamed from
	fortran-comment-hook.
	(delete-horizontal-regexp): Function deleted.
	(fortran-electric-line-number): Simplified.
	(fortran-beginning-of-subprogram): Renamed from
	beginning-of-fortran-subprogram.
	(fortran-end-of-subprogram): Renamed from
	end-of-fortran-subprogram.
	(fortran-mark-subprogram): Renamed from mark-fortran-subprogram.
	(fortran-previous-statement, fortran-next-statement): Simplified.
	(fortran-blink-match): New function.
	(fortran-blink-matching-if, fortran-blink-matching-do): Use it.
	(fortran-indent-to-column): Don't use delete-horizontal-regexp.
	(fortran-find-comment-start-skip, fortran-is-in-string-p): Use
	line-end-position.
	(fortran-fill): No longer interactive.  Simplified.
	(fortran-break-line): Simplified.
	(fortran-analyze-file-format): Use char-after, not looking-at.

	* emacs-lisp/find-func.el (find-function-regexp):
	Use `define-minor-mode' after easy-menu change.

1999-11-23  Gerd Moellmann  <gerd@gnu.org>

	* comint.el: Add redirection.from active comint buffers into
	another buffer.  Written by Peter Breton.

1999-11-23  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/autoload.el (make-autoload): Recognize the new
	`define-minor-mode'.
	(define-minor-mode): Specify `doc-string-elt'.

	* emacs-lisp/easy-mmode.el: Changed maintainer.
	(easy-mmode-define-toggle): New BODY arg; Never append `-mode';
	Use defcustom for the hooks; Improve the auto-generated docstrings.
	(easy-mmode-define-minor-mode): Renamed `define-minor-mode'.
	(define-minor-mode): Add BODY arg; Only declare the keymap if
	provided; Improve the auto-generated docstrings.

1999-11-22  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/text-mode.el (text-mode): Construct paragraph-start so
	that the leading `^' is at the start.  This is necessary because
	paragraphs.el tries to remove anchors, but can find them only if
	they are the first character.

	* progmodes/antlr-mode.el: New file.

	* calendar/calendar.el: Fix autoload for
	calendar-absolute-from-astro.  Add autoload for
	calendar-print-astro-day-number.

1999-11-21  Anders Lindgren  <andersl@andersl.com>

	* follow.el: Use modern backquote syntax.  Minor comment update.

1999-11-21  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (with-syntax-table): Don't switch buffers.

	* emacs-lisp/edebug.el, emacs-lisp/cust-print.el,
	progmodes/hideif.el: Use new backquote syntax.

1999-11-21  Ken Manheimer  <klm@python.org>

	* icomplete.el (icomplete-completions): Use an explicit variable
	`icomplete-prospects-length', obviating the need to use an
	apparently faulty throw/catch arrangement.

1999-11-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* term/internal.el (IT-display-table-setup): Don't overstep
	character code 255.

1999-11-20  Kenichi Handa  <handa@mule.m17n.org>

	* ps-mule.el (ps-mule-font-info-database-bdf): Default BDF font
	for the charset chinese-sisheng is 7bit encoding, not 8bit.

1999-11-19  Stefan Monnier  <monnier@cs.yale.edu>

	* scroll-bar.el (scroll-bar-toolkit-scroll): Add handling of the
	`ratio' event for Xaw and Xaw3d(without arrows) scrollbars.

	* files.el (auto-mode-alist): Add patterns for diff-mode.

	* complete.el (PC-do-complete-and-exit): Use minibuffer-prompt-end
	to detect an empty prompt.

1999-11-18  Dave Love  <fx@gnu.org>

	* simple.el (input-mode-8-bit): Fix the customization.

1999-11-18  Gerd Moellmann  <gerd@gnu.org>

	* international/iso-acc.el (iso-languages): Add more
	characters for Portuguese.

	* speedbar.el: Clean up comment at the start of the file.
	Remove RCS id.

	* progmodes/compile.el (compilation-parse-errors): Use
	compilation-buffer-p instead of testing major-mode.

1999-11-18  Dave Pearson  <davep@hagbard.demon.co.uk>

	* quickurl.el: Added defcustom of quickurl-completion-ignore-case.
	(quickurl-ask): completion-ignore-case is set to the value of
	quickurl-completion-ignore-case for the duration of the call to
	completing-read.

1999-11-18  Richard M. Stallman  <rms@gnu.org>

	* mail/rmailedit.el (rmail-cease-edit): Run rmail-mode-hook.

1999-11-18  Kenichi Handa  <handa@etl.go.jp>

	* ps-vars.el: Renamed from ps-print-def.el.  Provide ps-vars
	instead of ps-print-def.

	* ps-print.el: Require ps-vars instead of ps-print-def.

	* ps-mule.el: Require ps-vars instead of ps-print-def.

1999-11-17  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (with-syntax-table): Save buffer explicitly instead of
	using save-excursion.

1999-11-16  Gerd Moellmann  <gerd@gnu.org>

	* mail/supercite.el: New maintainer.

1999-11-16  Reto Zimmermann  <reto@synopsys.com>

	* progmodes/vhdl-mode.el: Use new backquote syntax.

1999-11-16  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (with-syntax-table): New.

1999-11-15  Sam Steingold  <sds@ksp.com>

	* dabbrev.el (dabbrev-filter-elements): Use the new backquote syntax.

1999-02-22  Sam Steingold  <sds@goems.com>

	* goto-addr.el (goto-address-at-mouse,
	goto-address-find-address-at-point): Use compose-mail.
	(goto-address-mail-method): Removed variable.
	(goto-address-send-using-mh-e, goto-address-send-using-mhe,
	goto-address-send-using-mail): Removed functions.

1998-11-03  Sam Steingold  <sds@goems.com>

	* simple.el (backward-delete-char-untabify):
	backward-delete-char-untabify-method can be `all' now - to delete
	hungrily including newlines.

1999-11-15  Sam Steingold  <sds@ksp.com>

	* mail/rnews.el, mail/mh-utils.el: Use the new backquote syntax.

1999-11-15  Dave Love  <fx@gnu.org>

	* cus-edit.el (customize-face, customize-face-other-window):
	Require match from completing-read.
	(custom-buffer-done-function): Default to custom-bury-buffer, not
	bury-buffer.

1999-11-15  Gerd Moellmann  <gerd@gnu.org>

	* mail/rmail.el, iswitchb.el, hippie-exp.el,
	progmodes/cperl-mode.el: Use new backquote syntax.

1998-09-14  Michael Ernst  <mernst@alum.mit.edu>

	* uniquify.el: Use new backquote syntax.

1999-11-14  Markus Rost  <rost@ias.edu>

	* ispell.el (ispell-dictionary-alist): Fix type by adding koi8-r
	as in ispell-local-dictionary-alist.

1999-11-14  Alex Schroeder  <alex@gnu.org>

	* ansi-color.el (ansi-color-apply): Updated regexps to include
	highlighted face.

1999-01-14  Johan Vromans  <jvromans@squirrel.nl>

	* forms.el (forms--make-format-elt-using-text-properties):
	Treat `intangible' differently.

	* forms.el: Use new backquote syntax.

1999-11-13  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/scribe.el (scribe-mode): Doc-fix.

1999-11-13  Peter Breton  <pbreton@ne.mediaone.net>

	* net-utils.el (run-network-program, net-utils-run-program): Use
	the new backquote syntax.
	(smbclient-program, smbclient-program-options)
	(smbclient-prompt-regexp, smbclient-font-lock-keywords): New
	variables
	(smbclient, smbclient-list-shares): New functions

1999-11-12  Sam Steingold  <sds@ksp.com>

	* emulation/viper-init.el (viper-deflocalvar, viper-loop)
	(viper-buffer-live-p, viper-kbd-buf-alist, viper-kbd-buf-pair)
	(viper-kbd-buf-definition, viper-kbd-mode-alist)
	(viper-kbd-mode-pair, viper-kbd-mode-definition)
	(viper-kbd-global-pair, viper-kbd-global-definition):
	Use the new backquote syntax.

	* emulation/viper-cmd.el (viper-test-com-defun)
	(viper-prefix-arg-value, viper-prefix-arg-com):
	Use the new backquote syntax.

	* emacs-lisp/debug.el (debugger-env-macro):
	Use the new backquote syntax.

	* emacs-lisp/easymenu.el (easy-menu-make-symbol):
	Use the new backquote syntax.

	* calendar/calendar.el (calendar-remove-frame-by-deleting):
	New user variable.
	(calendar-hide-window): Use it.
	(increment-calendar-month, calendar-for-loop, calendar-sum):
	Use the new backquote syntax.

1999-11-12  Andrew Innes  <andrewi@gnu.org>

	* select.el (x-set-selection): Call buffer-substring, not
	substring.  Also fix docstring

1999-11-12  Peter Kleiweg  <kleiweg@let.rug.nl>

	* progmodes/ps-mode.el (ps-mode-submit-bug-report): Added list
	of customizable variables to bug report message. Added
	system-type to package name in bug report.

1999-11-12  Gerd Moellmann  <gerd@gnu.org>

	* buff-menu.el (list-buffers-noselect): Use abbreviate-file-name
	to display file names.

1999-11-11  Gerd Moellmann  <gerd@gnu.org>

	* mwheel.el: Fix copyright notice, don't require 'cl at run time.

	* isearch.el: Add lazy-highlighting feature.

1999-11-10  Peter Kleiweg  <kleiweg@let.rug.nl>

	* progmodes/ps-mode.el (ps-mode-maintainer-address): New
	constant.
	(ps-mode-submit-bug-report): New function. Entry added to menu.

1999-11-10  William M. Perry  <wmperry@aventail.com>

	* mwheel.el: New file to support the new style wheeled mice.

1999-11-10  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (initial-scratch-message): Add ";;" to the front of
	lines in the message.

	* files.el (file-local-copy): Remove optional BUFFER argument
	because that's not used by anything.

	* mail/mh-comp.el (mh-smail-batch): If TO is nil, use "" as
	to-address.

1999-11-08  Markus Rost  <rost@ias.edu>

	* wid-edit.el (widget-button-click): Wrap with save-excursion
	to restore track-mouse in the correct buffer.

1999-11-08  Gerd Moellmann  <gerd@gnu.org>

	* mail/mh-e.el: Changed maintainer to billcurtis@hotmail.com.

1999-11-08  Peter Kleiweg  <kleiweg@let.rug.nl>

	* progmodes/ps-mode.el (ps-mode-print-function): Changed default
	lpr-command to "lp" for some system-types. (copied from lpr.el
	Emacs version 20.2.1).

1999-11-04  Markus Rost  <rost@ias.edu>

	* simple.el (comment-region): Strip off white space at end of
	comment-start.

1999-11-04  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (secondary-selection): Fix wrong color name.

1999-11-04  John Tobey  <jtobey@epsilondev.com>

	* gud.el (gud-perldb-massage-args): Handle the case "perl -e 0",
	the default when invoking perldb in a non-Perl buffer, and other
	cases involving -e or --.

1999-11-04  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (previous-matching-history-element)
	(next-history-element): Use delete-field instead of erase-field.

	* isearch.el (isearch-ring-advance-edit, isearch-complete-edit):
	Use delete-field instead of erase-field.

	* faces.el (secondary-selection): Change background to yellow.

	* complete.el (PC-do-completion): Use minibuffer-prompt-end to
	find the start of the text.  Use field-string to read the user
	input.

1999-11-03  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (make-face-bold, make-face-unbold, make-face-italic)
	(make-face-unitalic, make-face-bold-italic): Add NOERROR argument
	for compatibility with old face implementation.

	* isearch.el (isearch-complete-edit, isearch-ring-advance-edit):
	Use erase-field instead of erase-buffer.

	* frame.el (blink-cursor-mode, blink-cursor-end): Use
	internal-show-cursor with new interface.
	(blink-cursor-timer-function): New.
	(blink-cursor-start): Use blink-cursor-timer-function.

1999-11-03  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* calendar.el (redraw-calendar): Move to nearest date before
	redrawing.

	* diary-lib.el (simple-diary-display): Reset modeline even if
	there are no diary entries since the diary buffer may be displayed.

1999-11-03  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/debug.el (debug): If noninteractive, display the
	backtrace using `message', then exit Emacs.
	(debugger-batch-max-lines): New variable.
	(debugger-setup-buffer): New subroutine, broken out of `debug'.
	Change the messages put at the start, to say that the debugger
	was entered.

1999-11-02  Sam Steingold  <sds@ksp.com>

	* progmodes/cmacexp.el (c-macro-preprocessor): Find the Solaris cpp.

1999-11-01  John Tobey  <jtobey@epsilondev.com>

	* gud.el (gud-perldb-massage-args): Massage correctly in the
	presence of perl switches other than "-e".

1999-11-01  Markus Rost  <rost@ias.edu>

	* dired-x.el (dired-smart-shell-command): Use
	shell-command-history as in shell-command.

1999-11-01  Richard M. Stallman  <rms@gnu.org>

	* userlock.el (ask-user-about-lock): Doc fix.

	* frame.el: Doc fixes.

1999-11-01  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (blink-cursor-mode): Call internal-show-cursor instead
	of show-cursor.
	(blink-cursor-start, blink-cursor-end): Ditto.

	* textmodes/tex-mode.el (tex-default-mode): Changed to latex-mode.

1999-11-01  Richard M. Stallman  <rms@gnu.org>

	* window.el (walk-windows): If ALL-FRAMES is a frame,
	start on that frame.  Use save-selected-window.

1999-11-01  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (end-of-buffer): Use window-end to find the window end
	instead of vertical-motion because this handles variable-height
	lines correctly.

1999-11-01  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff.el: Version change.

	* ediff-util.el (ediff-cleanup-mess): Fixed the case of dead windows.
	make sure you are in a good frame before deleting other
	windows.
	(ediff-file-checked-in-p): Don't consider CVS
	files checked in.
	(ediff-make-temp-file,ediff-make-empty-tmp-file): Make sure you
	are writing to a newly created empty file.

	* ediff-mult.el (ediff-show-session-group-hook): New default.

	* ediff-vers.el (ediff-pcl-cvs-view-revision): First cd to the file
	directory; reportedly works better with remote files.

	* ediff-vers.el (ediff-pcl-cvs-internal, ediff-pcl-cvs-merge-internal):
	Use file-name-nondirectory when passing files to CVS.

	* ediff-diff.el (ediff-cmp-options): New variable.
	(ediff-same-file-contents): Use ediff-cmp-options.

	* ediff-ptch.el (ediff-prompt-for-patch-buffer, ediff-get-patch-buffer):
	Use current buffer if it appears to be a patch.

	* viper-keym.el: Fixed calls to viper-ex, change key C-c g to C-c C-g.

	* viper-util.el (viper-nontrivial-find-file-function): Deleted.
	(viper-glob-unix-files, viper-glob-mswindows-files): New functions.
	(viper-save-cursor-color,viper-restore-cursor-color):
	Improved cursor color handling.
	(viper-get-saved-cursor-color-in-replace-mode)
	(viper-get-saved-cursor-color-in-insert-mode): New functions for
	better cursor color handling.

	* viper-ex.el (ex-read,ex-edit):
	Fixes for correct interpretation of #,%.
	(viper-ex): Now works correctly when called from other functions.
	(viper-glob-function): New variable.
	(viper-ex): Save excursion before doing :global.

	* viper-mous.el (viper-counting-clicks-p): Bug fixes.

	* viper-cmd.el (viper-post-command-sentinel)
	(viper-insert-state-post-command-sentinel)
	(viper-insert-state-pre-command-sentinel): Takes better care of
	cursor colors.

	* viper.el: Version change.

1999-10-31  Rajesh Vaidheeswarran  <rv@dsmit.com>

	* whitespace.el (whitespace-update-modeline): Bugfix to ensure
	that the modeline display was updated *only* when
	`whitespace-display-in-modeline' was set, not otherwise.

1999-10-30  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/sgml-mode.el (sgml-char-names): Change "half" to
	"frac12".

	* emacs-lisp/advice.el (ad-activate-on): Make it an alias for
	ad-activate.

1999-10-30  Rajesh Vaidheeswarran  <rv@dsmit.com>

	* whitespace.el: Test for existence of `defcustom' and `defgroup'
	using fboundp instead of assuming that these are not present in
	particular flavors of emacs.
	(whitespace-version): Update to 2.8
	(whitespace-display-in-modeline): Add custom variable to control
	displaying the whitespace errors on the modeline based on
	suggestion from <klaus.berndl@sdm.de>
	(whitespace-buffer): Now returns `t' if unclean and `nil' if
	clean, to enable using as a hook function, as suggested by Puneet
	Goel <puneet@computer.org>
	(whitespace-buffer): Fix a subtle bug that cleaned up only if
	quiet was not set, even with whitespace-auto-cleanup set.
	(whitespace-mode-line): Now uses less modeline real estate and
	shows whitespaces as W:<x>!<y> where <x> is any type of whitespace
	which is present in the file, and <y> is any type of whitespace
	whose check has been suppressed by setting
	`whitespace-check-<whitespace-type>' to nil.
	(whitespace-unchecked-whitespaces): New function to return the
	list of whitespaces for whom checks have been suppressed.
	(whitespace-display-unchecked-whitespaces): Renamed to
	`whitespace-update-modeline' to reflect its functionality.

1999-10-30  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/compile.el (compilation-error-regexp-alist):
	Undo previous change.

1999-10-28  Dave Love  <fx@gnu.org>

	* help.el (help-follow): Make arg optional again and really
	default to point.

1999-10-28  Gerd Moellmann  <gerd@gnu.org>

	* paths.el (rmail-file-name): Make it an option.

	* progmodes/ada-mode.el, progmodes/ada-prj.el,
	* progmodes/ada-stmt.el, progmodes/ada-xref.el: Doc-string and
	comment fixes.

	* progmodes/compile.el (compilation-error-regexp-alist): Recognize
	MIPS Pro 7.3 compiler error message syntax.

1999-10-27  Dave Love  <fx@gnu.org>

	* progmodes/compile.el: Checkdoc-inspired fixes.

1999-10-27  Gerd Moellmann  <gerd@gnu.org>

	* lpr.el (print-buffer): Doc-string fix.

1999-10-27  Dave Love  <fx@gnu.org>

	* emacs-lisp/advice.el: Doc fixes.
	(ad-lemacs-p): Removed.
	(advice): Add :link to defgroup.

1999-10-27  Kenichi Handa  <handa@etl.go.jp>

	* ange-ftp.el (ange-ftp-insert-file-contents): Don't change
	last-coding-system-used by the call of ange-ftp-set-ascii-mode.

1999-10-24  Richard M. Stallman  <rms@gnu.org>

	* window.el (walk-windows): If ALL-FRAMES is a frame,
	start on that frame.  Use save-selected-window.

1999-10-27  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/advice.el (ad-activate-internal): Renamed from
	ad-activate.  All callers changed, including those in data.c.
	(ad-activate-internal-off): Renamed from ad-activate-off.
	All uses changed.
	(ad-activate): Renamed from ad-activate-on.  All uses changed.
	(ad-start-advice, ad-stop-advice, ad-recover-normality):
	Alter the definition of ad-activate-internal, not ad-activate.

1999-10-26  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (command-line-1): Add support for command line
	arguments `file' and `execute'.  Fix handling of `visit'.

1999-10-26  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (read-input-method-name): Handle the
	case that the arg DEFAULT is symbol.

	* international/mule-diag.el (mule-diag): Handle the case that
	default-input-method is symbol.

1999-10-26  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/tildify.el: New file.

1999-10-25  Sam Steingold  <sds@ksp.com>

	* Makefile (compile-files): Fixed the "tr" strings.
	(EMACS): Set to ../src/emacs.

1999-10-25  Gerd Moellmann  <gerd@gnu.org>

	* info.el (Info-build-node-completions): Add '("*") to the
	completion list.

1999-10-25  Richard M. Stallman  <rms@gnu.org>

	* frame.el (auto-raise-mode): When enabling the mode,
	immediately raise the selected frame.

	* indent.el (indent-region): Doc fix.

	* comint.el (comint-output-filter): Make the Comint buffer current
	for the comint-preoutput-filter-functions.

	* mail/reporter.el: Doc fix.

1999-10-24  Stephen Eglen  <stephen@gnu.org>

	* progmodes/octave-mod.el (octave-auto-indent): Remove :version so
	that Octave lisp files can also run under XEmacs 20.
	(require 'custom) added so that files can run under Emacs 19.34.

	* iswitchb.el (iswitchb-default-keybindings): No need to use
	read-kbd-macro in keybindings.

1999-10-23  Dave Love  <fx@gnu.org>

	* elide-head.el: New file.

1999-10-23  Gerd Moellmann  <gerd@gnu.org>

	* Makefile (compile-files, backup-compiled-files): New targets.
	(bootstrap, bootstrap-clean): Ditto.

1999-10-22  Paul Eggert  <eggert@twinsun.com>

	* international/mule-cmds.c (locale-language-names):
	Use Latin-1 (not Latin-3) for Afrikaans, Galician.
	Use Latin-5 (not Cyrillic-ISO) for Byelorussian, Bulgarian,
	Macedonian, Russian, Ukrainian, Serbian (Cyrillic alphabet).
	Use Latin-8 for Welsh.
	Use Latin-1 for English if "en" is explicitly specified.
	Use Latin-1 for Scots Gaelic, Tagalog.
	Use Latin-1 (not Latin-4) for Greenlandic.
	Use Latin-1 (not Latin-2) for Albanian.
	(locale-preferred-coding-systems, locale-language-names):
	Remove generic ISO 8859 locales; locale-charset-language-names now
	does this.
	(locale-charset-language-names): New variable.
	(set-locale-environment): Use language name specified by
	locale-charset-language-names if its charsets disagree with the
	language name specified by locale-language-names.

1999-10-22  Dave Love  <fx@gnu.org>

	* make-mode.el: Minor doc fixes.

	* latin-9.el: Avoid non-ASCII characters to prevent loadup failure.

1999-10-21  Dave Love  <fx@gnu.org>

	* loadup.el: Add latin-8, latin-9.

1999-10-20  Paul Eggert  <eggert@twinsun.com>

	* disp-table.el (standard-display-european): Remove undocumented
	arg AUTO; no longer used by startup.el.  Do not attempt to treat
	all non-English language environments as coding system names.
	Instead, use the downcased language environment name as a coding
	system name if it is one; otherwise, use latin-1.

1999-10-20  Gerd Moellmann  <gerd@gnu.org>

	* dired.el (dired-move-to-filename-regexp): Fix long comment lines
	that were split so that part of the comment appeared as Lisp code.

1999-10-20  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-bdf.el: Doc fix.

	* ps-print-def.el: New file: common definitions for all parts of
	ps-print.
	(ps-multibyte-buffer): Moved from ps-mule.

	* ps-mule.el: File dependence fix.
	(ps-multibyte-buffer): Moved to ps-print-def.

	* ps-print.el: Doc fix, better customization.
	(ps-print-region-function, ps-number-of-columns, ps-spool-tumble)
	(ps-print-color-p, ps-printing-region-p, ps-n-up-database)
	(ps-end-file): Doc fix.
	(ps-setup, ps-begin-file): Fun fix.
	(postscript): New group.
	(ps-zebra-gray, ps-banner-page-when-duplexing): New vars.
	(ps-print-prologue-1): Adjust PostScript programming.
	(ps-print): Adjust group hierarchy.
	(ps-print-n-up, ps-print-zebra, ps-print-background, ps-print-printer)
	(ps-print-page): New subgroups.
	(ps-print-prologue-header, ps-printer-name, ps-lpr-command)
	(ps-lpr-switches, ps-page-dimensions-database, ps-paper-type)
	(ps-landscape-mode, ps-print-control-characters, ps-n-up-printing)
	(ps-n-up-margin, ps-n-up-border-p, ps-n-up-filling, ps-zebra-stripes)
	(ps-zebra-stripe-height, ps-print-background-image)
	(ps-print-background-text, ps-spool-config): Adjust customization.
	(dos-ps-printer): Definition eliminated.

1999-10-20  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-mule.el: Doc fix, define functions properly if mule package is
	loaded or not.
	(ccl-encode-ethio-unicode, ps-mule-encode-ethiopic): Define properly if
	mule package is loaded or not.

	* ps-print.el: Doc fix, n-up printing.
	(ps-print-version): New version number (5.0).
	(ps-page-dimensions-database): Added document media.
	(ps-n-up-printing, ps-n-up-margin, ps-n-up-border-p, ps-n-up-filling)
	(ps-page-order, ps-printing-region-p): New vars.
	(ps-n-up-printing, ps-n-up-filling, ps-header-sheet, ps-end-job):
	New funs.
	(ps-page-dimensions-get-media, ps-n-up-landscape, ps-n-up-lines)
	(ps-n-up-columns, ps-n-up-missing, ps-n-up-xcolumn, ps-n-up-ycolumn)
	(ps-n-up-xline, ps-n-up-yline, ps-n-up-repeat, ps-n-up-end)
	(ps-n-up-xstart, ps-n-up-ystart): New macros.
	(ps-print-begin-sheet-hook): New hook.
	(ps-boundingbox-re, ps-n-up-database, ps-n-up-filling-database):
	New const.
	(ps-setup, ps-begin-file, ps-get-buffer-name, ps-begin-job)
	(ps-end-file, ps-dummy-page, ps-generate): Fix funs.
	(ps-print-prologue-1): Adjust PostScript programming for n-up printing.
	(ps-count-lines): Changed to defun.
	(ps-header-page): Changed to defsubst, fix fun.
	(ps-printing-region): Doc fix, adjust programming code.
	(ps-output-boolean, ps-background-pages, ps-background-text)
	(ps-background-image, ps-background, ps-get-boundingbox):
	Adjust programming code.

1999-10-20  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Doc fix, duplex and setpagedevice configuration.
	(ps-print-version): New version number (4.2).
	(ps-spool-config, ps-spool-tumble): New vars.
	(ps-print-prologue-1): Changed to defconst, adjust PostScript
	programming, new PostScript procedure to handle errors.
	(ps-print-prologue-2): Changed to defconst.
	(ps-print-duplex-feature): New const: duplex and tumble setting.
	(ps-setup, ps-begin-file): Fix funs.
	(ps-boolean-capitalized): New fun.

1999-10-19  Stefan Monnier  <monnier@cs.yale.edu>

	* Makefile (dontcompilefiles): Obsoleted.
	(DONTCOMPILE): Added emacs-lisp/cl-specs.el.
	(EL): Unused.
	(temacs): Removed (unused).
	(cus-load.el, finder-inf.el, loaddefs.el): New targets to build a dummy
	version of the file (necessary for the update to work properly).
	(autoloads): Force the use of `pwd`/loaddefs.el.
	(updates); Redefined in terms of other targets to reduce redundancy.
	(.el.elc): New default rule, just in case you want it.
	(compile): Use a single invocation of Emacs.
	(bootstrap-compile); Unneeded.
	(autoloads-with-other-emacs): Unneeded now that autoloads is fixed.

1999-10-19  Dave Love  <fx@gnu.org>

	* emacs-lisp/eval-reg.el: Removed -- not now needed by edebug.

1999-10-19  Sam Steingold  <sds@ksp.com>

	* map-ynp.el (map-y-or-n-p): Remove extraneous `not' to
	comply with the comment.

1999-10-19  Gerd Moellmann  <gerd@gnu.org>

	* autorevert.el (auto-revert-mode): Make auto-revert-mode
	permanent-local.

1999-10-19  Peter Kleiweg  <kleiweg@let.rug.nl>

	* progmodes/ps-mode.el (ps-mode-print-function): Fix default
	value: \"lpr\" changed to "lpr"
	(ps-mode-version): New constant
	(ps-mode-show-version): New function, added key in ps-mode-map
	(ps-run-messages): Removed
	(ps-run-font-lock-keywords-2): New defcustom variable replacing
	ps-run-messages.  These keywords now include the value of
	ps-run-prompt, making its fontification customizable.
	(ps-run-init): Removed \\n from docstring, it is now added when
	the value is used
	(ps-run-font-lock-keywords-1): Added checking for initial ^ in
	ps-run-prompt
	(ps-mode): Added ps-run-font-lock-keywords-2 to list of
	customizable variables in doc-string (its equivalent
	ps-run-messages was missing in previous version of the doc-string).
	(ps-run-mode): Simplified assignment to font-lock-defaults, using
	symbols only.

1999-10-19  Alex Schroeder  <alex@gnu.org>

	* ansi-color.el: Complete rewrite.

1999-10-19  Paul Eggert  <eggert@twinsun.com>

	Fix bootstrapping problems.
	Use the system locale to specify Emacs locale defaults.

	* international/mule-cmds.el (global-map):
	Do not use backquote, because that makes a bootstrapping
	problem if you need to recompile all Lisp files using interpreted code.
	* international/mule.el (charset-id, charset-bytes)
	(charset-dimension, charset-chars, charset-width)
	(charset-direction, charset-iso-final-char)
	(charset-iso-graphic-plane, charset-reverse-charset)
	(charset-short-name, charset-long-name, charset-description)
	(charset-plist): Likewise.
	* subr.el (save-match-data): Likewise.

	* international/mule-cmds.el
	(set-display-table-and-terminal-coding-system): New function,
	containing code migrated out of set-language-environment.
	(set-language-environment, set-locale-environment): Use it.
	(locale-translation-file-name): Moved here from startup.el.
	(locale-language-names, locale-preferred-coding-systems):
	New vars.
	(locale-name-match, set-locale-environment): New functions.

	* language/japan-util.el (setup-japanese-environment-internal):
	Prefer japanese-iso-8bit if the system-type is usg-unix-v.

	* startup.el (iso-8859-n-locale-regexp): Remove.
	(locale-translation-file-name): Move to mule-cmds.el.
	(command-line): Move locale-stuff into set-locale-environment.

1999-10-18  Dave Love  <fx@gnu.org>

	* abbrev.el (add-abbrev, inverse-add-abbrev)
	(expand-region-abbrevs): Remove properties from buffer text.

1999-10-17  Gerd Moellmann  <gerd@gnu.org>

	* iswitchb.el (iswitchb-exhibit): Extract user-input only
	from the mini-buffer, without the prompt.

	* simple.el (minibuffer-prompt-end): Return the position
	after the prompt, not the position of that last character
	of the prompt.

1999-10-17  Miles Bader  <miles@gnu.org>

	* simple.el: Doc fixes.

1999-10-17  Miles Bader  <miles@gnu.org>

	* simple.el (previous-matching-history-element, next-history-element):
	Change to work correctly even if the point is in the prompt.
	(choose-completion-string): Likewise.
	(minibuffer-prompt-width): New function (compatibility with old subr).

	* textmodes/paragraphs.el (forward-sentence, forward-paragraph):
	When constraining the final position to the current field,
	don't use the ONLY-IN-LINE mode of constrain-to-field.

1999-10-17  Miles Bader  <miles@gnu.org>

	* simple.el (line-move): Supply new ESCAPE-FROM-EDGE argument to
	constrain-to-field.
	* textmodes/paragraphs.el (forward-sentence): Likewise.

1999-10-17  Miles Bader  <miles@gnu.org>

	* simple.el (line-move): Use constrain-to-field to avoid
	moving into a prompt.
	(previous-complete-history-element): Clarify doc string.
	(next-complete-history-element): Likewise.
	Use field-beginning instead of point-min.
	(next-matching-history-element): Use field-beginning and
	erase-field instead of point-min and erase-buffer.
	* textmodes/paragraphs.el
	(forward-paragraph, forward-sentence): Likewise.
	(backward-kill-paragraph, backward-kill-sentence): Remove code to
	constrain the kill to an field, as the movement commands now
	do this.

1999-10-17  Miles Bader  <miles@gnu.org>

	* simple.el (previous-matching-history-element): Get the
	minibuffer input with field-string instead of buffer-string.
	(choose-completion-string): Likewise.
	(next-history-element): Likewise.
	Erase the minibuffer input with erase-field, not erase-buffer.
	Use field-beginning to find the beginning of the input.
	* textmodes/paragraphs.el (backward-kill-sentence):
	Remove minibuffer-prompt hack.
	Constrain to any input field.

1999-10-17  Sam Steingold  <sds@ksp.com>

	* bindings.el (completion-ignored-extensions): Added ".sparcf"
	for CMUCL on sparc and ".ufsl" for LispWorks.
	(bound-and-true-p): Bugfix: free variable `v'.

1999-10-16  Dave Love  <d.love@dl.ac.uk>

	* emacs-lisp/edebug.el (edebug-install-read-eval-functions)
	(edebug-uninstall-read-eval-functions): Use load-read-function,
	avoiding elisp-eval.

1999-10-16  Sam Steingold  <sds@ksp.com>

	* emacs-lisp/cl-indent.el (common-lisp-indent-function): Use `eq'
	instead of `eql'.

1999-10-14  Stefan Monnier  <monnier@cs.yale.edu>

	* ange-ftp.el (ange-ftp-make-tmp-name, ange-ftp-del-tmp-name):
	* browse-url.el (browse-url-of-buffer, browse-url-delete-temp-file),
	(browse-url-temp-file-list, browse-url-delete-temp-file-list):
	* ediff-util.el (ediff-make-temp-file):
	* ediff-vers.el (ediff-pcl-cvs-view-revision):
	* emerge.el (emerge-make-temp-file):
	* jka-compr.el (jka-compr-make-temp-name, jka-compr-delete-temp-file):
	* vc.el (vc-update-change-log):
	* mail/mailpost.el (post-mail-send-it):
	* mail/metamail.el (metamail-region):
	* progmodes/cmacexp.el (c-macro-expansion):
	* textmodes/makeinfo.el (makeinfo-region): Use make-temp-file.

1999-10-15  Gerd Moellmann  <gerd@gnu.org>

	* smtpmail.el (smtpmail-via-smtp): Add support for
	automatically appending a domain to RCPT TO: addresses.

1999-10-14  Richard M. Stallman  <rms@gnu.org>

	* dired.el (dired-insert-directory): Insert the amount of
	free space after the total size.
	(dired-free-space-program, dired-free-space-args): New variables.

1999-10-14  Karl Heuer  <kwzh@gnu.org>

	* mail/rmail.el (rmail-pop-password-error): Add new pattern.

1999-10-14  Dave Love  <fx@gnu.org>

	* international/characters.el:
	* international/fontset.el:
	* international/mule-conf.el: Add latin-iso8859-1[45].

	* language/european.el: Add Latin-8, Latin-9.  Modify some doc strings.

	* startup.el (iso-8859-n-locale-regexp): Modify for Latin-[89].
	(command-line): Detect Latin-[89] locales.

1999-10-13  Stefan Monnier  <monnier@cs.yale.edu>

	* international/mule-cmds.el (select-safe-coding-system)
	(leim-list-header): Avoid the use of strings that start with backslash
	newline since lread.c:read1 has a hack to turn those strings into
	integer 0 during the loadup.el process.

	* diff-mode.el (diff-find-file-name): Use `Index:' preferentially.

1999-10-13  Dave Love  <fx@gnu.org>

	* image.el (insert-image): Copy the image spec and add an
	intangible property.

1999-10-13  Stefan Monnier  <monnier@cs.yale.edu>

	* help.el (help-xref-interned): Make it also work on variable-only
	and function-only symbols.
	(help-make-xrefs): Take advantage of the new `help-xref-interned'.
	(help-follow): If the point under mouse is not highlighted, try
	`help-xref-interned' on the pointed-to symbol anyway.

	* info.el (Info-on-current-buffer): New entry point.
	(Info-find-node): Split into two for Info-on-current-buffer to
	hook into it.
	(Info-current-file, Info-set-mode-line, Info-up):
	Info-current-file can now be t.
	(Info-clone-buffer-hook): Function for `clone-buffer'.
	(Info-goto-node, Info-menu, Info-mode-map, Info-mode):
	Make `clone-buffer' available in various ways to the user.

1999-10-12  Stefan Monnier  <monnier@cs.yale.edu>

	* simple.el (shell-command, shell-command-on-region): Use
	make-temp-file.
	(clone-buffer, clone-process, clone-buffer-hook): New functions.

	* subr.el (with-current-buffer): Don't use backquotes to avoid
	bootstrapping problems.

	* loadup.el (load-path): Add subdirs for bootstrapping.
	(docstrings): Ignore errors during bootstrapping.
	(args): New `bootstrap' argument (for use in place of `dump').

1999-10-12  Emmanuel Briot  <briot@gnat.com>

	* ada-stmt.el: Doc-string fixes.

1999-10-12  Gerd Moellmann  <gerd@gnu.org>

	* recentf.el: New file.

	* ps-mode.el: New file.

	* files.el (auto-mode-alist): Add ps-mode for .eps and .ps,
	case insensitive.

1999-10-12  Richard Sharman  <rsharman@pobox.com>

	* sh-script.el: Added support for indenting existing scripts.
	(sh-mode-map): Added new bindings.
	(sh-mode): Updated mode doc-string for new commands, added
	make-local-variable calls, initialize mode-specific variables.
	(sh-indent-line): Renamed to sh-basic-indent-line;  sh-indent-line
	is now a different function.
	(sh-header-marker): Changed docstring.
	(sh-set-shell): Initialize mode-specific variables.
	(sh-case, sh-for, sh-if, sh-indexed-loop, sh-repeat, sh-select)
	(sh-tmp-file, sh-until, sh-until, sh-while, sh-while-getopts):
	Changed these define-skeleton calls to work with user-specified
	indentation settings.
	(sh-basic-indent-line, sh-blink, sh-calculate-indent)
	(sh-check-paren-in-case, sh-check-rule, sh-do-nothing)
	(sh-electric-hash, sh-electric-less, sh-electric-rparen)
	(sh-find-prev-matching, sh-find-prev-switch, sh-get-indent-info)
	(sh-get-indent-var-for-line, sh-get-kw, sh-get-word)
	(sh-goto-match-for-done, sh-goto-matching-case, sh-goto-matching-if)
	(sh-guess-basic-offset, sh-handle-after-case-label)
	(sh-handle-prev-case, sh-handle-prev-case-alt-end, sh-handle-prev-do)
	(sh-handle-prev-done, sh-handle-prev-else, sh-handle-prev-esac)
	(sh-handle-prev-fi, sh-handle-prev-if, sh-handle-prev-open)
	(sh-handle-prev-rc-case, sh-handle-prev-then, sh-handle-this-close)
	(sh-handle-this-do, sh-handle-this-done, sh-handle-this-else)
	(sh-handle-this-esac, sh-handle-this-fi, sh-handle-this-rc-case)
	(sh-handle-this-then, sh-help-string-for-variable)
	(sh-in-comment-or-string, sh-indent-line, sh-learn-buffer-indent)
	(sh-learn-line-indent, sh-load-style, sh-make-vars-local, sh-mark-init)
	(sh-mark-line, sh-mkword-regexpr, sh-mkword-regexp)
	(sh-must-be-shell-mode, sh-must-support-indent, sh-name-style)
	(sh-prev-line, sh-prev-stmt, sh-prev-thing, sh-read-variable)
	(sh-remove-our-text-properties, sh-rescan-buffer)
	(sh-reset-indent-vars-to-global-values, sh-safe-backward-sexp)
	(sh-safe-forward-sexp, sh-save-styles-to-buffer, sh-scan-buffer)
	(sh-scan-case, sh-search-word, sh-set-char-syntax)
	(sh-set-here-doc-region, sh-set-indent, sh-set-var-value)
	(sh-show-indent, sh-this-is-a-continuation, sh-var-value):
	New functions.
	(sh-debug, sh-electric-rparen-needed, sh-here-doc-syntax)
	(sh-indent-supported, sh-kw, sh-kw-alist, sh-kws-for-done)
	(sh-learned-buffer-hook, sh-make-vars-local, sh-regexp-for-done)
	(sh-special-keywords, sh-special-syntax, sh-st-punc, sh-styles-alist)
	(sh-var-list): New variables.

1999-10-12  Dave Pearson  <davep@hagbard.demon.co.uk>

	* quickurl.el (quickurl-list-insert): `count-lines' was returning
	a value one line to high if the cursor wasn't at the start of a
	line. A `beginning-of-line' is now performed before making the
	call to `count-lines'.

1999-10-11  Stefan Monnier  <monnier@cs.yale.edu>

	* diff-mode.el (vc-backend-diff): Get rid of the autoloaded advice.

1999-10-09  Stefan Monnier  <monnier@cs.yale.edu>

	* Makefile (setwins): Abstract out the command to find subdirectories
	and fix it to also ignore subdirectories of CVS (f.ex. CVS/Base).
	(custom-deps, finder-data, autoloads, update-subdirs, updates)
	(autoloads-with-other-emacs): Use it.

	* diff-mode.el: New file.  A mode for viewing/editing context diffs.

1999-10-09  Gerd Moellmann  <gerd@gnu.org>

	* Makefile (bootstrap-compile): New target.  Compile Lisp
	files with ../src/temacs.

1999-10-08  Dave Love  <fx@gnu.org>

	* ange-ftp.el: Require dired when compiling.
	(ange-ftp-normal-login): Allow EFS-style port specification.

1999-10-08  Simon Marshall  <simon@gnu.org>

	* emacs-lisp/regexp-opt.el (regexp-opt-try-suffix): New function.
	(regexp-opt-group): Use it to get common suffixes in STRINGS.
	If STRINGS is nil, return "" rather than nil.

1999-10-08  Gerd Moellmann  <gerd@gnu.org>

	* Makefile (compile): Compile files one by one.  Set load-path to
	current directory and subdirectories when compiling.

1999-10-08  Gerd Moellmann  <gerd@gnu.org>

	* Makefile (EMACSOPT, DONTCOMPILE, EL): New.
	(emacs): Use it everywhere instead of EMACS.
	(compile): New target.  Compile all Lisp files from scratch.
	(recompile): New target.  Recompile lisp directory.
	(autoloads-with-other-emacs): New target.  Build loaddefs.el with
	an Emacs executable not built in the current directory tree.

1999-10-07  Peter Breton  <pbreton@ne.mediaone.net>

	* filecache.el (file-cache-completion-ignore-case): New variable,
	defaulting to the value of completion-ignore-case.
	(file-cache-minibuffer-complete): Use it.
	(file-cache-files-matching, file-cache-files-matching-internal):
	New functions.

1999-10-07  Emmanuel Briot  <briot@gnat.com>

	* ada-xref.el: New file

	* ada-prj.el: New file

	* ada-stmt.el (ada-stmt-add-to-ada-menu): New function

	* ada-stmt.el (ada-subprogram-body): Correctly find the name of the
	subprogram being created.

	* ada-mode.el (ada-get-indent-*, ada-indent-current, ada-goto-*,
	ada-indent-newline-indent): Rewritten to support the new indentation
	scheme

	* ada-mode.el (ada-case-read-exceptions, ada-create-case-exceptions):
	New functions

	* ada-mode.el (ada-fill-comment-paragraph): Add support for the
	justification parameter

	* ada-mode.el (ada-make-body, ada-gen-treat-proc,
	ada-make-subprogram-body): Rewritten to benefit from the gnatstub
	external program

1999-10-07  Dave Love  <fx@gnu.org>

	* bindings.el (bound-and-true-p): New macro.
	(make-mode-line-mouse-sensitive): Don't require easymenu.

1999-10-07  Gerd Moellmann  <gerd@gnu.org>

	* custom.el (defface): Extend documentation for new values of `type'.

	* faces.el (face-spec-set-match-display): Recognize `type' of
	`motif', `lucid', `x-toolkit'.
	(menu): New face.

1999-10-05  Dave Love  <fx@gnu.org>

	* files.el: Recognize temporary crontab files.

	* info.el: Require jka-compr when compiling.
	(Info-suffix-list): Add bzip2 files (non-ms-dos only).

1999-10-04  Dave Love  <fx@gnu.org>

	* cus-start.el: Add x-stretch-cursor, indicate-empty-lines,
	scroll-up-aggressively, scroll-down-aggressively.

	* time.el (display-time-mode): Add autoload cookie.

	* rect.el (delete-extract-rectangle): Doc fix from verna.

	* help-macro.el (three-step-help): Customize.

1999-10-04  Richard M. Stallman  <rms@gnu.org>

	* hexl.el (hexlify-buffer): Move point in proper range
	if it is too large.
	(hexl-after-revert-hook): Update hexl-max-address.
	(hexl-address-to-marker): Doc fix.

1999-10-03  Dave Love  <fx@gnu.org>

	* image.el (defimage): Remove redundant code.  Substitute file in
	image plist.

1999-10-02  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-backend-checkout): Use coding system 'no-conversion
	when doing with-temp-file.

1999-10-01  Dave Love  <fx@gnu.org>

	* cus-edit.el (custom-comment-create): Fill :from and :to slots.

	* help.el: Require view when compiling.
	(view-emacs-FAQ): Use Info version.

1999-09-29  Ken'ichi Handa  <handa@gnu.org>

	* ps-mule.el (ps-mule-font-info-database-ps): Typo fixed
	(normat->normal).  Use correct font names for Korean
	(Munhwa-Regular-KSC-EUC-H and Munhwa-Bold-KSC-EUC-H).

1999-09-29  Kenichi Handa  <handa@etl.go.jp>

	* language/cyrillic.el (cyrillic-koi8-r-decode-table): Map 8-bit
	code not used by KOI8 to the same 8-bit code instead of mapping to
	SPC.
	(cyrillic-alternativnyj-decode-table): Likewise.

1999-09-29  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-imenu-generic-expression): Aew, used to set
	imenu-generic-expression.
	(sql-mode): Use ?_ and ?. instead of 95 and 46 when setting
	font-lock-defaults' SYNTAX-ALIST.  Set imenu-generic-expression,
	imenu-case-fold-search, and imenu-syntax-alist.
	(sql-interactive-mode): Use ?_ and ?. instead of 95 and 46 when
	setting font-lock-defaults' SYNTAX-ALIST.

1999-09-28  Richard M. Stallman  <rms@gnu.org>

	* map-ynp.el (map-y-or-n-p): If we read -1, for end of keyboard
	macro, try again.

1999-09-28  Dave Love  <fx@gnu.org>

	* cus-edit.el (custom-comment): Change widget definition.
	(custom-comment-create, custom-comment-show)
	(custom-comment-invisible-p): Don't use :comment-overlay.
	(custom-comment-hide): New function.
	(custom-variable-set, custom-variable-save)
	(custom-variable-reset-standard, custom-face-set)
	(custom-face-save): Use it.

1999-09-27  Richard M. Stallman  <rms@gnu.org>

	* hexl.el (hexl-mode): Do nothing if already in hexl mode.

1999-09-27  Richard M. Stallman  <rms@gnu.org>

	* faces.el (region): Doc fix.

1999-09-27  Dave Love  <fx@gnu.org>

	* isearch.el (isearch): Add :links in defgroup.
	(isearch-mode-map): Bind mouse-2 to isearch-mouse-yank.
	(isearch-switch-frame-handler): Comment out (unused).
	(isearch-yank-x-selection, isearch-ring-advance-edit): Doc fix.
	(isearch-ring-retreat-edit): Doc fix.
	(isearch-mouse-yank): New command.
	(isearch-last-command-char): Removed.  Callers changed to use
	last-command-char.
	(isearch-char-to-string): Removed.  Callers changed to use
	char-to-string.

1999-09-26  Oleg S. Tihonov  <tihonov@ffke-campus.mipt.ru>

	* ispell.el (ispell-dictionary-alist-6): Don't use "-C"
	option for Russian.

1999-09-25  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-differs-from-default-p): Compare face
	attributes individually.

	* image.el (put-image, insert-image): Add string argument.

1999-09-24  Gerd Moellmann  <gerd@gnu.org>

	* ange-ftp.el (ange-ftp-date-regexp): Make it work for
	LANG=de_DE.iso88591 on HPUX 11.0.

	* dired.el (dired-move-to-filename-regexp): Make it work
	for LANG=de_DE.iso88591 on HPUX 11.0.

1999-09-24  Richard M. Stallman  <rms@gnu.org>

	* info.el (info-initialize): Don't test existence of ALTERNATIVE
	if we know for some other reason it should not be used.

	* emacs-lisp/edebug.el (edebug-outside-current-prefix-arg):
	New variable.
	(edebug-recursive-edit): Save current-prefix-arg there,
	bind it, and set it back at the end.
	(edebug-outside-excursion): Restore and update the outside
	value of current-prefix-arg.
	(edebug-emacs-version-specific): Delete support for Epoch.

1999-09-24  Howard Melman  <howard@silverstream.com>

	* imenu.el (imenu-after-jump-hook): New variable.
	(imenu): Run menu-after-jump-hook.
	(imenu-name-lookup-function): New variable.
	* imenu.el (imenu--in-alist): Use those variables.

1999-09-24  Carsten Dominik  <cd@gnu.org>

	* textmodes/reftex-parse.el (reftex-parse-from-file): Scan for
	multiple thebibliography environments.

	* textmodes/reftex-cite.el (reftex-pop-to-bibtex-entry): Fixed bug
	with recentering window.
	(reftex-extract-bib-entries-from-thebibliography)
	(reftex-offer-bib-menu,reftex-bibtex-selection-callback):
	Deal with multiple thebibliography environments.

	* textmodes/reftex-vars.el (reftex-section-levels):
	Function allowed as cdr.
	(reftex-max-section-depth) New option.

	* textmodes/reftex-vcr.el (reftex-view-cr-cite):
	Deal with multiple thebibliography environments.

1999-09-23  Gerd Moellmann  <gerd@gnu.org>

	* iswitchb.el (iswitchb-complete): Use minibuffer-prompt-end
	instead of point-min in call to delete-region.

1999-09-22  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-backend-checkout): Use with-temp-file when checking
	out into arbitrary file names.

1999-09-19  Ken'ichi Handa  <handa@gnu.org>

	* language/european.el ("Turkish"): New language environment.

1999-09-19  Dave Love  <fx@gnu.org>

	* delim-col.el: New file.

1999-09-17  Richard Stallman  <rms@gnu.org>

	* files.el (after-find-file): When visiting a backup file,
	make it read-only.

	* apropos.el (apropos-symbol-face): Non-nil even for ttys.
	(apropos-keybinding-face, apropos-label-face): Likewise.
	(apropos-property-face, apropos-match-face): Likewise.
	(apropos-label-properties): New variable.
	(apropos-print-doc): Use apropos-label-properties.
	(apropos-print): Set apropos-label-properties.

1999-09-15  Richard Stallman  <rms@gnu.org>

	* winner.el: Use aref instead of sref.

	* whitespace.el (whitespace-mode, whitespace-mode-line): Add defvars.

1999-09-14  Gerd Moellmann  <gerd@gnu.org>

	* lisp-mode.el (eval-last-sexp): Use prin1 instead of print.

1999-09-14  Richard Stallman  <rms@gnu.org>

	* font-lock.el (lisp-font-lock-keywords-1): Recognize an autoload
	cookie, even if followed by a letter.

1999-09-14  Stephen Eglen  <stephen@gnu.org>

	* progmodes/octave-inf.el (inferior-octave-startup): Ensure -i and
	--no-line-editing are passed to Octave by including them here
	rather than storing them in inferior-octave-startup-args.

1999-09-14  Eli Zaretskii  <eliz@gnu.org>

	* textmodes/texinfo.el (texinfo-font-lock-keywords): Add uref,
	command, option, env and sc.

	* subr.el (shell-quote-argument): Quote argument with double
	quotes for ms-dos.

1999-09-14  Richard Stallman  <rms@gnu.org>

	* simple.el (eval-expression-print-level): New variable.
	(eval-expression-print-length): New variable.
	(eval-expression-debug-on-error): New variable.
	(eval-expression): Bind print-level, print-length and
	debug-on-error from those vars.

	* emacs-lisp/lisp-mode.el (eval-defun, eval-last-sexp):
	Bind print-level, print-length and debug-on-error.

1999-09-14  Inge Frick  <inge@nada.kth.se>

	* dired.el (dired-recursive-deletes): New custom variable.
	(dired-re-no-dot): New variable.
	(dired-delete-file): New function deletes files and directories
	recursively.
	(dired-internal-do-deletions): Use `dired-delete-file' to delete files.

	* dired-aux.el (dired-recursive-copies): New custom variable.
	(dired-handle-overwrite): Broke a long line.
	(dired-copy-file): Call `dired-copy-file-recursive' instead of
	`copy-file'.
	(dired-copy-file-recursive): New function.  Copy directories
	recursively.
	(dired-do-create-files): Added support for generalized directory
	target.  How-to function may now return a function.  New fluid
	variable `dired-one-file'.
	(dired-copy-how-to-fn): New variable.
	(dired-do-copy): Bind `dired-recursive-copies' to preserve it.
	Use dired-copy-how-to-fn as how-to argument to dired-do-create-files.
	(dired-do-copy-regexp): No recursive copies.

1999-09-14  Rajesh Vaidheeswarran  <rv@dsmit.com>

	* whitespace.el (whitespace-version): Update version to 2.4

	* whitespace.el: Add customization variables to conditionally test
	any of the five whitespaces, per request from Rune Kleveland
	<runekl@math.uio.no> and Klaus Berndl <berndl@sdm.de>.

	* whitespace.el (whitespace-spacetab-regexp): Fix doc string.

	* whitespace.el (whitespace-modes): Add `change-log-mode' to the
	list of modes to be checked for bogus whitespaces.

	* whitespace.el (whitespace-rescan-timer-time): Update
	documentation.

	* whitespace.el (whitespace-display-unchecked-whitespaces):
	New function to update modeline with untested whitespaces.

	* whitespace.el (whitespace-buffer): Test only whitespaces whose
	checking is turned on, and update modeline using the newly created
	`whitespace-display-unchecked-whitespaces'.

	* whitespace.el (whitespace-cleanup): Cleanup only whitespaces
	whose checking is turned on, and update modeline using the newly
	created `whitespace-display-unchecked-whitespaces'.

	* whitespace.el (whitespace-describe): Update documentation.

	* whitespace.el (whitespace-tickle-timer): Test if
	`whitespace-rescan-timer-time' is non-zero before tickling timer.

1999-09-13  Dave Love  <fx@gnu.org>

	* hideif.el (hide-ifdef-mode): Add autoload cookie.

	* checkdoc.el (checkdoc-display-status-buffer): Avoid Help mode
	for temp buffer.
	(checkdoc-this-string-valid): Don't assume default comment-start.

1999-09-13  Gerd Moellmann  <gerd@gnu.org>

	* rsz-mini.el: Remove code, keep the interface.

1999-09-13  Dave Love  <fx@gnu.org>

	* help.el (help-highlight-p): Doc fix.

	* faces.el (mode-line, header-line, tool-bar): Add :version.
	(highlight, secondary-selection): Add :group.
	(trailing-whitespace): Add :group, :version.

	* wid-edit.el: Remove some compatibility code and checks.
	(widget-specify-field, widget-specify-button): Don't use XEmacs
	properties.
	(widget-overlay-inactive): Change error message.
	(widget-button-pressed-face): New variable.
	(widget-button-click): Use it.
	(widget-documentation-link-add): Specify mouse and button faces.
	(widget-echo-help-mouse, widget-stop-mouse-tracking): Functions
	removed now the functionality is built in.

	* cus-edit.el: Don't define-widget-keywords.
	(multimedia): New group.
	(custom-last): Function removed.
	(custom-quote): Add vectorp case, comment out characterp case.
	(custom-buffer-done-function, custom-raised-buttons): New option.
	(Custom-buffer-done): New function.
	(custom-buffer-create-internal): Obey custom-raised-buttons,
	Custom-buffer-done.
	(custom-button-face): Make it `released-button'.
	(custom-button-pressed-face): Make it `pressed-button'
	(custom-mode-map): Bind "q" to Custom-buffer-done.
	(custom-mode): Deal with raised/pressed buttons.

	Changes from Didier Verna:
	(custom-prompt-variable): Optional third arg makes prompt for a
	comment string.
	(customize-set-value, customize-set-variable,
	customize-save-variable): Optional prefix makes function handle
	variable comments.
	(customize-customized, customize-saved, custom-variable-state-set)
	(custom-variable-set, custom-variable-save, custom-face-state-set)
	(custom-variable-reset-saved, custom-variable-reset-standard)
	(custom-face-set, custom-face-save, custom-face-reset-saved)
	(custom-face-reset-standard, customize-save-customized): Handle
	custom comments.
	(custom-comment-face, custom-comment-tag-face): New face.
	(custom-comment): New widget.
	(custom-comment-create, custom-comment-delete)
	(custom-comment-value-set, custom-comment-show)
	(custom-comment-invisible-p): New functions.
	(custom-variable-value-create, custom-face-value-create): Create a
	comment field widget.
	(custom-variable-menu, custom-face-menu): New entry for custom comment.
	(custom-face-value-create): Remove compatibility code.
	(custom-save-variables, custom-save-faces): Possibly save custom
	comments.

	* cus-face.el (custom-face-attributes): Simplify :underline,
	:overline, :inverse-video cases.  Fix up :box case (probably needs
	more work).

	Change from Didier Verna:
	(custom-set-faces): The arguments can now have a custom comment as
	fourth argument.

	* custom.el: Don't define-widget-keywords.
	Change from Didier Verna:
	(custom-set-variables): The arguments can now have a
	custom comment as fifth element.

1999-09-13  Richard Stallman  <rms@gnu.org>

	* info.el (Info-find-node): Cope better if guesspos is too large.

1999-09-12  Gerd Moellmann  <gerd@gnu.org>

	* iswitchb.el (iswitchb-exhibit): Use buffer-string instead
	of buffer-substring because buffer-string doesn't copy the
	prompt.

	* faces.el (mode-line): Replaces `modeline'.
	(toplevel): Make `modeline' an alias for `mode-line'.

1999-09-12  Gerd Moellmann  <gerd@gnu.org>

	* gs.el: Change `ghostscript' to `postscript' in comment.

1999-09-11  Rob Riepel  <riepel@Stanford.EDU>

	* emulation/tpu-edt.el (tpu-version): New version.
	(tpu-search-overlay, tpu-replace-overlay): New variables.
	(tpu-search-highlight, tpu-toggle-direction): New functions.
	(tpu-lm-replace): Set tpu-replace-overlay.
	(tpu-edt-on, tpu-edt-off): Add/remove tpu-search-highlight post
	command hook.

1999-09-11  Richard Stallman  <rms@gnu.org>

	* isearch.el (isearch-mode-map): Undo previous change.

	* emacs-lisp/lisp-mode.el (eval-last-sexp): If after ?\LETTER,
	use all of that as the sexp.

	* files.el (find-file-noselect): Catch errors in file-expand-wildcards,
	and use the initial argument as file name directly.
	Likewise if nothing matches.

1999-09-11  Ivar Rummelhoff  <ivarru@math.uio.no>

	* winner.el: Major changes.  Avoid changing point and mark.
	Save configurations after they change, not before.

1999-09-10  Keisuke Nishida  <kxn30@po.cwru.edu>

	* emacs-lisp/bytecomp.el (byte-compile-output-docform):
	Bind print-continuous-numbering and print-number-table.

1999-09-10  Dave Love  <fx@gnu.org>

	* bindings.el (debug-ignored-errors): Restore BBDB stuff.

1999-09-09  Richard Stallman  <rms@gnu.org>

	* whitespace.el: Finish making it fit Emacs conventions.
	Add autoloads.

1999-09-09  Eli Zaretskii  <eliz@is.elta.co.il>

	* generic-x.el (bat-generic-mode): "::"-style comments don't
	need to begin with "-".  Fix the font-lock definitions of ON/OFF
	after BREAK/VERIFY.  Remove built-in commands like CALL and ECHO
	from the list of keywords.  Add DO to the list of keywords.

1999-09-09  Dave Love  <fx@gnu.org>

	* emacs-lisp/byte-opt.el (byte-optimize-backward-char):
	(byte-optimize-backward-word): New optimizations.
	(side-effect-free-fns, side-effect-and-error-free-fns): Add
	entries.

1999-09-09  Gerd Moellmann  <gerd@gnu.org>

	* image.el (put-image): Remove optional buffer parameter.

	* faces.el (face-italic-p): Return t only for values `italic'
	and `oblique'.

	* mouse.el (mouse-drag-mode-line-1): Extension of former
	mouse-drag-mode-line that also drags the header line.
	(mouse-drag-mode-line): Call it.
	(mouse-drag-header-line): New.
	(toplevel): Bind down-mouse-1 on header lines to
	mouse-drage-header-line.

1999-09-08  Gerd Moellmann  <gerd@gnu.org>

	* bindings.el (mode-line-unbury-buffer): Use aref instead of sref.
	(make-mode-line-mouse-sensitive): Replace `top-line' by
	`header-line'.

1998-09-08  Michael Ernst  <mernst@alum.mit.edu>

	* help.el (describe-function-1): Don't return empty string for keymaps.

	* fill.el (fill-region-as-paragraph, canonically-space-region):
	Respect colon-double-space at end of line.

1999-09-08  Stephen Gildea  <gildea@stop.mail-abuse.org>

	* files.el (backup-by-copying-when-privileged-mismatch): New variable.
	(backup-buffer): Use it.

1999-09-08  Peter Breton  <pbreton@ne.mediaone.net>

	* generic-x.el (generic-define-unix-modes): Added new modes:
	inetd-conf-generic-mode, etc-services-generic-mode,
	etc-passwd-generic-mode.  These are all defined for Unix by default.
	(apache-generic-mode): Use an imenu-generic-expression to list
	Configuration keywords.
	(samba-generic-mode): Use both ; and # as comment characters.
	(samba-generic-mode): Font-lock expressions now highlight name
	value pairs.
	(bat-generic-mode): Keywords are now case-insensitive through
	font-lock-defaults setting.
	(java-properties-generic-mode): Supports both ! and # as comment
	characters.
	(java-properties-generic-mode): Added an imenu-generic-expression
	(java-properties-generic-mode): Reworked to support the various
	different ways to separate name and value (viz, '=', ':' and
	whitespace).
	(show-tabs-generic-mode): Added this new generic-mode.

1999-09-08  Richard Stallman  <rms@gnu.org>

	* progmodes/inf-lisp.el: Moved from top directory.

	* tar-mode.el (tar-header-block-tokenize):
	Use `when' instead of `and'.  Fix some clobbered text.

	* gud.el (gud-make-debug-menu): Make a child for the
	local menu, for its menu bar, and the debug menu.
	(gdb, sdb, dbx, xdb, perldb, pdb, jdb):
	Use the history in the simple way.

1999-09-07  Kenichi Handa  <handa@etl.go.jp>

	* language/korea-util.el (default-korean-keyboard): Initialize it
	according to the environment variable HANGUL_KEYBOARD_TYPE.

1999-09-07  Richard Stallman  <rms@gnu.org>

	* subr.el (make-temp-file): New function.

1999-09-07  Stefan Monnier  <monnier@cs.yale.edu>

	* font-lock.el (font-lock-multiline): New text property contains
	a boolean to indicate if the char is part of a multiline match.
	(font-lock-default-fontify-region): Extend the region appropriately
	for multiline keywords.
	(font-lock-default-unfontify-region): Also remove the new
	font-lock-multiline text property.
	(font-lock-fontify-anchored-keywords): Mark multiline anchored matches.
	(font-lock-fontify-keywords-region): Mark multiline regexp matches.

1999-09-07  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* diary-lib.el (list-diary-entries): Make sure two-digit years
	have leading zeros.

1999-09-07  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-set-after-frame-default): Initialize some
	attributes of some faces from frame parameters.

	* faces.el (scroll-bar, border, cursor, mouse): New faces.

1999-09-07  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (fringe): Replaces face `margin'.

1999-09-07  Dave Love  <fx@gnu.org>

	* tar-mode.el (tar-header-block-tokenize): Bind linkname.

1999-09-07  Richard Stallman  <rms@gnu.org>

	* subr.el (push): Doc fix.

1999-09-06  Richard Stallman  <rms@gnu.org>

	* vc.el (vc-annotate-display): Use < 69 not < 70
	to distinguish 20YY from 19YY.

	* timezone.el (timezone-parse-date): Use < 69 not < 70
	to distinguish 20YY from 19YY.

	* tar-mode.el (tar-extract): Don't assume buffer is visiting a file.

1999-09-07  Dave Pearson  <davep@hagbard.demon.co.uk>

	* quickurl.el (quickurl-list-focused-line): Removed.
	(quickurl-list-insert): Now works out the focused line using
	`count-lines' instead of using `quickurl-list-focused-line'.

1999-09-06  Richard Stallman  <rms@gnu.org>

	* mail/rmail.el (rmail-retry-failure): Unconditionally move
	to beginning of message.

1999-09-06  Dave Love  <fx@gnu.org>

	* isearch.el (isearch-mode-map): Add mouse-2.

	* mail/rmail.el (rmail-read-password): Deleted.
	(rmail-get-pop-password): Use read-password.

	* quickurl.el: Don't conditionally define caddr.
	(quickurl-url-comment): Use nth, not caddr in function and
	defsetf.

1999-09-06  Richard Stallman  <rms@gnu.org>

	* auto-show.el: Doc fixes.

1999-09-06  Stephen Eglen  <stephen@gnu.org>

	* progmodes/octave-inf.el (inferior-octave-startup-args): Add
	--no-line-editing so that TABs in source files are not interpreted
	as completion requests.

1999-09-06  Gerd Moellmann  <gerd@gnu.org>

	* hscroll.el, auto-show.el: Remove all code, keep the public
	interface as no-ops.

	* faces.el (face-bold-p): Don't return t if face has lighter
	weight than normal.

1999-09-06  Eli Zaretskii  <eliz@gnu.org>

	* startup.el (command-line): Make small-temporary-file-directory
	be nil except on ms-dos.

	* files.el (small-temporary-file-directory): Ditto.  Also doc fix.

	* progmodes/sh-script.el (sh-tmp-file): For sh, use $TMPDIR if it
	is defined.

	* dired.el (dired-re-dir, dired-re-sym): Don't match DOS drive
	letters with a colon after d or l.

1999-09-06  Dave Love  <fx@gnu.org>

	* emacs-lisp/byte-opt.el (byte-boolean-vars): Removed.  (Now primitive.)

1999-09-05  Richard Stallman  <rms@gnu.org>

	* vc.el (vc-annotate-display): Treat 2-digit years under 70 as 20YY.

	* textmodes/paragraphs.el (backward-kill-sentence):
	Don't test minibuffer-prompt-end here.
	(forward-sentence): Do handle it here.
	(backward-kill-paragraph): Don't test it here.
	(forward-paragraph): Handle it here.

	* mouse.el (font-menu-add-default): Simplify code.

1999-09-05  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (header-line): Renamed from `top-line'.

1999-09-05  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (tool-bar): Change face `toolbar' to `tool-bar'.

1999-09-04  Richard Stallman  <rms@gnu.org>

	* whitespace.el: New file.

1999-09-04  Dave Love  <fx@gnu.org>

	* paths.el: Make some doc strings obey the make-docfile convention.

	* bindings.el: Likewise.
	(debug-ignored-errors): Remove BBDB ones.

1999-09-03  Richard Stallman  <rms@gnu.org>

	* mail/mh-comp.el (mh-forward): Get new subject line from the original,
	not from the draft to forward.

	* emacs-lisp/autoload.el (make-autoload): Handle defun* like defun.

1999-09-03  Dave Love  <fx@gnu.org>

	* double.el (double-mode): Customize the variable.

1999-09-03  Kenichi Handa  <handa@etl.go.jp>

	* international/characters.el: Delete duplicated code.

1999-09-02  Richard Stallman  <rms@gnu.org>

	* indent.el (indent-relative): Doc fix.

	* quickurl.el (quickurl): Doc fix.

1999-09-02  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (margin): Change background to "gray" for mono (this is
	drawn with a stipple pattern).

1999-09-02  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (next-history-element): Use minibuffer-prompt-end once
	again.  Remove test for minibuffer-prompt-in-buffer.

1999-09-02  Eli Zaretskii  <eliz@gnu.org>

	* files.el (small-temporary-file-directory): New variable.

	* startup.el (command-line): Compute the value of
	small-temporary-file-directory.

	* ediff-init.el (ediff-temp-file-prefix): Use
	small-temporary-file-directory if non-nil.

	* vc.el (vc-update-change-log): Likewise.

	* progmodes/cmacexp.el (c-macro-expansion): Likewise.

	* simple.el (shell-command, shell-command-on-region): Use
	make-temp-name properly.  Use small-temporary-file-directory if
	non-nil, otherwise temporary-file-directory, to generate temporary
	files.

	* dos-w32.el (direct-print-region-helper): Use
	temporary-file-directory.  (From Stefan Monnier.)

1999-09-02  Richard Stallman  <rms@gnu.org>

	* progmodes/asm-mode.el (asm-mode): Set comment-start properly
	from asm-comment-char.
	(asm-font-lock-keywords): Recognize instruction width suffixes.

1999-09-01  Richard Stallman  <rms@gnu.org>

	* play/fortune.el: New file.

1999-08-31  Dave Love  <fx@gnu.org>

	* help.el (help-make-xrefs): Don't lose on non-empty blank line
	after key table.

	* emacs-lisp/byte-opt.el (byte-boolean-vars): Add several w32 and
	redisplay variables.

	* subr.el (push): Fix typo.

1999-08-30  Kevin Blake  <kblake@ticnet.com>

	* emacs-lisp/ring.el: Many doc fixes.
	(ring-size, ring-copy): New functions.

1999-08-29  Richard Stallman  <rms@gnu.org>

	* progmodes/etags.el (tags-loop-continue):
	After tags-loop-operate returns, force skip to next file.

	* mail/mail-extr.el (mail-extr-all-letters-but-separators)
	(mail-extr-first-letters, mail-extr-last-letters):
	Use character classes [:alpha:] and [:alnum:].

	* subr.el (push, pop): New macros.

	* progmodes/compile.el (compilation-error-regexp-alist):
	New item for SGI IRIX MipsPro compilers.

	* speedbar.el (speedbar-directory-buttons): Recognize
	device names when checking for file names.

	* array.el (array-reconfigure-rows): Use generate-new-buffer.

	* emacs-lisp/lisp-mode.el (eval-defun): Expand macros,
	and specially handle defvar inside their expansions.
	(eval-defun-1): New subroutine.

	* progmodes/compile.el (compilation-error-regexp-alist):
	Fix the Perl -w entry to allow period after line number.
	Don't allow newlines in file name, but allow them after line number
	for Perl debugging traces.

	* which-func.el (which-func-cleanup-function): New variable.
	(which-function): Call that function.

	* emacs-lisp/find-func.el (find-function-regexp): Allow a ) or (
	to end a function name.

	* informat.el (Info-tagify): Don't insert more than one newline
	before the tag table.

1999-08-29  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/bibtex.el (bibtex-mode): Use with-temp-buffer rather
	than make-temp-name, use match-string-no-properties, and eliminate
	a quadratic behavior when building bibtex-strings.

1999-08-29  Alex Schroeder  <alex@gnu.org>

	* comint.el (comint-input-ring-separator): New variable.
	(comint-read-input-ring): Doc change; use
	comint-input-ring-separator when reading file.
	(comint-write-input-ring): Use
	comint-input-ring-separator when writing file.

1999-08-29  Marc Girod  <girod@shire.ntc.nokia.com>

	* informat.el (Info-tagify): Start by widening.
	Match node headers that don't list the file name,
	and more kinds of page separations.
	Strip properties during tagification.
	Use start of node header line as tag's position.
	Fix the "done" message.

	(Info-validate): Save and restore match data around narrowing down.

1999-08-28  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/easy-mmode.el (easy-mmode-define-minor-mode):
	On repeated call, override previous values put into
	minor-mode-map-alist and minor-mode-alist.

1999-08-28  Michael Ernst  <mernst@alum.mit.edu>

	* dired-x.el (dired-guess-shell-alist-default): Support bzip2 format.

1999-08-27  Andreas Schwab  <schwab@gnu.org>

	* vc.el (vc-backend-merge-news): Fix regexp to also match P marker
	from cvs update.

1999-08-27  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* calendar/calendar.el (calendar-move-hook): New hook.

	* calendar/cal-move.el: Call the new hook in every movement function.

	* calendar/calendar.el (calendar-goto-astro-day-number): Autoload
	the right function name.

1999-08-26  Stephen Gildea  <gildea@stop.mail-abuse.org>

	* time-stamp.el: Put quote-backquote around all symbol names
	in doc strings, for mousing.
	(time-stamp): Support multi-line patterns.
	(time-stamp-inserts-lines): New variable.
	(time-stamp-count): New variable.
	(time-stamp-string-preprocess): Fixed bug where "%%a" becomes
	"Thu" instead of "%a".

1999-08-25  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (kill-word): Undo previous change.

1999-08-25  Gerd Moellmann  <gerd@gnu.org>

	* jit-lock.el (jit-lock-function): Extend the fontified range
	to the beginning of the line containing the range start and
	the beginning of the line following the range end.

1999-08-24  Dave Love  <fx@gnu.org>

	* timezone.el: Move provide to end.
	(timezone-parse-date): Simplify somewhat.  Assume 2-digit years
	<70 are 2000+.
	(timezone-parse-time): Simplify somewhat.

1999-08-24  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (margin): Renamed from bitmap-area.

1999-08-24  Alex Schroeder  <alex@gnu.org>

	* sql.el: Doc changes.
	(sql-sybase): Use sql-server instead of sql-database.

1999-08-23  Dave Love  <fx@gnu.org>

	* rect.el: Add/fix various doc strings.  Add `*' to all the
	interactive specs.

1999-08-21  Gerd Moellmann  <gerd@gnu.org>

	* jit-lock.el (jit-lock-function): Use line-beginning-position.
	Don't unwind-protect font-lock-fontify-region.

	* paragraphs.el (backward-kill-paragraph): Don't move
	point into mini-buffer prompt.
	(backward-kill-sentence): Ditto.

	* simple.el (next-history-element): Use minibuffer-prompt-end.
	Remove test for minibuffer-prompt-in-buffer.
	(kill-word): Don't move point into mini-buffer prompt.

1999-08-21  Dave Love  <fx@gnu.org>

	* Makefile: Exclude CVS dirs like RCS.

1999-08-19  Dave Love  <fx@gnu.org>

	* tooltip.el (tooltip-mode): Customize this, per convention.
	(tooltip-active): Option deleted.

	* font-lock.el (global-font-lock-mode): Autoload.  Add :initialize.

	* hanoi.el, page-ext.el: Declare dynamic vars.

	* term.el: Avoid ange-ftp related compilation warnings.

1999-08-18  Gerd Moellmann  <gerd@gnu.org>

	* font-lock.el (font-lock-support-mode): Make `jit-lock-mode'
	the default so that beginners can benefit from it without
	searching in manuals.

1999-08-18  Ray Blaak  <blaak@gnu.org>

	* progmodes/delphi.el: Consider assembly sections as blocks, to
	indent them better. Make auto-indent on newline optional.

1999-08-17  Gerd Moellmann  <gerd@gnu.org>

	* bindings.el (mode-line-modified): Look up key binding for C-x
	C-q.  If it's bound call that binding, otherwise call
	toggle-read-only.

1999-08-17  Dave Love  <fx@gnu.org>

	* info.el (info): Doc fix.

	* finder.el (finder-known-keywords): Add `multimedia'.

	* apropos.el: Don't capitalize custom group name.

	* info-look.el: Remove compatibility code.
	(info-lookup-guess-default*): DTRT for point at start of symbol.
	(info-complete): Don't lose with point not at end of symbol.

1999-08-16  Gerd Moellmann  <gerd@gnu.org>

	* term.el (toplevel): Make face `term-default' an empty face.
	The code relied on the fact that Emacs ignored invalid faces in
	face text properties in 20.4.

1999-08-16  Richard M. Stallman  <rms@gnu.org>

	* subr.el (point-at-eol, point-at-bol): New aliases.

	* simple.el: Functions reordered.

	* rect.el (delete-rectangle-line): Use line-end-position.

1999-08-16  Karl Heuer  <kwzh@gnu.org>

	* subr.el (assoc-ignore-case, assoc-ignore-representation): Moved
	here from simple.el.

1999-08-16  Dave Love  <fx@gnu.org>

	* mouse.el: Provide `mldrag' for compatibility.
	(mldrag-drag-mode-line, mldrag-drag-vertical-line): New aliases,
	marked obsolete.

	* mldrag.el: Removed since the features are in mouse.el.

	* jka-compr.el (auto-compression-mode): New variable for
	customization.

	* bindings.el (mode-line-mule-info): Doc fix.

	* msb.el (msb--choose-file-menu): Use `completion-ignore-case' in
	name comparisons.

	* files.el (interpreter-mode-alist): Add make, guile, clisp.
	(find-file): Doc fix.

1999-08-16  Carsten Dominik  <cd@gnu.org>

	* textmodes/reftex.el: Most of the code moved to other files.
	* textmodes/reftex-auc.el: New file, split out from reftex.el.
	* textmodes/reftex-cite.el: New file, split out from reftex.el.
	* textmodes/reftex-global.el: New file, split out from reftex.el.
	* textmodes/reftex-index.el: New file, split out from reftex.el.
	* textmodes/reftex-parse.el: New file, split out from reftex.el.
	* textmodes/reftex-ref.el: New file, split out from reftex.el.
	* textmodes/reftex-sel.el: New file, split out from reftex.el.
	* textmodes/reftex-toc.el: New file, split out from reftex.el.
	* textmodes/reftex-vars.el: New file, split out from reftex.el.
	* textmodes/reftex-vcr.el: New file, split out from reftex.el.

1999-08-16  Carsten Dominik  <cd@gnu.org>

	* textmodes/reftex.el (reftex-pop-to-bibtex-entry): Fixed
	conflict with pop-up-frames.
	(reftex-special-environment-parsers): New constant.
	(reftex-label-alist): car of an entry can also be a function.
	(reftex-what-special-env): Cew function.
	(reftex-label-location): Call `reftex-what-special-env'.
	(reftex-compile-variables): Check for symbol in `reftex-label-alist'.
	(reftex-what-environment): Fixed bug with stacked environments of
	same kind (e.g. enumerate).
	(reftex-process-string): Preserve default directory.
	(reftex-label-alist-builtin): Changed prefixes of endnote and footnote.
	Also the magic words.
	(reftex-reference): Interprete new option `reftex-fref-is-default'.
	(reftex-replace-prefix-escapes): Interprete new `%S' format.
	(reftex-toc-mouse-view-line): Command removed (had no binding).
	(reftex-everything-regexp): New function.
	(reftex-nearest-match): Made better.
	(reftex-toc-find-section): Use new version of `reftex-nearest-match'.
	(reftex-insert-docstruct): Adapted to work with the index stuff.
	(reftex-parse-from-file): Find index entries as well.
	(reftex-toc-toggle-index): New function
	(reftex-toc-map): `i' is now used to togle the index, File
	boundaries has been moved to `F'.
	(reftex-select-label-map): Toggling display of file boundaries is
	now on the `F' key, for consistency with `reftex-toc-map'.
	(reftex-erase-all-selection-and-index-buffers): Renamed from
	`reftex-erase-all-selection-buffer'.  Now also kills the index
	buffers.
	(reftex-viewing-cross-references): Customization group renamed
	from reftex-viewing-cross-references-and-citations.
	(reftex-index-macro-regexp, reftex-find-index-entry-regexp-format):
	New variables.
	(reftex-macros-with-index): New variable.
	(reftex-add-index-macros): New function.
	(reftex-renumber-simple-labels, reftex-translate): Allow for
	multiple labels in a single ref command.
	(reftex-index-support): New customization group.
	(reftex-support-index, reftex-index-special-chars)
	(reftex-index-macros, reftex-index-default-macro)
	(reftex-index-default-tag, reftex-index-math-format)
	(reftex-index-section-letters, reftex-index-include-context)
	(reftex-index-follow-mode, reftex-index-header-face)
	(reftex-index-section-face, reftex-index-tag-face)
	(reftex-index-face): New options
	(reftex-index-map, reftex-index-menu, reftex-last-index-file)
	(reftex-index-tag, reftex-index-return-marker)
	(reftex-index-restriction-indicator, reftex-index-restriction-data)
	(reftex-index-macro-regexp, reftex-index-level-re)
	(reftex-index-key-end-re, reftex-find-index-entry-regexp-format)
	(reftex-everything-regexp-no-index, reftex-index-re)
	(reftex-macros-with-index, reftex-index-macro-alist): New variables.
	(reftex-index-help, reftex-index-macros-builtin,
	(reftex-key-to-index-macro-alist, reftex-query-index-macro-prompt)
	(reftex-query-index-macro-help): New constants
	(reftex-index-selection-or-word, reftex-index)
	(reftex-default-index, reftex-update-default-index)
	(reftex-index-complete-tag, reftex-index-select-tag)
	(reftex-index-complete-key, reftex-index-update-taglist)
	(reftex-index-globally, reftex-index-mode, reftex-index-show-entry)
	(reftex-display-index, reftex-insert-index)
	(reftex-index-insert-new-letter, reftex-get-restriction)
	(reftex-index-pre-command-hook, reftex-index-post-command-hook)
	(reftex-index-show-help, reftex-index-next, reftex-index-previous)
	(reftex-index-toggle-follow, reftex-index-toggle-context)
	(reftex-index-view-entry, reftex-index-goto-entry-and-hide)
	(reftex-index-goto-entry, reftex-index-mouse-goto-line-and-hide)
	(reftex-index-quit, reftex-index-quit-and-kill)
	(reftex-index-goto-toc, reftex-index-rescan, reftex-index-Rescan)
	(reftex-index-revert, reftex-index-switch-index-tag)
	(reftex-index-restrict-to-section, reftex-index-widen)
	(reftex-index-restriction-forward)
	(reftex-index-restriction-backward, reftex-index-visit-location)
	(reftex-index-analyze-entry, reftex-index-globalize)
	(reftex-index-edit, reftex-index-toggle-range-beginning)
	(reftex-index-toggle-range-end, reftex-index-edit-key)
	(reftex-index-edit-attribute, reftex-index-edit-visual)
	(reftex-index-edit-part, reftex-index-level-down)
	(reftex-index-level-up, reftex-index-kill, reftex-index-undo)
	(reftex-index-change-entry, reftex-index-goto-letter)
	(reftex-add-index-macros, reftex-ensure-index-support)
	(reftex-index-info-safe, reftex-index-info): New functions.

1999-08-15  Richard M. Stallman  <rms@gnu.org>

	* paren.el (show-paren-mode): Support making show-paren-mode
	a buffer-local variable.  Don't check for a window system.
	(show-paren-function): Check whether show-paren-function is
	enabled in current buffer; do the right thing if not.
	Don't check for a window system.
	(show-paren-mode): Make it a user variable.

	* add-log.el (add-log-current-defun): Exclude all trailing whitespace.
	Handle `enum' like `struct'.

	* server.el (server-process-filter): If a client visits no buffers,
	close it immediately before recording it.

	* mail/mail-utils.el (mail-unquote-printable): Make it autoload.
	Optimize by calling concat just once.  Handle =\n sequence.
	(mail-unquote-printable-region): New command.
	(mail-quote-printable): Make it autoload.

1999-08-15  Karl Heuer  <kwzh@gnu.org>

	* progmodes/octave-mod.el (octave-maintainer-address): Use gnu.org.

1999-08-15  Yoshiki Hayashi  <t90553@mail.ecc.u-tokyo.ac.jp>

	* lisp/texinfmt.el: Handle @ifnottex.

1999-08-15  Eli Zaretskii  <eliz@gnu.org>

	* frame.el (blink-cursor): Don't turn on cursor blinking for
	ms-dos.

	* faces.el (face-valid-attribute-values): Look in
	x-bitmap-file-path only for x and w32 window systems.

	* term/pc-win.el (x-list-fonts): Return "ms-dos", not "default".
	Do that if width is nil as well.
	(x-display-mm-height, x-display-mm-width): Update values.
	(x-colors): Compute the list from msdos-color-values.
	(x-select-enable-clipboard): Doc fix.
	(x-frob-font-weight, x-font-family-list): New functions.

1999-08-15  Toby Speight  <Toby.Speight@streapadair.freeserve.co.uk>

	* window.el (shrink-window-if-larger-than-buffer): Don't try to
	back up from beginning of buffer.

1999-08-13  Karl Heuer  <kwzh@gnu.org>

	* emacs-lisp/advice.el (ad-special-forms): Use track-mouse iff bound.

1999-08-13  Alakazam Petrofsky  <Alakazam@Petrofsky.Berkeley.CA.US>

	* play/hanoi.el: Mostly rewritten.  Customized.  To support an s2G
	doomsday clock, speed control is added and changes are made to
	allow large numbers of rings: rings now show the whole ring
	number, not just the last digit; consecutive rings are allowed to
	be the same size when necessary to fit all the rings in the
	window; and poles can be oriented horizontally.  Face support is
	thrown in gratuitously.
	(hanoi): Changed default number of rings back to 3.
	(hanoi-unix, hanoi-unix-64): New commands
	(hanoi-horizontal-flag, hanoi-move-period, hanoi-use-faces,
	hanoi-pole-face, hanoi-base-face, hanoi-even-ring-face,
	hanoi-odd-ring-face): New variables.
	(hanoi-internal, hanoi-current-time-float, hanoi-put-face,
	hanoi-n, hanoi-insert-ring, hanoi-goto-char, hanoi-sit-for,
	hanoi-ring-to-pos, hanoi-pos-on-tower-p): New functions.
	(hanoi-0): Renamed from hanoi0, for symmetry with hanoi-n.
	(hanoi-topos, hanoi-draw-ring): Removed.

1999-08-12  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-valid-attribute-values): Return an alist for
	families on ttys.
	(face-read-integer): Handle unspecified face attributes.  Add
	completion for `unspecified'.
	(read-face-attribute): Handle unspecified font attributes.
	(face-valid-attribute-values): Add `unspecified' to lists so that
	it can be chosen via completion.
	(face-read-string): Don't recognize "none" as input.

1999-08-10  Dave Love  <fx@gnu.org>

	* sendmail.el (mail-specify-envelope-from): Fix quoting of doc
	string.

	* sun-curs.el: Require sun-fns.

1999-08-10  Dave Love  <fx@gnu.org>

	* autorevert.el (auto-revert-mode): Add autoload cookie.

	* hscroll.el, auto-show.el: Files deleted -- we have built-in
	hscroll.

	* simple.el (hscroll-step, hscroll-point-visible)
	(hscroll-window-column): Remove now we have the mentioned real
	horizontal autoscrolling.

1999-08-10  Richard M. Stallman  <rms@gnu.org>

	* mail/sendmail.el (sendmail-send-it): Let mail-specify-envelope-from
	control use of -f option.
	(mail-specify-envelope-from): New variable.
	(mail-from-style): Doc fix.

	* emacs-lisp/easymenu.el (easy-menu-get-map-look-for-name): New fn.
	(easy-menu-get-map): New arg TO-MODIFY helps choose
	between local and global maps.
	(easy-menu-add-item): Pass TO-MODIFY arg to easy-menu-get-map.
	(easy-menu-change): Doc fix.

	* info-look.el (info-lookup-guess-c-symbol): Use skip-syntax-backward.
	(info-lookup-guess-default): Simplified and cleaned up.
	(info-lookup-guess-default*): Preserve point.

	* view.el (view-mode-disable): If buffer-read-only is nil,
	don't change it.

	* files.el (after-find-file): Disable View mode if buffer is no
	longer read-only.

	* view.el (view-mode-enable, view-mode-disable):
	Call force-mode-line-update.

1999-08-10  Karl Heuer  <kwzh@gnu.org>

	* language/european.el, emacs-lisp/byte-opt.el: Fix provide call.
	* array.el, play/landmark.el, international/latin-3.el: Likewise.
	* sun-curs.el, term/sun-mouse.el, progmodes/simula.el: Likewise.

1999-08-10  Alex Schroeder  <asc@bsiag.com>

	* ansi-color.el (ansi-color-to-text-properties): Added New state 5
	to prevent m-eating-bug.

1999-08-10  Eli Zaretskii  <eliz@gnu.org>

	* term/pc-win.el (msdos-bg-mode): Remove.  Call
	frame-set-background-mode instead.  All callers changed.
	(msdos-face-setup): Don't force color display parameter, it is set
	by frame-set-background-mode.
	(make-msdos-frame): Call x-handle-reverse-video and
	face-set-after-frame-default.  Delete frame if creation failed.

	* faces.el (face-set-after-frame-default): Don't call
	make-face-x-resource-internal for the pc window-system.

1999-08-10  Dave Love  <fx@melange.gnu.org>

	* emacs-lisp/advice.el (ad-make-single-advice-docstring): Treat
	case with no docstring specially.

1999-08-09  Eli Zaretskii  <eliz@gnu.org>

	* complete.el (PC-do-completion): If completing on file name,
	reproduce str by concatenating its directory and basename parts.

1999-08-07  Dave Love  <fx@gnu.org>

	* man.el (Man-softhyphen-to-minus): Revert previous change.  Avoid
	unibyte to multibyte conversion of search-forward (from Handa),
	but avoid the replacement if the language is Latin-N.

1999-08-06  Richard Stallman  <rms@gnu.org>

	* emacs-lisp/eval-reg.el (elisp-eval-buffer): Handle all 5 args
	of eval-buffer.

	* international/mule.el (load-with-code-conversion):
	Pass t to eval-buffer for DO-ALLOW-PRINT.

1999-08-06  Geoff Voelker  <voelker@cs.washington.edu>

	* ls-lisp.el (ls-lisp-delete-matching): List argument is now alist
	of filenames and attributes.
	(ls-lisp-insert-directory): Use directory-files-and-attributes
	for speed.

1999-08-05  Dave Love  <fx@gnu.org>

	* auto-show.el (auto-show-mode): Fix :set.

	* widget.el (define-widget-keywords): Make dummy definition and
	comment-out its use.

1999-08-04  Richard Stallman  <rms@gnu.org>

	* progmodes/tcl.el: Customized.

	* sql.el (sql-accumulate-and-indent): Instead of testing
	whether this is Emacs 20 before calling comint-accumulate,
	test whether comint-accumulate is defined.

1999-08-04  Dave Love  <fx@gnu.org>

	* sgml-mode.el: Require outline when compiling.
	(sgml-mode-hook, html-mode-hook): Customize.
	(sgml-validate-command): Fix :version.
	(html-autoview-mode): Doc fix.

	* man.el (Man-softhyphen-to-minus): Fix for multibyte case, do
	nothing in Latin-N environment.

	* info.el (Info-find-node): Call info-initialize here.
	(info): Not here.
	(Info-file-list-for-emacs): Add message, dired-x, c, viper.

1999-08-04  Richard Stallman  <rms@gnu.org>

	* ansi-color.el: New file.

1999-08-04  Stefan Monnier  <monnier@cs.yale.edu>

	* dired.el (dired-string-replace-match): Return `nil' when no match
	found with global search.

	* ledit.el (ledit-zap-file, ledit-read-file, ledit-compile-file):
	* terminal.el (te-terminfo-directory):
	* mail/mailpost.el (post-mail-send-it):
	* mail/metamail.el (metamail-region):
	* progmodes/ada-mode.el (ada-tmp-directory):
	Use temporary-file-directory.

	* progmodes/compile.el (compilation-parsing-end,compilation-setup)
	(compilation-filter, compilation-forget-errors)
	(compilation-parse-errors): Use a marker instead of an integer for
	`compilation-parsing-end'.

	* progmodes/diff.el (diff-parse-differences):
	Use a marker instead of an integer for `compilation-parsing-end'.
	* textmodes/tex-mode.el (tex-compilation-parse-errors):
	Use a marker instead of an integer for `compilation-parsing-end'.

1999-08-03  Richard Stallman  <rms@gnu.org>

	* buff-menu.el (Buffer-menu-mode-map): Add V for Buffer-menu-View.
	(Buffer-menu-mode): Doc fix.
	(Buffer-menu-view): New command.
	(Buffer-menu-view-other-window): New command.

1999-08-03  Christopher J. Madsen  <chris_madsen@geocities.com>

	* replace.el (query-replace-regexp-eval)
	(replace-eval-replacement, replace-loop-through-replacements)
	(replace-match-string-symbols): New functions.
	(perform-replace): Allow REPLACEMENTS to be (FUNCTION . DATA).
	Use replace-loop-through-replacements.

1999-08-03  Dave Pearson  <davep@hagbard.demon.co.uk>

	* play/5x5.el (5x5-mode-map): Bind C-p, C-n, C-b, C-f.
	(5x5): Doc fix.

1999-08-03  Dave Love  <fx@gnu.org>

	* fortran.el (fortran-indent-new-line): Make it an alias
	for reindent-then-newline-and-indent.

1999-08-03  Didier Verna  <verna@inf.enst.fr>

	* rect.el: All functions rewritten, except when noted above
	their declaration.  Below is a list of interface changes.
	(apply-on-rectangle): New function, mostly replaces
	`operate-on-rectangle'.  All callers changed.
	(move-to-column-force): Pass new second argument to `move-to-column'.
	(kill-rectangle): Added optional prefix arg to fill lines.
	(delete-rectangle): Ditto.
	(delete-whitespace-rectangle): Ditto.
	(delete-extract-rectangle): Ditto.
	(open-rectangle): Ditto.
	(clear-rectangle): Ditto.
	(delete-whitespace-rectangle-line): New function.
	(delete-rectangle-line): Added third arg FILL.
	(delete-extract-rectangle-line): Ditto.
	(open-rectangle-line): Ditto.
	(clear-rectangle-line): Ditto.

1999-08-03  Ray Blaak  <blaak@gnu.org>

	* progmodes/delphi.el: New file.

1999-08-02  Richard Stallman  <rms@gnu.org>

	* textmodes/outline.el (outline-previous-heading): New function.
	(outline-up-heading-all): Use outline-previous-heading.
	(outline-next-heading): Delete definition inserted yesterday.

1999-08-01  Richard Stallman  <rms@gnu.org>

	* textmodes/outline.el (outline-next-heading): New function.
	(outline-up-heading-all): New function.
	(outline-font-lock-level): Using outline-up-heading-all.
	Tell outline-back-to-heading to accept invisible headings.

	* simple.el (shell-command-on-region): EXIT-STATUS can be a string.

	* mail/mh-utils.el (mh-find-path-run): New variable.
	(mh-find-path): Test and set that.
	Set mail-user-agent only the first time this function is run.
	(mail-user-agent): Defvar deleted.

	* info.el (info-initialize): New function.
	(info): Call info-initialize.
	(Info-directory-list): Initialize to nil,
	so info-initialize will set it up for real.

1999-08-01  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* calendar/calendar.el (european-date-diary-pattern): Fix pattern so it
	does not interpret a time as the year in a day-month entry.

	* calendar/diary-lib.el: Change syntax table entry for colon in
	the diary as part of the european-date-diary-pattern fix.

1999-08-01  Eli Zaretskii  <eliz@gnu.org>

	* international/mule.el (set-auto-coding): Allow whitespace before
	and after the "variable: value" pair.

1999-07-30  Ken'ichi Handa  <handa@gnu.org>

	* mail/sendmail.el (sendmail-coding-system): Doc-string fixed.
	(default-sendmail-coding-system): Doc-string fixed.

1999-07-30  Dave Love  <fx@gnu.org>

	* subr.el (assoc-delete-all): New function, renamed from
	frame-delete-all.

	* frame.el: Change comments to doc strings and other doc fixes.
	(frame-delete-all): Moved to subr.el as `assoc-delete-all'.
	Callers changed.
	(set-background-color, set-foreground-color, set-cursor-color)
	(set-mouse-color, set-border-color): Offer completion of colours.
	(cursor): Add :version to defgroup.

	* facemenu.el (list-colors-display): Make it work on ttys.
	(facemenu-read-color): Likewise.

1999-07-30  Richard M. Stallman  <rms@gnu.org>

	* frame.el (frame-notice-user-settings): If background
	color has been changed, update background-mode from it,
	then update faces.

1999-07-30  Wolfgang Rupprecht  <wolfgang@wsrcc.com>

	* net-utils.el (finger): Don't do indirect fingering.

1999-07-30  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* cal-tex.el (cal-tex-cursor-filofax-daily): Add possibility of
	rules.  Add separator at end of holidays.
	(cal-tex-rules): New customizable variable.
	(cal-tex-latexify-list): Add optional parameter to put separator
	at end.

1999-07-30  Bill Richter  <richter@steenrod.math.nwu.edu>

	* textmodes/fill.el (fill-individual-paragraphs): Calculate new
	fill prefix on each line while looping to the end of paragraph.
	End paragraph if it's longer than the existing fill prefix.

	* textmodes/fill.el (fill-context-prefix): Doc fix.

1999-07-30  Dave Love  <fx@gnu.org>

	* font-lock.el (jit-lock): Fix :load, add :version.

1999-07-30  Eli Zaretskii  <eliz@gnu.org>

	* term/pc-win.el (msdos-face-setup): Register standard colors in
	Vface_tty_color_alist.
	(face-color-supported-p, face_color_gray_p): New functions.

	* loadup.el: Don't load scroll-bar unless x-toolkit-scroll-bars-p
	is bound.

	* startup.el (command-line): Don't register default colors for
	MSDOS window-system.

1999-07-29  Dave Love  <fx@gnu.org>

	* f90.el (f90-mode-syntax-table): Change backslash to escape, not
	charquote.

	* lisp-mode.el (eval-defun): Re-written to avoid
	capturing variables.

	* picture.el (picture-beginning-of-line): Don't call
	hscroll-point-visible now we have real autoscrolling.
	(picture-end-of-line, picture-newline, picture-open-line):
	Likewise.

	* international/latin-8.el: New file.
	* international/latin-9.el: New file.

1999-07-28  Dave Love  <fx@gnu.org>

	* mouse.el (x-fixed-font-alist): Add lucidasanstypewriter.

	* msb.el: Require cl only when compiling.
	(msb--home-dir): Deleted.
	(msb--format-title): Use abbreviate-file-name.
	(msb--choose-file-menu): Simplify string comparison.

1999-07-28  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (toolbar): Add face definition for mono displays.

1999-07-27  Richard M. Stallman  <rms@gnu.org>

	* textmodes/fill.el (fill-region-as-paragraph): Fix previous change.

	* frame.el (frame-initialize): When setting frame-initial-frame-alist,
	force copying of default-frame-alist.

1999-07-26  Ken'ichi Handa  <handa@gnu.org>

	* ps-mule.el (ps-mule-begin-job): Fix malformed regexp.

1999-07-26  Richard M. Stallman  <rms@gnu.org>

	* frame.el (set-mouse-color): If new color is nil,
	really respecify the current color.

1999-07-26  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (bitmap-area): Change background of face `bitmap-area'
	to white for mono displays.

1999-07-26  Kenichi Handa  <handa@etl.go.jp>

	* international/ccl.el (ccl-embed-symbol): New function.
	(ccl-program-p): Deleted.  Now it's implemented in C code.
	(ccl-compile-call): Use ccl-embed-symbol to embed a symbol.
	(ccl-compile-translate-character): Likewise.
	(ccl-compile-map-single): Likewise.
	(ccl-compile-multiple-map-function): Likewise.
	(declare-ccl-program): Doc-string modified.
	(check-ccl-program): Check compiled CCL code by ccl-program-p.

1999-07-25  Ken'ichi Handa  <handa@etl.go.jp>

	* textmodes/fill.el (fill-region-as-paragraph): Fix previous change.

1999-07-25  Markus Rost  <rost@gnu.org>

	* cus-edit.el (custom-save-variables, custom-save-faces):
	Sort the entries to make custom-file more readable.

1999-07-25  Richard M. Stallman  <rms@gnu.org>

	* cus-edit.el (custom-save-delete): Avoid error for empty .emacs.

	* emacs-lisp/edebug.el: Delete compatibility code.
	(edebug-next-token-class): If . is followed by a digit,
	return `symbol' for the token class.

	* startup.el (command-line): If we don't find the user's init file,
	set user-init-file to nil.

1999-07-25  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* info-look.el (info-lookup-interactive-arguments): Add optional
	argument query for new choice of help mode.
	(info-lookup-symbol): Use it.
	(info-lookup-file): Ditto.
	(info-lookup): Don't switch to other window, if already in Info
	buffer.

1999-07-23  Dave Love  <fx@gnu.org>

	* fortran.el (fortran-mode-syntax-table): Change `\' to `\'
	syntax.
	(fortran-fontify-string, fortran-match-!-comment): Deleted.
	(fortran-font-lock-syntactic-keywords): New variable.
	(fortran-mode): Use it.
	(fortran-font-lock-keywords-1): Don't do comments.
	(beginning-of-fortran-subprogram, end-of-fortran-subprogram): Save
	match data.

	* textmodes/sgml-mode.el (sgml-validate-command): Use nsgmls.

	* msb.el (msb-menu-bar-update-buffers): Renamed from
	menu-bar-update-buffers.
	(msb-custom-set, msb--toggle-menu-type): Call
	msb-menu-bar-update-buffers.
	(msb-mode): Revise the hook setting.

	* font-lock.el (turn-on-font-lock): Use tty-display-color-p.

1999-07-23  Gerd Moellmann  <gerd@gnu.org>

	* font-lock.el, help.el, simple.el: Re-integrate previously
	described changes that were lost due to errors while checking them
	in.

1999-07-23  Kevin Blake  <kblake@ticnet.com>

	* font-lock.el (lisp-font-lock-keywords-2): Fix regexp.

1999-07-23  Ken'ichi Handa  <handa@etl.go.jp>

	* international/encoded-kb.el
	(encoded-kbd-self-insert-iso2022-7bit): Don't insert the character
	but push it to unread-command-events.
	(encoded-kbd-self-insert-iso2022-8bit): Likewise.
	(encoded-kbd-self-insert-sjis): Likewise.
	(encoded-kbd-self-insert-big5): Likewise.

	* textmodes/fill.el (fill-region-as-paragraph): Avoid backing up
	before left margin and fill-prefix by fill-find-break-point.

1999-07-21  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* info-look.el (info-lookup-setup-mode): Don't give up, if
	info-lookup-make-completions returns an error.
	(info-lookup-maybe-add-help :mode 'latex-mode): Use Info file
	name latex, not latex2e.

1999-07-21  Richard M. Stallman  <rms@gnu.org>

	* replace.el (perform-replace): Turn off case-fold-search
	if FROM-STRING argument has uppercase in it.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* jit-lock.el (jit-lock-after-change): Do it only if jit-lock
	mode is on.  Don't use end of changed text.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* cl-extra.el (cl-make-hash-table): Renamed from make-hash-table.
	(cl-hash-table-p): Renamed from hash-table-p.
	(cl-hash-table-count): Renamed from hash-table-count.
	(maphash): Alias to cl-maphash removed.
	(gethash): Likewise.
	(puthash): Likewise.
	(remhash): Likewise.
	(clrhash): Likewise.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* jit-lock.el (jit-lock-stealth-fontify): Don't call sit-for with
	third arg non-nil.  See comment there why this isn't a good idea.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* jit-lock.el (jit-lock-stealth-fontify): Use with-temp-message.

	* jit-lock.el (jit-lock-stealth-fontify): Widen buffer, and call
	sit-for with 3rd arg non-nil to prevent redisplay.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* image.el (image-type-from-file-header): If file doesn't
	have a directory part, add data-directory.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* tooltip.el (tooltip-gud-tips-p): Set default to nil.
	(tooltip-activate-mouse-motions-if-enabled): Don't activate mouse
	motion handling when tooltip-gud-tips-p is nil.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* tooltip.el (tooltip-mode): Don't use `plusp'.
	(tooltip-active): Use initial value of nil.

	* jit-lock.el (jit-lock-mode): Don't use `plusp'.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* bindings.el (make-mode-line-mouse-sensitive): Add key
	definitions for `top-line'.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (top-line): New face.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* image.el (image-type-regexps): Add regexp for PS files.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (set-face-attribute): Fix wrong handling of frame
	begin equal to t.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* image.el (image-type-regexps): Add PNG format.

1999-07-21  Dave Love  <fx@gnu.org>

	* bindings.el (mode-line-modified): New variable.
	(mode-line-mode-menu-1): Switch to appropriate window before
	showing menu.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-underline): Removed.
	(face-underline-color): Ditto.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-x-resources): Fix typo.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el: Remove handling of `:relief', extend handling of
	`:box'.
	(frame-set-background-mode): Choose new defface specs after
	frame parameters have changed.

	* cus-face.el: Ditto.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* custom.el (defface): Extend documentation to include new
	face attributes.

	* cus-face.el (custom-face-attributes): Add overline,
	strike-through, box.

	* faces.el (face-valid-attribute-values): Handle overline,
	strike-through, box.
	(face-attribute-name-alist): Add pairs for new face attributes.
	(describe-face): Handle new face attributes.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-x-resources): Add overline, strike-through, box.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* enriched.el (enriched-translations): Add `display' and
	"x-display".
	(enriched-handle-display-prop): New.
	(enriched-decode-display-prop): New.

	* format.el (top-level): Give `display' property
	`format-list-atomic-p.
	(format-annotate-single-property-change): Test that property.
	If present, treat list property values like atoms.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* cus-face.el (custom-face-attributes): Use `choice' everywhere
	so that "*" can be entered.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* cus-face.el (custom-face-attributes): Don't use `#''.

1999-07-21  Masatake Yamato  <masata-y@is.aist-nara.ac.jp>

	* cus-face.el (custom-face-attributes): Return underline
	face attribute directly from the second lambda of underline.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* jit-lock.el (jit-lock-stealth-verbose): Set to nil.

	* frame.el (after-setting-font-hooks): New variable.
	(set-frame-font): Run those hooks.

	* jit-lock.el (jit-lock-function): Use font-lock-fontify-region.

	* faces.el (set-face-attribute): Fix doc string.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* cus-face.el (custom-face-attributes): Accept color name.

	* faces.el (face-underline-p): Accept unspecified underlining.
	(face-underline): Ditto.  Fix doc string.

1999-07-21  Masatake Yamato  <masata-y@is.aist-nara.ac.jp>

	* faces.el (face-underline-color): New function.

1999-07-21  Masatake Yamato  <masata-y@is.aist-nara.ac.jp>

	* cus-face.el (custom-face-attributes): Support underline coloring.
	Added slot to choose a color.

	* faces.el (face-underline): New function.
	(face-underline-p): Support underline coloring.
	Return nil only if the underline attribute is 'normal.
	(set-face-underline): New function.
	(face-valid-attribute-values): Support underline coloring.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* image.el (insert-image): Use `display' instead of `glyph'
	as text property name.
	(put-image): Ditto.
	(image-type-from-file-header): Use insert-file-contents-literally.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* easymenu.el (easy-menu-do-add-item): Don't use the empty
	string to indicate separators.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* jit-lock.el (jit-lock-stealth-fontify): Bind message-log-max
	instead of message-log.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (bitmap-area): New face.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* image.el (insert-image): New.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (blink-cursor): Set the symbol's value.
	(show-trailing-whitespace): Change group to font-lock.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* jit-lock.el: New.
	* font-lock.el: Add jit-mode as new support mode.

	* font-lock.el (font-lock-fontify-keywords-region): Stop when
	reaching end instead of letting re-search-forward signal an error.
	(demand-lock-mode): New.
	(font-lock-turn-on-thing-lock): Add demand-lock-mode.
	(font-lock-turn-off-thing-lock): Ditto.
	(font-lock-after-fontify-buffer): Ditto.
	(font-lock-after-unfontify-buffer): Ditto.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* gs.el: New file.

	* startup.el (command-line-1): Activate tooltip mode if
	interactive.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (toolbar): Grey default background.
	(modeline): Ditto.

	* image.el (image-type-regexps): New.
	(image-type-from-file-header): New.
	(create-image): Call it.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* image.el: New file.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* bindings.el (mode-line-format): Replace `mode-name' with
	`(:eval mode-line-mode-name)'.
	(mode-line-mode-name): New.
	(make-mode-line-mouse-sensitive): Don't change default value
	of `mode-name'.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* tooltip.el: New file.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* bindings.el (make-mode-line-mouse-sensitive): Use down-mouse-3
	instead of mouse-3 to pop up menus.
	(mode-line-kill-buffer): Removed.
	(make-mode-line-mouse-sensitive): Pop mouse buffer menu over
	buffer name.
	(mode-line-buffer-menu-1): Removed.

	* startup.el (command-line-1): Call make-mode-line-mouse-sensitive.

	* bindings.el (mode-line-buffer-identification-keymap): New.
	(mode-line-buffer-menu-keymap): New.
	(mode-line-mode-menu-keymap): New.
	(mode-line-unbury-buffer): New.
	(mode-line-other-buffer): New.
	(mode-line-kill-buffer): New.
	(mode-line-buffer-menu-1): New.
	(mode-line-mode-menu-1): New.
	(make-mode-line-mouse-sensitive): New.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* help.el (describe-key-briefly): Handle mode line strings
	with local-map properties.
	(describe-key): Ditto.
	(mode-line-key-binding): New.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* scroll-bar.el (scroll-bar-timer): New.
	(scroll-bar-toolkit-scroll): Start and cancel scroll-bar-timer.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* scroll-bar.el (scroll-bar-toolkit-scroll): Handle `top'
	and `bottom'.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* scroll-bar.el (scroll-bar-toolkit-scroll): New.
	(global): Use different key bindings if using tookit scroll bars.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (modeline): Define mode line face with relief for
	class color, only.
	(toolbar): New face.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (frame-initialize): Set frame-creation-function to
	tty-create-frame-with-faces.

	* faces.el (frame-set-background-mode): Make it work for
	window-system nil.

	* faces.el (tty-create-frame-with-faces): New.
	(face-set-after-frame-default): Make it work for TTY frames.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-valid-attribute-values): Use tty-defined-colors.
	Return a list of one font family for TTYs.  Don't return bitmap
	file paths for TTY frames.

	* faces.el: Add face specs for tty displays to basic faces.

	* font-lock.el (font-lock-comment-face): Add spec for color tty.
	(font-lock-string-face): Ditto.
	(font-lock-keyword-face): Ditto.
	(font-lock-builtin-face): Ditto.
	(font-lock-function-name-face): Ditto.
	(font-lock-variable-name-face): Ditto.
	(font-lock-type-face): Ditto.
	(font-lock-constant-face): Ditto.
	(font-lock-warning-face): Ditto.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (command-line): Register default tty colors.

	* faces.el (face-spec-set-match-display): Recognize `type tty'.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (modeline): For X frames, use a modeline with relief.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (frame-update-faces): Copied from 20.2.
	(frame-update-face-colors): Ditto.  Code removed that isn't
	applicable in the new face implementation.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (show-trailing-whitespace): New.

	* faces.el (trailing-whitespace): New basic face.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* cus-face.el (custom-facep): Always define as alias for facep.

	* cus-face.el (custom-face-attributes): Use choice widgets.
	Remove :bold and :italic.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-charset-registries): Removed since fontset.el
	is no always loaded.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (internal-get-face): Added as obsolete function for
	compatibility.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (blink-cursor-end): Call show-cursor.
	(blink-cursor-mode): Ditto.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-spec-reset-face): Reset all attributes to
	`unspecified'.
	(face-spec-set): Use it.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (read-all-face-attributes): Bug fix.
	(face-read-integer): Allow nil default value.
	(face-valid-attribute-values): Use symbol names of attribute
	values for completion list.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (internal-find-face): Define for compatibility with
	20.2.
	(face-id): Likewise.

	* faces.el (face-id): Return the ID of a realized face for ASCII.

	* fontset.el (x-charset-registries): Removed.  Now in faces.el.
	(x-complement-fontset-spec): Use face-charset-registries.

	* faces.el (face-font-selection-order): Set font selection order
	from Lisp.
	(face-alternative-font-family-alist): Set alternative font
	families from Lisp.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (set-face-charset-registries): Set symbol value.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-set-after-frame-default): Call function
	internal-merge-in-global-face.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-list): Return symbols from face-global-alist.

	* faces.el (face-list): Return a copy of the face name list so
	that it cannot be modified from outside (facemenu.el uses
	nreverse, for example).

	* cus-face.el (custom-face-attributes): Add :bold and :italic
	for compatibility with old code.

	* faces.el (set-face-attributes-from-resources): Additional
	frame parameter.
	(make-face-x-resource-internal): Set attributes from resources
	for a given frame or all frames.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (all-faces): Removed.

	* custom.el (defface): Add new face attributes to function
	comment.

	* font-lock.el (font-lock-comment-face): Use new face attribute
	names.
	(font-lock-string-face): Ditto.
	(font-lock-keyword-face): Ditto.
	(font-lock-builtin-face): Ditto.
	(font-lock-function-name-face): Ditto.
	(font-lock-variable-name-face): Ditto.
	(font-lock-type-face): Ditto.
	(font-lock-reference-face): Ditto.
	(font-lock-warning-face): Ditto.
	((boundp 'font-lock-face-attributes)): Ditto.

	* cus-face.el (custom-face-attributes): Use new face attributes.

	* faces.el (set-face-attribute-from-resource): Initialize
	from resources only for X and W32.

	* cus-face.el (custom-declare-face): Don't make frame-local
	faces.

	* faces.el (describe-face): Use princ instead of insert.

	* faces.el: Add XLFD manipulation functions from 20.2 again
	because fontset.el uses them.
	(face-set-after-frame-default): Add empty definition.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (make-face): Correct typo.
	(set-face-attribute-from-resource): Use let*.
	(face-underline-p): Correct typo.
	(face-inverse-video-p): Ditto.
	(set-face-stipple): Ditto.
	(face-read-string): Make completion-list optional parameter.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-charset-registries): Alist mapping charset
	symbols to registries and encoding.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (blink-cursor-mode): Use interactive spec "P".

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (blink-cursor-mode): Function to toggle blinking cursor
	mode.  The cursor of selected_window blinks if the mode is enabled.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (next-history-element): Set point to the end of the
	prompt if minibuffer-prompt-in-buffer.

1999-07-21  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (x-font-regexp): Add sub-expression parentheses for
	several font name components.

1999-07-21  Gerd Moellmann  <gerd@acm.org>

	* faces.el (set-face-relief): Use index 12 for relief.
	(face-fill-in): Set relief from data.
	(internal-make-face): Init relief to zero.

	* faces.el (face-spec-set): Call modify-face with additional
	parameters for relief and fixed-p.

1999-07-21  Gerd Moellmann  <gerd@acm.org>

	* cus-face.el: ':fixed and ':relief added.

	* faces.el (describe-face): Add fixed font attribute and relief.
	(face-attr-match-p): Ditto.
	(face-attr-construct): Ditto.
	(face-spec-set): Ditto.

1999-07-21  Gerd Moellmann  <gerd@acm.org>

	* faces.el (internal-make-face): Function to create a Lisp vector
	suitable for representing a face.
	(make-face): Use it instead of make-vector.
	(x-create-frame-with-faces): Use it instead of vector.
	(internal-facep): Increase vector size to 14.
	(internal-make-face): Ditto.
	(face-relief): Access relief thickness.
	(face-fixed-p): Access fixed font attribute.
	(set-face-fixed-p): Set fixed font attribute.
	(set-face-relief): Set relief attribute.
	(internal-face-interactive-int): Read int attribute of face.
	(modify-face): Add fixed-p and relief parameters.
	(copy-face): Handle fixed-p and relief.
	(face-equal): Compare fixed-p and relief.
	(face-differs-from-default-p): Ditto.
	(face-nontrivial-p): Add fixed-p and relief.

1999-07-21  Gerd Moellmann  <gerd@acm.org>

	* faces.el (eval-when-compile): Add set-face-shadow-thickness.
	(internal-facep): Increase vector size.
	(make-face): Ditto.
	(face-shadow-thickness): Added.
	(set-face-shadow-thickness): Added.
	(modify-face): Add optional shadow-thickness parameter.
	(make-face-x-resource-internal): Add shadows.
	(copy-face): Ditto.
	(face-equal): Ditto.
	(face-differs-from-default-p): Ditto.
	(face-nontrivial-p): Ditto.
	(face-attr-match-p): Ditto.
	(face-attr-construct): Ditto.
	(face-spec-set): Ditto.
	(face-fill-in): Ditto.

1999-07-21  Gerd Moellmann  <gerd@acm.org>

	* bench.el (bench-mark-split-window): New bench mark.

1999-07-21  Gerd Moellmann  <gerd@acm.org>

	* faces.el (set-face-font): Don't pass default font to
	x-resolve-font so that font will not have to be of the same
	size.

1999-07-20  Dave Love  <fx@gnu.org>

	* wid-edit.el (widget-use-overlay-change): Uncustomize and make it
	unconditionally t.

1999-07-20  Karl Heuer  <kwzh@gnu.org>

	* font-lock.el (c++-font-lock-extra-types): Add "type_info".

1999-07-20  Dave Love  <fx@gnu.org>

	* help.el (describe-variable): Fix test for customizability.

	* simple.el (append-to-buffer, prepend-to-buffer, copy-to-buffer):
	Check for readonly buffer in interactive spec.
	(zap-to-char, kill-line, kill-region, comment-region, kill-word)
	(backward-kill-word): Add * to interactive spec.

	* underline.el (underline-region, ununderline-region): Add * to
	interactive spec.

	* fill.el (canonically-space-region, justify-current-line): Add *
	to interactive spec.
	(fill-region-as-paragraph, fill-paragraph, fill-region)
	(fill-nonuniform-paragraphs, fill-individual-paragraphs): Check
	readonly buffer in interactive spec.

	* paragraphs.el (kill-paragraph, backward-kill-paragraph)
	(backward-kill-sentence, kill-sentence): Add * to interactive spec.

1999-07-19  Richard M. Stallman  <rms@gnu.org>

	* dired-aux.el (dired-do-shell-command): Doc fix.

	* shell.el (shell-unquote-argument): New function.
	(shell-directory-tracker): Use shell-unquote-argument.
	* comint.el (comint-arguments): Handle \ followed by space or tab.

1999-07-19  John Wiegley  <jwiegley@borland.com>

	* term.el (ansi-term-fg-faces-vector): Added support for ANSI
	color codes 39 and 49, which by the way lynx uses them seem to
	mean "foreground reset" and "background reset".

1999-07-19  Karl Heuer  <kwzh@gnu.org>

	* font-lock.el (c++-keywords): Add "typeid".

	* term/w32-win.el (mouse-set-font): If user uses w32 dialog but
	selects no font, treat that as zero selections, not one.

1999-07-19  Dave Love  <fx@gnu.org>

	* info.el (Info-search): Don't lose with empty regexp.

	* version.el: Cater for (free) `ident' program, not `which'.

	* hl-line.el: New file.

	* mouse.el (mouse-major-mode-menu): Default to menu-bar-edit-menu
	for modes which don't define menus.

1999-07-16  Richard M. Stallman  <rms@gnu.org>

	* webjump.el (webjump-sample-sites): Update some URLs.

1999-07-14  Richard Stallman  <rms@gnu.org>

	* Version 20.4 released.

1999-07-14  Andreas Schwab  <schwab@gnu.org>

	* compare-w.el (compare-windows): Try to find the next window in
	the current frame before looking at the other frames.

1998-07-12  Oleg S. Tihonov  <ost@benetnash.ffke-campus.mipt.ru>

	* language/cyrillic.el ("Cyrillic-KOI8", "Cyrillic-ALT"):
	Use cyrillic-jcuken as default input method.

1999-07-12  Richard Stallman  <rms@gnu.org>

	* progmodes/cc-engine.el (c-inside-bracelist-p): Tighter test for
	Java anonymous array expressions ("new Foo[] {.. bracelist ..}").

	* ispell.el (ispell-dictionary-alist-6): Change charset for Russian.
	(ispell-local-dictionary-alist): Add koi8-r for character set.

	* textmodes/flyspell.el (flyspell-get-word):
	Add special handling for when ispell-otherchars is empty.

1999-07-12  Espen Skoglund  <espensk@stud.cs.uit.no>

	* progmodes/pascal.el (pascal-beg-of-defun): More intuitive behavior
	when having nested functons.
	(pascal-indent-nested-functions) (pascal-indent-line)
	(pascal-calculate-indent) (pascal-get-lineup-indent): Support for
	indenting nested functions.

1999-07-09  Richard Stallman  <rms@gnu.org>

	* add-log.el (add-log-current-defun): Remove trailing `=' in C modes.

1999-07-08  Espen Skoglund  <espensk@stud.cs.uit.no>

	* pascal.el (pascal-calculate-indent): Fixed a bug occuring when
	the `end' keyword was in the very beginning of the buffer.

1999-07-08  Richard Stallman  <rms@gnu.org>

	* emacs-lisp/easy-mmode.el (easy-mmode-define-keymap): Doc fix.

	* term.el (term-emulate-terminal): Avoid infinite loop
	in strange case where minibuffer window is selected but not active.

1999-07-07  Stephen Eglen  <stephen@gnu.org>

	* progmodes/octave-inf.el (inferior-octave-directory-tracker):
	Change regexp so that it doesn't match commands beginning with `cd'.

1999-07-07  Francesco Potorti`  <F.Potorti@cnuce.cnr.it>

	* mail/rmail.el (mail-unsent-separator): Add a missing \\|.

1999-07-06  Richard Stallman  <rms@gnu.org>

	* hscroll.el (hscroll-minibuffer-hook): New function.
	(hscroll-global-mode): Add and remove that hook.
	Set hscroll-old-truncate-was-global's default value.

1999-07-05  Richard Stallman  <rms@gnu.org>

	* files.el (revert-buffer): Don't preserve point here.
	(revert-buffer-insert-file-contents-function): Doc fix.

	* isearch.el (isearch-process-search-char): Write octal 200 correctly.

	* startup.el (normal-top-level-add-subdirs-to-load-path): Avoid
	doing a `stat' when it isn't necessary because that can cause
	trouble when an NFS server is down.

1999-07-04  Richard Stallman  <rms@gnu.org>

	* hscroll.el (hscroll-window-maybe): Do nothing in the minibuffer.

1999-07-03  Richard Stallman  <rms@gnu.org>

	* isearch.el (isearch-quote-char): Call unibyte-char-to-multibyte
	for \200...\240 also.
	(isearch-printing-char): Use unibyte-char-to-multibyte.

1999-07-02  Richard Stallman  <rms@gnu.org>

	* frame.el (minibuffer-frame-alist): Use defcustom.
	(pop-up-frame-alist): Likewise.
	(initial-frame-alist): Specify * in the doc string.

	* hscroll.el (hscroll-mode): Make it a permanent local.
	(hscroll-mode): Don't cancel the timer
	if HScroll mode is enabled in some other buffer.

	* isearch.el (isearch-done): If search ends in middle of intangible
	text (due to text property), move on to the limit of that text.

1999-07-01  Andrew Innes  <andrewi@gnu.org>

	* man.el (Man-build-man-command): Use value of null-device,
	instead of hard-coding "/dev/null".

	* dos-w32.el (untranslated-canonical-name): Avoid expanding
	ange-ftp file names, which might force ange-ftp to prompt for a
	password.

	* ange-ftp.el (ange-ftp-load): Bind load-force-doc-strings to t,
	to prevent references to temp files.

1999-06-30  Richard Stallman  <rms@gnu.org>

	* progmodes/sh-script.el (sh-feature): If nothing is known
	about the given shell, use the values for `sh'.

1999-06-30  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-fetch-cvs-status): Use "-l" option for "cvs status",
	to make it non-recursive.

	* vc-hooks.el (vc-find-cvs-master): Set case-fold-search correctly.

1999-06-29  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* auto-show.el (auto-show-mode): Fix Typo in :set.

1999-06-29  Richard M. Stallman  <rms@gnu.org>

	* progmodes/sh-script.el (sh-mode): When setting syntax
	table, default to the standard one.

1999-06-27  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/lisp-mode.el (eval-defun): Doc fix.

1999-06-27  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/reftex.el (reftex-pop-to-bibtex-entry): Don't pop up
	a frame when `return' is requested (even if pop-up-frames = t)
	* textmodes/bibtex.el (bibtex-mode): `font-lock-mark-block-function'
	should only be set for the bibtex buffer.

	* emacs-lisp/autoload.el (generated-autoload-file): Doc fix.

	* progmodes/compile.el: Deal with compilation-error-screen-columns
	being buffer-local.

1999-06-27  Francesco Potorti`  <F.Potorti@cnuce.cnr.it>

	* comint.el (comint-password-prompt-regexp): Allow "(again)".

1999-06-27  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* cal-x.el (calendar-only-one-frame-setup): New function.
	* calendar.el (calendar): Call it if requested.

1999-06-24  Karl Heuer  <kwzh@gnu.org>

	* startup.el (iso-8859-n-locale-regexp): Doc fix.

1999-06-22  Richard M. Stallman  <rms@gnu.org>

	* mail/supercite.el (sc-emacs-features): Doc fix.

1999-06-22  Karl Heuer  <kwzh@gnu.org>

	* files.el (auto-mode-alist): Add pike-mode.

1999-06-20  Paul R. Eggert  <eggert@twinsun.com>

	* tar-mode.el (tar-header-block-tokenize): Don't assume that the
	last byte of a numeric field is a space or a NUL.  Parse it as
	potentially part of the number.  This is used by GNU tar
	1.12.64012 to handle larger values.

1999-06-20  Karl Heuer  <kwzh@gnu.org>

	* custom.el (custom-handle-keyword): Fix error message.

1999-06-18  Andrew Innes  <andrewi@gnu.org>

	* mail/smtpmail.el (smtpmail-send-it): Use
	convert-standard-filename to make file names for queued mail safe
	on Windows (`:' is invalid in file names on Windows).

1999-06-17  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (describe-current-input-method):
	Current-input-method is string.
	(toggle-input-method): Docstring fixed.

	* international/mule-diag.el
	(describe-current-coding-system-briefly): Fix format string.

	* international/mule-util.el (coding-system-eol-type-mnemonic):
	Docstring modified.  Return a string.

1999-06-17  Alex Schroeder  <a.schroeder@bsiag.ch>

	* sql.el (sql-input-ring-file-name): Doc fix.

1999-06-17  Richard M. Stallman  <rms@gnu.org>

	* calendar/cal-x.el (special-display-buffer-names):
	Don't put (get-file-buffer diary-file) on this list.

1999-06-17  Mark W Maimone  <mwm@helios.jpl.nasa.gov>

	* play/mpuz.el (mpuz-try-proposal): Fix message call.
	Don't penalize player for certain impossible guesses.

1999-06-16  Andrew Innes  <andrewi@gnu.org>

	* ls-lisp.el (ls-lisp-format-time): If timestamp is invalid,
	return the string "Unk  0  0000" so at least it appears to be a
	valid timestamp to `dired-move-to-filename-regexp'.

1999-06-15  Ken'ichi Handa  <handa@gnu.org>

	* ps-print.el (ps-control-character): Fix previous change.

1999-06-15  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* mail/rmailsum.el (rmail-summary-output-to-rmail-file): Avoid
	multiple output of the last message.

1999-06-14  Eli Zaretskii  <eliz@gnu.org>

	* term/internal.el (IT-display-table-setup): Do not remap \222 to
	the ASCII apostrophe, as most DOS codepages have some other glyph
	there.

1999-06-14  Ken'ichi Handa  <handa@gnu.org>

	* language/ethio-util.el (setup-ethiopic-environment-internal):
	Use quail-activate-hook instead of obsolete hook quail-mode-hook.
	(exit-ethiopic-environment): Likewize.

1999-06-12  Richard M. Stallman  <rms@gnu.org>

	* cus-start.el (scroll-preserve-screen-position): Fix typo in type.

1999-06-12  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* emulation/crisp.el (crisp-mode): (defcustom) Initialize with
	custom-initialize-default to avoid infinite loop.
	(crisp-mode): (defun) Call transient-mark-mode here, not when
	loading the file.  Run crisp-mode-hook here, and run
	crisp-load-hook when loading the file.

	* mail/rmailout.el (rmail-output-read-rmail-file-name): If in
	rmail-summary buffer, search for pattern in rmail-file.

	* mail/rmailsum.el (rmail-summary-output-to-rmail-file): Fix typo.

	* progmodes/cperl-mode.el (cperl-invalid-face): Fix custom type.

	* ps-print.el (ps-printer-name): Fix custom type.

1999-06-12  Reto Zimmermann  <reto@synopsys.com>

	* progmodes/vhdl-mode.el (vhdl-port-copy): Fix parsing bug.
	(vhdl-port-paste-generic-map): Fix indentation bug.
	(vhdl-port-paste-port-map): Fix indentation bug.
	(vhdl-scan-file-contents): Make scanning case insensitive.

1999-06-11  Richard M. Stallman  <rms@gnu.org>

	* files.el (write-file): When buffer is not already visiting a file,
	don't put buffer name in the minibuffer, just make it the default.
	Also handle just directory as arg usefully in that case.

	* simple.el (sendmail-user-agent-compose):
	Ignore case when inserting the rest of the "other" headers.

	* help.el (help-for-help): Mention C-h C-i.  Clear up C-h n.

	* info-look.el (info-lookup-file, info-lookup-symbol): Doc fix.
	(info-lookup-interactive-arguments): Never insert the default
	into the minibuffer automatically.

	* emacs-lisp/cl-extra.el (getf): Don't call get*.

1999-06-09  Richard M. Stallman  <rms@gnu.org>

	* simple.el (shell-command): Avoid printing "mark set" message.

1999-06-09  Dave Love  <fx@gnu.org>

	* progmodes/compile.el (compilation-error-regexp-alist): Allow
	digits in program name in first pattern.

1999-06-09  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-dired-mode): Don't match anything before the date in
	dired-move-to-filename-regexp.

1999-06-07  Ken'ichi Handa  <handa@gnu.org>

	* international/quail.el (quail-define-rules): Fix typo in
	docstring.

1999-06-05  Stephen Eglen  <stephen@gnu.org>

	* iswitchb.el (iswitchb-default-keybindings): Add
	iswitchb-minibuffer-setup to minibuffer-setup-hook here rather
	than when package is loaded.

1999-06-04  Richard M. Stallman  <rms@gnu.org>

	* startup.el (command-line): Don't set user-init-file directly;
	tell `load' to set it.

	* ange-ftp.el (ange-ftp-shell-command): Handle error-buffer arg.

	* simple.el (next-history-element):
	Handle minibuffer-text-before-history properly when reading sexps.

	* disp-table.el (standard-display-european):
	For an interactive call by the user,
	don't set enable-multibyte-characters,
	and don't set the terminal coding system.

	* textmodes/refbib.el: Don't print any messages or display
	a buffer when loading the library.
	(r2b-help): Doc fix.
	(r2b-help-message): Update the documentation.
	(r2b-load-quietly): Variable deleted.
	(r2b-convert-buffer): Doc fix.

1999-06-04  Dave Love  <fx@gnu.org>

	* help.el (help-xref-interned): Fix insertion of fdoc and revamp.

	* auto-show.el: Don't change hooks on loading.
	(auto-show-mode): Autoload.  Default to nil.  Add :set &c.
	(auto-show-mode): Add to hooks here.

1999-06-04  Richard Sharman  <rsharman@pobox.com>

	* emacs-lisp/regexp-opt.el (regexp-opt-group): Avoid infinite
	recursion on bogus input.

1999-06-04  Eric M. Ludlam  <zappo@ultranet.com>

	* speedbar.el (speedbar-hack-buffer-menu): Fixed so if the user
	does not select a buffer from the buffers menu, then the attached
	frame is not switched to anything.

1999-06-03  Ken'ichi Handa  <handa@gnu.org>

	* language/vietnamese.el (ccl-encode-vscii): Typo fixed
	(viet-viscii-...->viet-vscii...).

	* international/mule-conf.el (iso-2022-7bit-lock-ss2): Typo fixed.

1999-06-01  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el: Add :link to defgroup.
	(fortran-blink-matching-if): Match ELSE statements too.
	(fortran-fill-statement, fortran-fill): Bind auto-fill-function so
	that filling is always done.

1999-05-31  Richard M. Stallman  <rms@gnu.org>

	* simple.el (append-next-kill): Use an arg to distinguish
	interactive calls from Lisp calls, rather than (interactive-p).

	* international/iso-transl.el (iso-transl-language-alist):
	Interchange n and N.

1999-05-31  Dave Love  <fx@gnu.org>

	* msb.el: Add to minor-mode-map-alist.  Remove hook installation
	and keymap munging on load.
	(msb-mode): New option.
	(msb-files-by-directory, msb-sort-by-name, msb-sort-by-directory):
	Doc fix.
	(msb-mode-map): New variable.
	(msb-mode): New command.

1999-05-31  Dave Love  <fx@gnu.org>

	* ispell.el (ispell-alternate-dictionary): Fix custom type.
	(ispell-complete-word-dict): Likewise.

1999-05-31  Eli Zaretskii  <eliz@gnu.org>

	* forms.el (forms-save-buffer): Call set-buffer-modified-p to
	force the data buffer to be saved, even if the data didn't
	change, in case the write filter was modified.  Restore the
	current record after read-file-filter finishes.

1999-05-29  Karl Heuer  <kwzh@gnu.org>

	* ispell4.el: Obsolete; file deleted.

	* textmodes/texinfmt.el (texinfo-format-direntry): Avoid blank line.

	* font-lock.el (font-lock-apply-syntactic-highlight): Don't die if
	VALUE is a syntax table.

	* emacs-lisp/cl.el (custom-print-functions): Add autoload cookie.

	* simple.el (zap-to-char): Doc fix.

1999-05-27  Ken'ichi Handa  <handa@gnu.org>

	* isearch.el (isearch-quote-char): Don't assume character codes
	0200 - 0237 stand for characters in some single-byte character
	charset.

1999-05-27  Dave Love  <fx@gnu.org>

	* startup.el (iso-8859-n-locale-regexp): Don't match 8859-15 &c.

1999-05-27  Andreas Schwab  <schwab@gnu.org>

	* dired-aux.el (dired-insert-subdir-doinsert): Check that the
	headerline does not exist already.

1999-05-26  Richard Stallman  <rms@gnu.org>

	* progmodes/cc-menus.el (cc-imenu-java-generic-expression):
	Avoid nested null-loops.

1999-05-26  Ken'ichi Handa  <handa@gnu.org>

	* international/characters.el: Typo fixed; prefered->preferred.

	* international/mule-cmds.el (find-coding-systems-for-charsets):
	Typo fixed; prefered->preferred.

	* map-ynp.el (map-y-or-n-p): Don't inherit the current input
	method in read-event.

	* international/mule.el (charset-info): Doc-string fixed.

1999-05-25  Ken'ichi Handa  <handa@gnu.org>

	* mail/smtpmail.el (smtpmail-send-it): Bind
	smtpmail-code-conv-from properly.
	(smtpmail-send-data-1): If DATA is a multibyte string, encode it
	by smtpmail-code-conv-from.

1999-05-24  Richard Stallman  <rms@gnu.org>

	* emulation/crisp.el (crisp-submit-bug-report): Function deleted.
	Binding deleted also.

1999-05-24  Karl Heuer  <kwzh@gnu.org>

	* comint.el (comint-bol-or-process-mark): Doc fix.

1999-05-23  Dave Love  <fx@gnu.org>

	* emulation/crisp.el (crisp-mode-map): Don't inherit global-map.
	Enter it on minor-mode-map-alist.
	(crisp-mode): Re-named from `crsip-mode-enabled'.  Users changed.
	Autoload.  Add custom setter.
	(crisp-mark-line): Doc fix.
	(crisp-mode): Autoload.  Re-write not to frob keymaps directly.
	(crisp-mode-hook): Define.

1999-05-23  Ken'ichi Handa  <handa@gnu.org>

	* files.el (recover-file): Recover buffer-file-coding-system.

1999-05-22  Richard Stallman  <rms@gnu.org>

	* vc.el (vc-dired-mode): Make the dired-move-to-filename-regexp
	regexp match the date, to avoid treating date as file size.
	Add YYYY S option to WESTERN/

	* bookmark.el: Delete some XEmacs compatibility code.
	(bookmark-jump-noselect): Check vc-backend.

	* subr.el (add-to-list): Doc fix.

1999-05-21  Stephen Eglen  <stephen@gnu.org>

	* diary-lib.el (diary-mail-entries): Use fancy-diary-buffer.

1999-05-18  Richard Stallman  <rms@gnu.org>

	* textmodes/texinfmt.el (texinfo-anchor): Don't delete a
	non-space after the @anchor command.
	(texinfo-format-var): Handle other nested constructs, using
	texinfo-parse-expanded-arg and texinfo-discard-command, not
	texinfo-parse-arg-discard.

	* emacs-lisp/debug.el (debugger-outer-inhibit-redisplay): New variable.
	(debug): Bind and use debugger-outer-inhibit-redisplay.
	Bind inhibit-redisplay to nil.
	(debugger-env-macro): Treat inhibit-redisplay like other outside vars.

1999-05-17  Dave Love  <fx@gnu.org>

	* help.el (describe-function-1): Extra arg, interactive-p.
	(describe-key, describe-function): Use it.

1999-05-17  Karl Heuer  <kwzh@gnu.org>

	* ispell.el (ispell-local-dictionary-alist): Add autoload cookie.

1999-05-16  Dave Love  <fx@gnu.org>

	* cus-start.el (all): Delete selective-display.  Add scroll-margin,
	scroll-preserve-screen-position, scroll-conservatively.

1999-05-16  Dave Love  <fx@gnu.org>

	* emacs-lisp/byte-opt.el (byte-optimize-plus): Fix 1-arg case.

1999-05-15  Reto Zimmermann  <reto@Synopsys.COM>

	* progmodes/vhdl-mode.el: Completely revised and massively extended.

1999-05-15  Francesco Potorti`  <F.Potorti@cnuce.cnr.it>

	* progmodes/sh-script.el (sh-mode): Do not fail if buffer has no
	magic number and is not associated with a file.

1999-05-14  Richard M. Stallman  <rms@gnu.org>

	* files.el (find-file-noselect-1): Fix previous change.

1999-05-14  Simon Marshall  <simon@gnu.org>

	* fast-lock.el (fast-lock-cache-name): Fix test for `windows-nt'.

1999-05-13  Ken'ichi Handa  <handa@gnu.org>

	* international/mule-diag.el (mule-diag): Change MULE to Mule in
	docstring.

	* international/mule-cmds.el: Change MULE to Mule in docstrings
	and menus.

1999-05-10  Kenichi HANDA  <handa@etl.go.jp>

	* ps-mule.el (ps-mule-prologue): Fix the definition of DefFontMule
	to correctly reflect the value of BaseLineOffset in
	RelativeCompose.  Now the value of RelativeCompose is an array of
	low and high positions.
	(ps-mule-cmpchar-prologue): Adjust the definition of BC, EC, and
	RLC for the above change.

1995-05-11  Joel N. Weber II  <devnull@melange.gnu.org>

	* comint.el (comint-password-prompt-regexp): Modified to match the
	output of ksu and ssh-add.

1999-05-11  Kenichi HANDA  <handa@etl.go.jp>

	* language/korea-util.el (isearch-toggle-korean-input-method):
	Adjusted for the change of input method handling in isearch.el.
	(isearch-hangul-switch-symbol-ksc): Likewise.
	(isearch-hangul-switch-hanja): Likewise.

1999-05-10  Dave Love  <fx@gnu.org>

	* help.el (help-make-xrefs): Fix typo.

1999-05-10  Andreas Schwab  <schwab@gnu.org>

	* emacs-lisp/byte-opt.el (byte-boolean-vars):
	Add unibyte-display-via-language-environment.

	* help.el (help-make-xrefs): Handle more cases when looking for
	commands in a keymap description.

1999-05-10  Eli Zaretskii  <eliz@gnu.org>

	* loadup.el: For ms-dos systems, load ccl and codepage.

1999-05-09  Ken'ichi Handa  <handa@gnu.org>

	* ps-print.el (ps-control-character): Call
	ps-mule-prepare-ascii-font to setup ASCII fonts.

	* ps-mule.el (ps-mule-begin-job): Redo this change "if
	ps-multibyte-buffer is nil, use
	ps-mule-font-info-database-default."

1999-05-08  Ken Stevens  <k.stevens@ieee.org>

	* ispell.el (ispell-local-dictionary-alist): New variable for
	customizing local dictionaries not accessable by everyone.
	(ispell-dictionary-alist): Loads `ispell-local-dictionary-alist'.
	(ispell-required-version): Changed format `(major minor
	revision)' to support general pattern matching.
	(ispell-tex-skip-alists): AMS Tex block comment and `\author'
	skip region commented out due to incorrect skip potential in std latex.
	(ispell-word): Removed `when' macro.  Fixed bug of not restoring
	cursor point on small words for calls from `ispell-minor-mode'.
	(check-ispell-version): Tests and accepts versions major.minor
	and above, with adjustments for interactions in 3.1.0-3.1.11.
	(ispell-get-line): No longer skips ispell process special characters.
	(ispell-comments-and-strings): Removed `when' macro call.
	(ispell-minor-check): Requires ispell-word to restore cursor point.
	(ispell-buffer-local-parsing): Supports checking comments only.

1999-05-08  Karl Heuer  <kwzh@gnu.org>

	* comint.el (comint-password-prompt-regexp): Fix last change to be
	more specific.

1999-05-07  Richard M. Stallman  <rms@gnu.org>

	* subr.el (with-temp-message): Fix the other call to message
	to use %s.

1999-05-07  Michael Ernst  <mernst@alum.mit.edu>

	* gud.el (gud-format-command): "%F" means file sans extension.
	(jdb): Use %F, not %f, for gud-break.

1999-05-07  Joel N. Weber II  <devnull@melange.gnu.org>

	* comint.el (comint-password-prompt-regexp): Modified so that it
	matches the output of kinit.

1999-05-06  Greg Stark  <gsstark@mit.edu>

	* timezone.el (timezone-parse-date): Recognize new format used in
	internet cookies.

1999-05-04  Tudor Hulubei  <tudor@cs.unh.edu>

	* international/iso-acc.el (iso-languages): Add latin-2 cedillas.

1999-05-04  Andrew Innes  <andrewi@gnu.org>

	* time.el (display-time-update): Allow for wrap-around when
	checking against display-time-server-down-time.

1999-05-04  Ken'ichi Handa  <handa@gnu.org>

	* international/mule-diag.el (describe-coding-system): Fix English
	message.

1999-05-03  Jason Rumney  <jasonr@altavista.net>

	* term/w32-win.el: Change the x-charset-registry property for the
	Japanese charsets that are supported by Japanese Windows fonts.

1999-05-03  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* diary-lib.el (diary-remind): Rewritten to behave sensibly for
	diary-block diary entries for which the reminders and the diary
	entries can overlap.

1999-05-02  Jason Rumney  <jasonr@altavista.net>

	* term/w32-win.el (mouse-set-font): Ensure constructed fontset
	matches the font selected in the dialog.

1999-05-02  Dave Love  <fx@gnu.org>

	* browse-url.el (browse-url-browser-function): Add :version.

	* international/mule.el (auto-coding-alist): Add .tgz.

1999-05-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/codepage.el (cp-coding-system-for-codepage-1):
	Make the magnification parameter for the -dos encoder be 2.

1999-05-02  Andrew Innes  <andrewi@gnu.org>

	* term/w32-win.el (w32-drag-n-drop): Select file in window where
	it is dropped, rather than current window.

	* mail/smtpmail.el (smtpmail-deduce-address-list): Bind variables
	after switching buffer, as case-fold-search is a buffer local
	variable.

	* w32-fns.el (convert-standard-filename): Only convert directory
	separators to backslash if the interactive shell is one of the
	standard Windows shells that has DOS semantics.

	* ls-lisp.el (ls-lisp-format-time): Trap errors from
	format-time-string, and return a suitable string to indicate the
	timestamp was invalid.

	* hexl.el (hexlify-command): Apply shell-quote-argument after
	expanding hexl-program in case exec-directory contains a space.
	(dehexlify-command): Ditto.

	* dos-w32.el (file-name-buffer-file-type-alist): Remove various
	file extension regexps which aren't necessarily binary files.
	(direct-print-region-helper): Use subst-char-in-string instead of
	binding directory-sep-char to convert filenames to DOS syntax.
	(direct-print-region-use-command-dot-com): New variable.
	(direct-print-region-helper): Use it to control whether to invoked
	command.com to print on Windows 9x.

	* browse-url.el (browse-url-browser-function): Default to
	browse-url-default-windows-browser on windows-nt.
	(browse-url-default-windows-browser): New function.

1999-04-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* forms.el (forms-mode): Don't call forms-first-record or
	forms-last-record if the data file has zero records.

1999-04-29  Richard M. Stallman  <rms@gnu.org>

	* files.el (find-file-noselect-1): If buffer-file-name has changed
	after find-file-not-found-hooks runs, recompute the truename.
	And don't use FILENAME after that point.

1999-04-27  Dave Love  <fx@gnu.org>

	* paren.el (show-paren-mode)
	* which-func.el (which-func-mode-global)
	* type-break.el (type-break-mode)
	* time.el (display-time-mode)
	* rsz-mini.el (resize-minibuffer-mode)
	* mouse-sel.el (mouse-sel-mode)
	* icomplete.el (icomplete-mode)
	* hscroll.el (hscroll-global-mode)
	* help.el (temp-buffer-resize-mode)
	* font-lock.el (global-font-lock-mode)
	* delsel.el (delete-selection-mode)
	* avoid.el (mouse-avoidance-mode)
	* autoinsert.el (auto-insert-mode)
	* winner.el (winner-mode): Doc fix.

1999-04-26  Karl Heuer  <kwzh@gnu.org>

	* mail/rmail.el (rmail-next-same-subject): When searching, ignore
	the same whitespace that was ignored in choosing the subject string.

1999-04-26  Richard M. Stallman  <rms@gnu.org>

	* info.el (Info-find-node): Position properly after finding anchor.

	* cus-start.el (all): Handle unibyte-display-via-language-environment.

	* simple.el (indent-new-comment-line): Fix previous change.

	* complete.el: Delete the wildcard expansion feature
	since that is now standard in find-file.
	(PC-try-load-many-files): Function deleted.
	(PC-after-load-many-files): Function deleted.
	(PC-many-files-list): Variable deleted.
	(PC-disable-wildcards): Variable deleted.
	(partial-completion-mode): Don't enable the wildcard feature.

	* complete.el (PC-look-for-include-file): Don't set global variables
	`error', `buf' and `filename' here.

	* mail/sendmail.el (mail-sent-via): Use copy-marker not make-marker.

1999-04-26  John Wiegley  <johnw@oneworld.new-era.com>

	* textmodes/outline.el (outline-regexp): Doc fix.

1999-04-26  John Wiegley  <johnw@borland.com>

	* progmodes/compile.el (compilation-error-regexp-alist): Recognize
	C++Builder 4.0 error message syntax.

1999-04-26  Mark Diekhans  <markd@Grizzly.COM>

	* progmodes/compile.el (grep-compute-defaults): If xargs -e isn't
	supported, use find -exec.

1999-04-26  Yoshiki Hayashi  <g740685@komaba.ecc.u-tokyo.ac.jp>

	* textmodes/texinfmt.el (texinfo-format-buffer): Bind
	coding-system-for-write, to avoid hanging when non-interactive.

1999-04-26  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* textmodes/bibtex.el (bibtex-reference-head): Allow entries to
	start with a newline.

1999-04-13  Ken'ichi Handa  <handa@gnu.org>

	* international/mule-conf.el (x-ctext): New coding system.

1999-04-12  Richard M. Stallman  <rms@gnu.org>

	* international/mule-cmds.el (input-method-function):
	Add permanent-local property.

1999-04-12  Dave Love  <fx@gnu.org>

	* jka-compr.el (jka-compr-insert-file-contents): Fix previous
	change to use jka-compr-byte-compiler-base-file-name.

	* supercite.el (sc-scan-info-alist): Revert last change.
	(sc-attrib-selection-list): Fix :type here instead.

1999-04-11  Eli Zaretskii  <eliz@gnu.org>

	* international/mule.el (auto-coding-alist-lookup): Include ms-dos
	in the list of case-insensitive filesystems.

1999-04-09  Kenichi Handa  <handa@etl.go.jp>

	* international/fontset.el (create-fontset-from-fontset-spec):
	Don't register duplicated alias fontset names.

1999-04-08  Richard Stallman  <rms@gnu.org>

	* international/mule.el (auto-coding-alist-lookup): New function.
	(set-auto-coding): Use auto-coding-alist-lookup.

	* jka-compr.el (jka-compr-insert-file-contents):
	Use auto-coding-alist-lookup to check for files that
	should not have eol conversion, in the unibyte case.

1999-04-07  Dave Love  <fx@gnu.org>

	* help.el (describe-variable): Check custom-loads property as well
	as custom-type.

	* abbrev.el (abbrev-mode): Customizing sets the default value.

1999-04-08  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-backend-revert): For CVS files that were made
	writeable with "cvs edit", call "cvs unedit" to undo that.

1999-04-08  Dave Love  <fx@gnu.org>

	* mail/supercite.el (sc-attrib-selection-list): Fix custom type more.
	(sc-emacs-features): Recognize Emacs 20.
	(sc-read-string): Use history arg.
	(sc-scan-info-alist): Check for rtnvalue a cons.

1999-04-08  Kenichi HANDA  <handa@etl.go.jp>

	* gnus/gnus-mule.el (gnus-mule-message-send-mail-function): Find a
	coding system to encode the message by
	select-message-coding-system.

1999-04-07  Richard Stallman  <rms@gnu.org>

	* progmodes/sql.el (sql-send-paragraph): Delete duplicate definition.

	* winner.el: Reorder definitions.

	* mail/mh-utils.el (mh-find-progs): Try /etc/nmh and lib/nmh dirs.

	* mail/rmail.el (rmail-decode-babyl-format):
	Undo previous change.

1999-04-06  Richard Stallman  <rms@gnu.org>

	* info.el (Info-find-node): Check for an anchor at the
	proper place, before reading an indirect file.

	* imenu.el (imenu--mouse-menu): Use assq when searching in FINAL.

	* jka-compr.el (jka-compr-insert-file-contents):
	Use raw-text-unix when we want no conversion.

1999-04-06  Thierry Emery  <Thierry.Emery@nmu.alcatel.fr>

	* timezone.el (timezone-parse-date): Corrected regexp for
	style (5) date format so that tenths of seconds are optional.

1999-04-05  Eli Zaretskii  <eliz@gnu.org>

	* term/internal.el (dos-cpNNN-setup): New function, with the guts
	of dos-codepage-setup.
	(cjk-codepages-alist): New variable, an alist of Far-Eastern
	codepages for which there's no need to set up cpNNN coding
	systems.
	(dos-codepage-setup): Support Far-Eastern DOS terminals.

1999-04-05  Richard Stallman  <rms@gnu.org>

	* mail/rmail.el (rmail-ignored-headers): Doc fix.

1999-04-02  Richard Stallman  <rms@gnu.org>

	* progmodes/compile.el (compilation-handle-exit): Do right thing
	if (car status) doesn't end in a newline.

1999-04-01  Dave Love  <fx@gnu.org>

	* progmodes/sql.el (SQL): Add defgroup :version.

1999-03-31  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-file): Clear
	buffer-file-coding-system.  If the coding system used is raw-text,
	etc., make the *Compiler Input* buffer unibyte.

	* international/mule.el (find-new-buffer-file-coding-system): Doc fix.

	* loadup.el: Don't write the fns-...el file if not dumping.

1999-03-31  Dave Love  <fx@gnu.org>

	* snmp-mode.el (snmp): Fix defgroup :version.

	* hilit-chg.el (highlight-changes): Add defgroup :version.

1999-03-31  Andreas Schwab  <schwab@gnu.org>

	* gnus/gnus-sum.el (gnus-data-compute-positions): Move down after
	the gnus-save-hidden-threads macro.

1999-03-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* faces.el (face-set-after-frame-default): Obey the
	`customized-face' for new faces.

1999-03-30  Dave Love  <fx@gnu.org>

	* international/mule-cmds.el (current-language-environment): Doc fix.
	* abbrev.el (abbrev-mode): Doc fix.
	* autoinsert.el (auto-insert-mode): Doc fix.
	* complete.el (partial-completion-mode): Doc fix.
	* avoid.el (mouse-avoidance-mode): Doc fix.
	* delsel.el (delete-selection-mode): Doc fix.
	* font-lock.el (global-font-lock-mode): Doc fix.
	* help.el (temp-buffer-resize-mode): Doc fix.
	* hscroll.el (hscroll-global-mode): Doc fix.
	* icomplete.el (icomplete-mode): Doc fix.
	* mouse-sel.el (mouse-sel-mode): Doc fix.
	* paren.el (show-paren-mode): Doc fix.
	* rsz-mini.el (resize-minibuffer-mode): Doc fix.
	* time.el (display-time-mode): Doc fix.
	* type-break.el (type-break-mode): Doc fix.
	* which-func.el (which-func-mode-global): Doc fix.
	* winner.el (winner-mode): Doc fix.

1999-03-30  Michael Ernst  <mernst@alum.mit.edu>

	* wid-edit.el (widget-before-change): Signal text-read-only rather
	than an ordinary error.

1999-03-30  Richard M. Stallman  <rms@gnu.org>

	* repeat.el: Don't require advice.
	(repeat): Do function-indirection in check for kbd macro.
	In self-insert case, use the *last* char in INSERTION.

1999-03-30  Karl Heuer  <kwzh@gnu.org>

	* progmodes/cc-cmds.el (c-indent-command): Doc fix.

1999-03-29  Andreas Schwab  <schwab@gnu.org>

	* textmodes/tex-mode.el (tex-start-shell): Use add-hook for
	comint-input-filter-functions.  Make variables related to shell
	directory tracking local.

1999-03-26  Andreas Schwab  <schwab@gnu.org>

	* emacs-lisp/debug.el (debug): Make *Backtrace* buffer writable.

	* simple.el (shell-command-on-region): Cope with exit-status being
	nil, which happens if call-process-region was interrupted.

1999-03-26  Richard M. Stallman  <rms@gnu.org>

	* simple.el (indent-new-comment-line): Handle use at a point
	after a comment-end.  Handle multiple comments.

	* mail/rmail.el (rmail-decode-babyl-format):
	To prevent locking, bind buffer-file-name to nil.

1999-03-26  Karl Fogel  <kfogel@red-bean.com>

	* mail-hist.el (mail-hist-current-header-name): Don't make
	off-by-one-error when determining if in message body.

1999-03-25  Andrew Innes  <andrewi@gnu.org>

	* w32-fns.el (set-default-process-coding-system): Copied from
	dos-w32.el, but modified to use Unix line endings for process
	input, and to add a suitable entry to process-coding-system-alist
	for DOS shells.

	* dos-fns.el (set-default-process-coding-system): Copied from
	dos-w32.el.

	* dos-w32.el (set-default-process-coding-system): Move function to
	dos-fns.el; a different version is used in w32-fns.el.

1999-03-24  Dave Love  <fx@gnu.org>

	* info.el (Info-directory-list): Revert change to re-writing
	Info-default-directory-list, but put `alternative' first.
	(Info-insert-dir): Modify selecting the top dir file as a consequence.

1999-03-23  Simon Marshall  <simon@gnu.org>

	* font-lock.el (c-font-lock-keywords-2): Only fontify a label if it is
	on the line by itself.
	(java-font-lock-keywords-2): Likewise.  Don't fontify a class name if
	it is not in a declarative context.

1999-03-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (custom-variable-prompt): Allow customization of
	autoloaded symbols.

1999-03-22  Kenichi HANDA  <handa@etl.go.jp>

	* simple.el (what-cursor-position): Don't cause error when point
	is at invalid multibyte sequence.

1999-03-21  Karl Heuer  <kwzh@gnu.org>

	* complete.el (partial-completion-mode): Doc fix.

1999-03-19  Richard M. Stallman  <rms@gnu.org>

	* progmodes/cplus-md.el (old-c++): Remove :group.

	* progmodes/c-mode.el (old-c): Remove :group.

1999-03-18  Simon Marshall  <simon@gnu.org>

	* font-lock.el (c-font-lock-keywords-2): Added "complex" type.
	(java-font-lock-keywords-2): Added "strictfp" keyword.

1999-03-17  Jason Rumney  <jasonr@altavista.net>

	* w32-fns.el (set-w32-system-coding-system) New function.
	(w32-system-coding-system) Initialize to 'iso-latin-1.

1999-03-17  Eli Zaretskii  <eliz@gnu.org>

	* international/mule-cmds.el (set-language-environment): Fix
	previous change: don't use dos-codepage when unbound.

1999-03-17  Karl Heuer  <kwzh@gnu.org>

	* calendar/appt.el (appt-make-list): Fix previous change.

1999-03-16  Richard M. Stallman  <rms@gnu.org>

	* window.el (shrink-window-if-larger-than-buffer):
	Don't try to redisplay with the cursor at the end
	on its own line--that would force a scroll and spoil things.

1999-03-16  Eli Zaretskii  <eliz@gnu.org>

	* international/mule-cmds.el (set-language-environment): Don't use
	cpNNN-nonascii-translation-table if it is unbound.

	* term/internal.el (dos-codepage-setup): Compute the unibyte
	syntax table and bind unibyte-display-via-language-environment
	here, rather than at top level, so that resetting to unibyte in
	.emacs works as expected.

1999-03-15  Simon Marshall  <simon@gnu.org>

	* font-lock.el (c-font-lock-keywords-2): Added "restrict" keyword.

1999-03-14  Milan Zamazal  <pdm@pvt.net>

	* abbrev.el (inverse-add-abbrev): Inherit the current input method.

1999-03-14  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-util.el (detect-coding-with-priority):
	Restore the internal database.

1999-03-14  Stephen Eglen  <stephen@gnu.org>

	* mail/sendmail.el (sendmail-send-it): Fix typo in error string
	if mail-from-style has invalid value.

1999-03-12  Karl Heuer  <kwzh@gnu.org>

	* vc.el (vc-delete-logbuf-window): New var.
	(vc-finish-logentry): Use it.

1999-03-12  Richard M. Stallman  <rms@gnu.org>

	* startup.el (command-line-1): Improve startup msg.

1999-03-12  Eric M. Ludlam  <zappo@ultranet.com>

	* speedbar.el: Added commentary about stealthy functions.
	(speedbar-message) new function.
	(speedbar-y-or-n-p): New function
	(speedbar-with-attached-buffer) Moved macro before reference.
	Now uses `save-selected-window'.
	(speedbar-mouse-hscroll, speedbar-track-mouse, speedbar-refresh,
	speedbar-generic-item-info, speedbar-item-info-file-helper,
	speedbar-item-delete, speedbar-insert-generic-list,
	speedbar-timer-fn, speedbar-check-vc-this-line,
	speedbar-check-obj-this-line, speedbar-fetch-dynaic-etags,
	speedbar-buffers-item-info) Use speedbar-message.
	(speedbar-item-info) Limit `message-log-max'.
	(speedbar-item-load, speedbar-item-copy, speedbar-item-rename,
	speedbar-item-delete, speedbar-item-object-delete,
	speedbar-buffer-kill-buffer) Use speedbar-y-or-n-p.

1999-03-10  Kenichi Handa  <handa@mulelab.etl.go.jp>

	* server.el (server-start): Set coding system for the server
	process to raw-text.
	(server-process-filter): Decode file names if necessary.

1999-03-12  Dave Love  <fx@gnu.org>

	* textmodes/fill.el (sentence-end-double-space): Doc fix.

	* textmodes/paragraphs.el (sentence-end): Doc fix.

1999-03-11  Karl Heuer  <kwzh@gnu.org>

	* comint.el (comint-password-prompt-regexp): Accept "login password:"

1999-03-09  Karl Heuer  <kwzh@gnu.org>

	* ispell.el (ispell-dictionary-alist-1): Shorten autoloaded line.
	(ispell-dictionary-alist-2): Likewise.
	(ispell-dictionary-alist-3, ispell-dictionary-alist-4): New vars.
	(ispell-dictionary-alist-5, ispell-dictionary-alist-6): New vars.
	(ispell-dictionary-alist): Build from six pieces, not just two.

	* ps-bdf.el (bdf-directory-list): Doc fix.

	* enriched.el (enriched-mode): Make var permanent-local.

1999-03-09  Dave Love  <fx@gnu.org>

	* textmodes/sgml-mode.el (html-mode): Use
	sentence-end-double-space when setting sentence-end.

1999-03-09  Ken'ichi Handa  <handa@gnu.org>

	* language/thai.el (tis-620): New alias coding system for thai-tis620.

1999-03-08  Felix Lee  <flee@cygnus.com>

	* textmodes/flyspell.el (flyspell-mode-on): Use change-major-mode-hook.

	* textmodes/outline.el (outline-back-to-heading): Fix invisible-ok.

1999-03-08  Karl Heuer  <kwzh@gnu.org>

	* dired-aux.el (dired-do-copy-regexp): Doc fix.
	(dired-do-hardlink-regexp, dired-do-symlink-regexp): Doc fix.

	* dired.el (dired-do-copy-regexp): Doc fix.
	(dired-do-hardlink-regexp, dired-do-symlink-regexp): Doc fix.

1999-03-08  Roger Breitenstein  <roger.breitenstein@starfish.com>

	* mail/smtpmail.el (smtpmail-do-bcc): Fix regexp.

1999-03-08  Jason Rumney  <jasonr@altavista.net>

	* international/codepage.el (cp1250-decode-table)
	(cp1251-decode-table, cp1253-decode-table)
	(cp1257-decode-table): New translation tables for MS Windows codepages.
	(cp-make-coding-systems-for-codepage): Accept 4 digit codepages.

1999-03-07  Yoshiki Hayashi  <g740685@komaba.ecc.u-tokyo.ac.jp>

	* textmodes/texinfmt.el (texinfo-append-refill): Check @c correctly.

1999-03-07  Eli Zaretskii  <eliz@gnu.org>

	* ps-bdf.el (bdf-directory-list): Different value for ms-dos.

	* term/internal.el (top level): Display character 255 as 8bit as well.

1999-03-06  Dave Love  <fx@gnu.org>

	* progmodes/cc-cmds.el (c-outline-level): Bind
	buffer-invisibility-spec.

	* progmodes/c-mode.el (c-outline-level): Likewise.

	* progmodes/ada-mode.el (ada-outline-level): Likewise.

1999-03-05  Felix Lee  <flee@cygnus.com>

	* textmodes/outline.el (outline-get-last-sibling): Doc fix.

1999-03-05  Richard M. Stallman  <rms@gnu.org>

	* bindings.el (complete-symbol): Invert meaning of prefix arg.

1999-03-05  Andrew Innes  <andrewi@gnu.org>

	* w32-fns.el (convert-standard-filename): Convert directory
	separators to Windows format.

1999-03-05  Andreas Schwab  <schwab@gnu.org>

	* international/skkdic-cnv.el: Provide skkdic-cnv.
	(skkdic-convert): Emit code to require skkdic-cnv at compile time.
	(batch-skkdic-convert): Doc fix.

1999-03-04  Dave Love  <fx@gnu.org>

	* custom.el (custom-set-variables): Protect against setter errors.

1999-03-04  Eli Zaretskii  <eliz@gnu.org>

	* ls-lisp.el (ls-lisp-insert-directory): Protect the sum total of
	the file sizes from overflowing.
	(ls-lisp-format): If file size is a float, use %8.0f to print it.
	Under -s, print the size in blocks with %4.0f, in case they have
	a *really* huge file.

1999-03-03  Dave Love  <fx@gnu.org>

	* options.el (edit-options): Doc fix.
	(list-options): Don't lose with unbound symbols.  Maintain
	Edit-options-mode.

1999-03-01  Dave Love  <fx@gnu.org>

	* mail/supercite.el (sc-attrib-selection-list): Fix custom type.

1999-02-28  Richard M. Stallman  <rms@gnu.org>

	* ispell.el (ispell-dictionary-alist-override): New variable.
	(ispell-dictionary-alist): Don't setq it,
	if ispell-dictionary-alist-override is set.

	* simple.el (shell-command-default-error-buffer): Renamed from
	shell-command-on-region-default-error-buffer.
	(shell-command-on-region): Mention in echo area when there
	is some error output.  Mention success or failure, too.
	Accumulate multiple error outputs
	going forward, with formfeed in between.  Display the error buffer
	when we have put something in it.
	(shell-command): Add the ERROR-BUFFER argument feature.

1999-02-28  Karl Heuer  <kwzh@gnu.org>

	* mail/mh-utils.el (mh-lib): Doc fix.
	(mh-lib-progs, mh-nmh-p): New vars.
	(mh-find-progs): Set mh-lib-progs along with other vars.
	(mh-path-search): New arg FUNC-P; if specified, use that instead
	of mh-file-command-p.
	(mh-install, mh-exec-lib-cmd-output): Use mh-lib-progs.

	* mail/mh-comp.el (mh-repl-formfile): New var.
	(mh-smail-batch): Don't ignore all arguments.
	(mh-reply): Do the right thing when using nmh.

1999-02-27  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (select-safe-coding-system): Be sure
	to show a buffer being decoded.

1999-02-26  Ken'ichi Handa  <handa@gnu.org>

	* ps-bdf.el (bdf-directory-list): Initialize it to
	'("/usr/local/share/emacs/fonts/bdf").

1999-02-25  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: PostScript programming fix.
	(ps-print-prologue-1): Fix BeginDoc PostScript procedure (don't use
	setpagedevice operator).

1999-02-25  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Doc fix, font size specifies landscape and portrait
	sizes.
	(ps-print-version): New version number (4.1.4).
	(ps-font-size, ps-header-font-size, ps-header-title-font-size):
	Specifies landscape and portrait sizes.
	(ps-setup, ps-print-quote, ps-line-lengths-internal, ps-nb-pages)
	(ps-get-page-dimensions, ps-begin-file, ps-begin-job, ps-generate): Fun
	fix.
	(ps-get-font-size): New fun.
	(ps-font-size-internal, ps-header-font-size-internal)
	(ps-header-title-font-size-internal): New vars.

	* ps-mule.el: Change of ps-print font size variable name.
	(ps-mule-generate-font): Fun fix.
	(ps-mule-begin-job): Programming uniformization.

1999-02-25  Dave Love  <fx@gnu.org>

	* help.el (help-xref-info-regexp): Allow linebreaks and capital.
	(help-make-xrefs): Do Info case first.

	* repeat.el: Don't require advice.
	(repeat-last-kill-command): Variable deleted.

1999-02-25  Richard Stallman  <rms@gnu.org>

	* simple.el (shell-command-on-region): Don't go into the REPLACE = t
	case just because the current buffer is the output buffer.

1999-02-25  Kenichi Handa  <handa@etl.go.jp>

	* simple.el (what-cursor-position): To show the character's
	encoding, use encoded-string-description instead of information
	of chaset-origin-alist.

	* international/mule-cmds.el (iso-2022-control-alist): New variable.
	(encoded-code-description): New function.
	(encoded-string-description): New function.
	(encode-coding-char): New function.

1999-02-25  Andrew Innes  <andrewi@gnu.org>

	* startup.el (command-line) [windows-nt]: Fix typo in regexp
	checking for .emacs[.el[c]].

1999-02-24  Richard Stallman  <rms@gnu.org>

	* help.el (describe-function-1): Don't print a whole lambda-function.

1999-02-23  Ken'ichi Handa  <handa@gnu.org>

	* international/encoded-kb.el (encoded-kbd-handle-8bit): Allow
	inputting ?\240.

1999-02-23  Karl Heuer  <kwzh@gnu.org>

	* term/vt100.el (vt100-wide-mode): Use defvar, not defconst.

	* midnight.el (clean-buffer-list-kill-regexps): Doc fix.
	(clean-buffer-list-kill-buffer-names): Doc fix.

	* gud.el (gud-jdb-massage-args): Spelling fix.

1999-02-23  Richard M. Stallman  <rms@gnu.org>

	* subr.el (with-temp-message): Use %s so % in old msg won't fool us.

1999-02-22  Eli Zaretskii  <eliz@gnu.org>

	* arc-mode.el (archive-set-buffer-as-visiting-file): Save
	excursion while calling set-auto-coding-function.

	* play/handwrite.el (handwrite): Require ps-print, and use
	ps-printer-name and ps-lpr-command.  Call ps-print-region-function
	if it's defined, instead of forking ps-lpr-command unconditionally.

1999-02-22  Kenichi Handa  <handa@etl.go.jp>

	* international/codepage.el (cp-coding-system-for-codepage-1): Put
	charset-origin-alist property to a coding system for the codepage.

	* international/mule.el: Modify comment for charset-origin-alist
	property of a coding system.

	* simple.el (what-cursor-position): charset-origin-alist property
	of a coding system may be a translation table or a symbol of which
	`translation-table' property is a translation table.

1999-02-21  Richard Stallman  <rms@gnu.org>

	* textmodes/sgml-mode.el (html-tag-alist): Add /head and /body
	to the "html" template.

1999-02-21  Peter Breton  <pbreton@ne.mediaone.net>

	* dirtrack.el (dirtrack): Added docstring.  Now returns input.

1999-02-18  Peter Breton  <pbreton@ne.mediaone.net>

	* dirtrack.el (dirtrack): Check for the prompt in the input string
	instead of the buffer.

1999-02-18  Alex Schroeder  <a.schroeder@bsiag.ch>

	* sql.el: Set version to 1.4.1.  Changed mail address to
	alex@gnu.org.  Mention the mailing list sql.el@gnu.org.
	(sql-input-ring-separator): Doc fix.
	(sql-mode-syntax-table): double-dash starts comments is defined as
	". 56" instead of ". 12b" for XEmacs.
	(sql-stop, sql-interactive-mode): Doc fixes.
	(sql-postgres): Queries for database and server, not just one.
	(sql-set-sqli-buffer): sql-set-sqli-hook must be quoted.

	* sql.el (sql-set-sqli-hook): A hook run when sql-buffer is
	changed.  This is needed for master.el to work.
	(sql-set-sqli-buffer): Use the new hook.

	* sql.el (sql-make-alternate-buffer-name): Function that sets
	sql-alternate-buffer-name.
	(sql-alternate-buffer-name): Possible name of SQLi buffers.
	(sql-interactive-mode): Set sql-alternate-buffer-name.
	(sql-rename-buffer): New command.
	(sql-interactive-mode-menu): Menu for SQLi buffers.

	* sql.el (sql-interactive-mode): Doc fix.  sql-input-ring-separator
	and sql-input-ring-file-name are used to temporarily set
	comint-input-ring-file-name and comint-input-ring-separator when
	reading and writing input history files.

	(sql-stop): Use sql-input-ring-separator and sql-input-ring-file-name.
	(sql-input-ring-file-name): New variable with customization.
	(sql-input-ring-separator): New variable with customization.
	(sql-set-sqli-buffer): Renamed from sql-change-sqli-buffer.
	Callers changed.
	(sql-show-sqli-buffer): The message for "sql-buffer is not set"
	now includes the name of the current buffer.

	(sql-mode): Set paragraph-separate and paragraph-start so that
	sql-send-paragraph sends the entire SQL statements, even if it
	contains indented lines.

1999-02-18  Dave Love  <fx@gnu.org>

	* format.el (format-encode-run-method, format-decode-run-method):
	Fix previous change.

1999-02-18  Ken'ichi Handa  <handa@gnu.org>

	* international/mule.el (coding-system-list): Moved here from
	mule-util.el to avoid autoloading mule-util by the call of
	select-safe-coding-system.

1999-02-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* simple.el (turn-on-auto-fill): Mark it as an option for
	`text-mode-hook'.

1999-02-17  Richard Stallman  <rms@gnu.org>

	* emacs-lisp/easymenu.el (easy-menu-get-map):
	Don't crash if (current-local-map) is nil.

1999-02-17  Peter Breton  <pbreton@ne.mediaone.net>

	* filecache.el (file-cache-filter-regexps): Added .class.

1999-02-17  Ken'ichi Handa  <handa@gnu.org>

	* international/mule-util.el (decompose-region): Use
	insert-buffer-substring instead of insert-buffer to avoid putting
	mark.

1999-02-17  Andreas Schwab  <schwab@gnu.org>

	* calendar/cal-move.el (scroll-calendar-left): Don't set
	displayed-month and displayed-year here, let generate-calendar do
	it, after range checking.

1999-02-17  Simon Marshall  <simon@gnu.org>

	* progmodes/cc-engine.el (c-at-toplevel-p): New function.

	* font-lock.el (c++-font-lock-keywords-3): Use it to distinguish
	correctly between an object declared via a constructor and a method.
	(font-lock-defaults-alist): Don't give `.' word syntax for Java.
	(java-font-lock-keywords-1): Fontify package names individually.
	(java-font-lock-extra-types): Ensure regexp matches capitalised only.
	(java-font-lock-keywords-2): Simplify type fontification.
	(java-font-lock-keywords-3): Likewise.

1999-02-17  Kenichi Handa  <handa@etl.go.jp>

	* language/japanese.el (iso-2022-jp-2): New coding system.
	("Japanese"): Put iso-2022-jp-2 in coding-priority property.

1999-02-16  Dave Love  <fx@gnu.org>

	* help.el (describe-function-1): Accept non-symbols.

1999-02-16  Paul Eggert  <eggert@twinsun.com>

	* dired.el (dired-move-to-filename-regexp): Prepend .* so that we
	find the last match if there are multiple matches.

1999-02-16  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* tex-mode.el (tex-run-command, latex-run-command)
	(slitex-run-command, tex-command): Doc changes.
	(tex-start-options-string): Autoload it.  Doc change.  Provide
	a menu for customization.  Allow nil.  Quote backslashes only once.
	(tex-start-tex): Handle nil value of tex-start-options-string
	and apply shell-quote-argument to it.

1999-02-16  Eli Zaretskii  <eliz@gnu.org>

	* ls-lisp.el (ls-lisp-insert-directory): Call fceiling to round
	the size in blocks, since it can be a float.
	(ls-lisp-format): Likewise

1999-02-16  Ken'ichi Handa  <handa@gnu.org>

	* language/japanese.el (japanese-shift-jis): Add
	charset-origin-alist property.

1999-02-15  Richard Stallman  <rms@gnu.org>

	* progmodes/compile.el (compile-internal): Use save-selected-window.

	* subr.el (momentary-string-display): Bind inhibit-read-only.

	* speedbar.el (speedbar-item-info-tag-helper): Scan the whole line.

1999-02-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* mail/rmail.el (rmail-show-message): If an unseen message has a
	Summary-line in its header, get past one more line before looking
	for the X-Coding-System header.

1999-02-15  Geoff Voelker  <voelker@cs.washington.edu>

	* makefile.nt (INSTALL): Copy the handful of uncompiled lisp files
	explicitly to accomodate Windows 9X lack of a useful copy program.

1999-02-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* wid-edit.el (widget-choice-value-create): Use `equal'
	instead of `eq'.

1999-02-14  Richard Stallman  <rms@gnu.org>

	* international/iso-transl.el:
	(iso-transl-ae): Renamed from iso-transl-e-slash.
	(iso-transl-a-ring): Renamed from iso-transl-a-slash.
	(iso-transl-AE): Renamed from iso-transl-E-slash.
	(iso-transl-A-ring): Renamed from iso-transl-A-slash.
	(iso-transl-char-map): Related changes.

	* format.el (format-replace-strings): Fix value of TO in REVERSE case.

1999-02-13  Richard Stallman  <rms@gnu.org>

	* textmodes/texinfmt.el (texinfo-alias): New function.
	(texinfo-fold-nodename-case): Add defvar.
	(texinfo-format-node): Do case folding if specified.

	* ffap.el (ffap-file-at-point): Test local file names
	immediately.  Strip off line numbers.

1999-02-12  Alex Schroeder  <a.schroeder@bsiag.ch>

	* sql.el: Set version to 1.3.2
	(sql-solid-program): Added support for solid.
	(sql-help): Doc mentions sql-solid.
	(sql-solid): Entry function for Solid.
	(sql-buffer): Doc explains the use of the variable and how to
	change it.
	(sql-mode-menu): Included entries for sql-show-sqli-buffer and
	sql-change-sqli-buffer; sql-send-region and sql-send-buffer are
	disabled if sql-buffer doesn't have a process; sql-send-paragraph
	is new.
	(sql-show-sqli-buffer): New function to display the value of
	sql-buffer.
	(sql-change-sqli-buffer): New function to change sql-buffer.
	(sql-mode): Doc explains how to change sql-buffer.
	(sql-send-paragraph): New function to send a paragraph.
	(sql-mode-map): Added keybinding for sql-send-paragraph.
	(sql-mysql): Doc corrected.
	(sql-ms): Doc corrected.

	* sql.el (sql-server): Doc fix.
	(sql-mysql): Added the use of sql-server to specify the host,
	sql-database now specifies database instead of host.
	(sql-mode-menu): Send... menu items are only active if sql-buffer
	is non-nil.
	(sql-help): Changed tag of entry functions a bit.

	* sql.el: Added keywords from `finder-by-keyword'.
	(sql-mode): Made sql-buffer a local variable, changed the
	documentation: removed instructions to add *.sql files to
	auto-mode-alist, added documentation for having mutliple SQL
	buffers sending their stuff to different SQLi buffers, each
	running a different process.
	(sql-postgres): Quoted *SQL* in doc string.
	(sql-ms): Likewise.
	(sql-ingres): Likewise.
	(sql-ingres): Quoted *SQL* in doc string, added references to
	sql-user and sql-password used during login.
	(sql-sybase): Quoted *SQL* in doc string, added comma.
	(sql-oracle): Likewise.
	(sql-interactive-mode): Added extensive documentation for having
	mutliple SQL buffers sending their stuff to different SQLi
	buffers, each running a different process.
	(sql-buffer): Changed doc from *SQL* to SQLi.
	(sql-get-login): Doc fix.

1999-02-12  Ken'ichi Handa  <handa@gnu.org>

	* international/mule-conf.el (undecided): Set ascii in
	safe-charsets property.

1999-02-12  Richard Stallman  <rms@gnu.org>

	* textmodes/paragraphs.el (paragraph-separate): Doc fix.

1999-02-12  Ken'ichi Handa  <handa@gnu.org>

	* ps-mule.el (ps-mule-font-info-database-default): Set the initial
	value to ps-mule-font-info-database-latin.

1999-02-13  Kenichi HANDA  <handa@etl.go.jp>

	* ps-mule.el (ps-multibyte-buffer): Doc-string modified.
	(ps-mule-font-info-database-default): New variable.
	(ps-mule-begin-job): If ps-multibyte-buffer is nil, use
	ps-mule-font-info-database-default.

1999-02-12  Dave Love  <fx@gnu.org>

	* timezone.el (timezone-make-date-sortable)
	(timezone-make-date-arpa-standard): Doc fix.

1999-02-12  Ken'ichi Handa  <handa@gnu.org>

	* international/quail.el (quail-show-kbd-layout): Bind
	blink-matching-paren to nil.

	* ps-mule.el (ps-mule-font-info-database-bdf): Fix ENCODING field
	for ASCII and Latin-1.

1999-02-12  Andreas Schwab  <schwab@gnu.org>

	* gud.el (jdb): Fix regexp for comint-prompt-regexp.

1999-02-12  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (language-info-alist): Remove
	description about charset-origin-alist.

	* international/mule.el: Comment added for a new coding system
	property `charset-origin-alit'.
	(make-translation-table): This variable deleted.

	* language/chinese.el (chinese-big5): Add charset-origin-alist
	property.
	("Chinese-CNS"): Remove charset-origin-alist property.

	* language/cyrillic.el (cyrillic-koi8): Add charset-origin-alist
	property.
	(cyrillic-alternativnyj): Likewise.
	("Cyrillic-KOI8"): Remove charset-origin-alist property.
	("Cyrillic-ALT"): Likewise.

	* language/vietnamese.el (vietnamese-viqr): Add
	charset-origin-alist property.
	("Vietnamese"): Remove charset-origin-alist property.

	* simple.el (what-cursor-position): Don't use the varialbe
	charset-origin-alist, but use charset-origin-alist property of
	buffer-file-coding-system to decide external character set code.

1999-02-10  Richard Stallman  <rms@gnu.org>

	* shadowfile.el: Don't turn on the mode when the file is loaded.

1999-02-09  Richard Stallman  <rms@gnu.org>

	* progmodes/compile.el (compile-auto-highlight): Customize.

	* add-log.el (add-log-file-name-function): New variable.
	(add-change-log-entry): Call that function, if non-nil.

1999-02-09  Michael Ernst  <mernst@alum.mit.edu>

	* rmail.el (rmail-search): Track match with a marker, not an integer.

1999-02-08  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* progmodes/compile.el (compilation-setup): Set value of
	compilation-directory-stack as in compilation-forget-errors.
	(compile-reinitialize-errors): Bind buffer-undo-list and
	deactivate-mark.
	(compilation-forget-errors): Likewise.

1999-02-08  Jim Blandy  <jimb@savonarola.red-bean.com>

	* textmodes/texinfo.el (texinfo-environment-regexp): Add the
	def... constructs.

	* texnfo-upd.el (texinfo-all-menus-update, texinfo-master-menu):
	Remove calls to sleep-for.

1999-02-08  Eli Zaretskii  <eliz@gnu.org>

	* international/codepage.el (cp-coding-system-for-codepage-1): On
	MS-DOS, use dos-unsupported-char-glyph for characters not
	supported by the codepage.
	(cp-make-coding-systems-for-codepage): Likewise.

1999-02-08  Andreas Schwab  <schwab@gnu.org>

	* international/mule-util.el (coding-system-list): Don't sort
	coding-system-list here.

	* international/mule.el (coding-system-lessp): Moved here from
	mule-util.el
	(add-to-coding-system-list): New function.
	(make-subsidiary-coding-system, make-coding-system,
	define-coding-system-alias): Use it instead of setting
	coding-system-list directly.

1999-02-07  Dave Love  <fx@gnu.org>

	* calendar/appt.el (appt-make-list): Don't splice quotes and date
	onto message.

1999-02-06  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* imenu.el (imenu--last-menubar-index-alist): Add doc.
	(imenu-add-to-menubar): Reset imenu--last-menubar-index-alist.

1999-02-06  Richard Stallman  <rms@gnu.org>

	* language/european.el (setup-slovenian-environment): New function.
	("Slovenian"): New language environment.

	* progmodes/sql.el (sql-help): Doc fix.
	(sql-mysql): Doc fix.

1999-02-05  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* tex-mode.el: When compiling, require compare-w and skeleton
	to pacify the byte-compiler.  Move the def's of the tex-commands
	together.  Add a comment on kill-process vs. quit-process.

1999-02-05  Dave Love  <fx@gnu.org>

	* progmodes/compile.el (compile-mouse-goto-error): Don't lose with
	null markers.
	(compile-goto-error): Likewise.

1999-02-05  Stephen Gildea  <gildea@stop.mail-abuse.org>

	* time-stamp.el (time-stamp-format): Format doc tighter.
	(time-stamp-line-limit): 0 searches the entire buffer (careful!).
	(time-stamp): Don't re-write the time stamp if it didn't change.

1999-02-05  Alex Schroeder  <asc@bsiag.com>

	* progmodes/sql.el: Changed version to 1.2.1.
	(sql-pop-to-buffer-after-send-region): Improved documentation.
	(sql-mysql-program): Added MySQL support.
	(sql-prompt-length): Made prompt-length configurable.
	(sql-mode-syntax-table): Made apostrophe (') be a string delimiter.
	(sql-help): Added MySQL support, changed documentation.
	(sql-send-region): A message is displayed if something is sent.
	(sql-mode): Added buffer-local comment-start.
	(sql-interactive-mode): Use sql-prompt-length to set left-margin.
	(sql-interactive-mode): Added buffer-local comment-start.
	(sql-oracle): Set sql-prompt-length.
	(sql-sybase): Set sql-prompt-length.
	(sql-mysql): Added MySQL support.
	(sql-ingres): Set sql-prompt-length.
	(sql-ms): Set sql-prompt-length.
	(sql-postgres): Set sql-prompt-length.

1999-02-04  Eli Zaretskii  <eliz@gnu.org>

	* term/internal.el (dos-codepage-setup): Set selection coding
	system to cpNNN-dos.

1999-02-03  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* international/characters.el: Let ethiopic use iso-2022-7bit.

1999-02-02  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el (mark-fortran-subprogram): Activate mark here...
	(fortran-narrow-to-subprogram, fortran-indent-subprogram): ...not here.

1999-02-02  Karl Heuer  <kwzh@gnu.org>

	* terminal.el (terminal-emulator): Doc fix.

1999-02-02  Ken'ichi Handa  <handa@gnu.org>

	* international/mule-util.el (compose-chars): Doc-string
	modified.  Correctly handle a composition character in ARGS.

1999-02-01  Richard Stallman  <rms@gnu.org>

	* progmodes/make-mode.el (makefile-imenu-generic-expression): New var.
	(makefile-menu-index-function): Function deleted.
	(makefile-mode): Use makefile-imenu-generic-expression.

1999-02-01  Geoff Voelker  <voelker@cs.washington.edu>

	* term/w32-win.el (w32-create-initial-fontsets): Back out previous
	change, invoke from before-init-hook.

1999-02-01  Dan Nicolaescu  <done@ece.arizona.edu>

	* subr.el (remove-from-invisibility-spec): Cope with the case when
	buffer-invisibility-spec is t.

1999-02-01  Ed Reingold  <reingold@cs.uiuc.edu>

	* calendar/calendar.el (calendar-mode-map): Fix bindings for
	appt-add and appt-delete.

1999-02-01  Eli Zaretskii  <eliz@gnu.org>

	* term/pc-win.el (msdos-approximate-color): New function.
	(msdos-color-translate): Call it to find a DOS color that best
	approximates an X-style "#NNNNNN" color specification.

1999-02-01  Ken'ichi Handa  <handa@gnu.org>

	* international/mule-util.el (compose-chars-component): Add
	autoload cookie.

1999-01-31  Ken'ichi Handa  <handa@gnu.org>

	* international/quail.el (quail-lookup-key): If cdr of MAP is a
	function, replace cdr of MAP by the return value of the function
	unconditionally.

1999-01-31  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* progmodes/compile.el (compilation-next-error-locus): Don't
	decrease argument FIND-AT-LEAST of compilation-next-error-locus.

1999-01-31  Eli Zaretskii  <eliz@gnu.org>

	* mail/rmail.el (rmail-mime-charset-pattern): Add optional TABs
	and NLs before "charset", and allow the charset name be in double
	quotes.

1999-01-31  Richard Stallman  <rms@gnu.org>

	* imenu.el (imenu-sort-function): Fix custom type.

1999-01-30  Richard Stallman  <rms@gnu.org>

	* speedbar.el (speedbar-line-token): Match {...} instead of [...].
	(speedbar-line-token): Likewise.

	* play/gametree.el (gametree-default-score): Use defcustom.
	(gametree-score-regexp, gametree-score-closer): Likewise.
	(gametree-score-manual-flag, gametree-score-opener): Likewise.

1999-01-29  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* mail/rmail.el (rmail-decode-babyl-format): Avoid locking when
	decoding.

1999-01-29  Markus Rost  <rost@gnu.org>

	* tex-mode.el (tex-mode-map): Replace validate-tex-buffer by
	tex-validate-buffer.
	(plain-tex-mode, latex-mode, slitex-mode): Likewise.
	(tex-validate-buffer): Renamed from validate-tex-buffer.  Works
	now with recent occur-mode.
	(tex-validate-region): Really walk through all Sexps.
	(tex-region): Bind shell-dirtrack-verbose.
	(tex-file, tex-bibtex-file): Likewise.

1999-01-29  Dave Love  <fx@gnu.org>

	* finder.el (finder-commentary): Fix interactive spec.
	Try appending .el to file name.
	(finder-find-library, finder-commentary): Doc fixes.

1999-01-29  Andrew Innes  <andrewi@gnu.org>

	* mail/rmail.el (rmail-insert-inbox-text): Handle POP mailboxes
	where the userid contains directory separators.

1999-01-29  Dave Love  <fx@gnu.org>

	* emacs-lisp/lisp-mnt.el (lm-verify): Fix arg list.
	(lm-commentary): Doc fix.

1999-01-29  Andreas Schwab  <schwab@gnu.org>

	* files.el (file-expand-wildcards): Never consider `.' and `..' a
	wildcard match.  Fix regexp that tests if dirpart contains
	wildcard characters.

1999-01-28  Richard Stallman  <rms@gnu.org>

	* font-lock.el (font-lock-default-unfontify-region):
	If not font-lock-syntactic-keywords, don't remove syntax-table prop.

1999-01-27  Jason Rumney  <jasonr@altavista.net>

	* term/w32-win.el (w32-standard-fontset-spec): Remove wildcard
	from FAMILY field.
	(w32-create-initial-fontsets): Do not use before-init-hook.
	(mouse-set-font): Document.  Automatically create and use fontsets.

	* dos-w32.el (direct-print-region-helper): Check for printer
	being t as well as a string.

1999-01-27  Kenichi Handa  <handa@etl.go.jp>

	* mail/rmail.el (rmail-decode-mime-charset): New variable.
	(rmail-mime-charset-pattern): New variable.
	(rmail-convert-to-babyl-format): Decode by MIME-charset if
	rmail-decode-mime-charset is non-nil.

1999-01-27  Ken'ichi Handa  <handa@gnu.org>

	* international/characters.el: Set category `q' for all characters
	in tibetan and tibetan-1-column.

1999-01-27  Andrew Innes  <andrewi@gnu.org>

	* frame.el (select-frame-by-name): Obey focus-follows-mouse.
	(select-frame-by-name) [windows-nt]: Use w32-focus-frame.

1999-01-27  Dave Love  <fx@gnu.org>

	* international/mule-cmds.el (current-language-environment):
	Provide :link, :type (choices) and appropriate :get.

1999-01-27  Eli Zaretskii  <eliz@gnu.org>

	* startup.el (command-line): Set default eol-mnemonic-* strings to
	display end-of-line format in mode line.

	* cus-start.el (all): Add eol-mnemonic-* variables.

1999-01-26  Dave Love  <fx@gnu.org>

	* startup.el (command-line-1): Up-date copyright.

	* paths.el (Info-default-directory-list): Use configdir twice.

	* info.el (Info-directory-list): Don't set path-separator now
	we're not shipped with Texinfo.  Simplify path definition.
	Substitute all occurrences of instdir in Info-default-directory-list.

1999-01-25  Richard Stallman  <rms@gnu.org>

	* startup.el (normal-top-level-add-subdirs-to-load-path):
	Record the inode numbers of the dirs processed, to avoid loop.

	* textmodes/tex-mode.el (tex-run-command): Doc fix.

1999-01-25  Dave Love  <fx@gnu.org>

	* browse-url.el (browse-url-netscape-program): Doc addition.

	* help.el (help-make-xrefs): Default info references to an `(emacs)'
	prefix.

	* snmp-mode.el (snmpv2-mode, snmpv-mode): Add autoload cookies -- see
	auto-mode-alist.

1999-01-25  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* calendar/diary-lib.el (mark-diary-entries): Use
	assoc-ignore-case and do not capitalize when matching month and
	day names.

	* calendar/calendar.el (calendar-read-date): Ditto.

	* calendar/cal-hebrew.el (calendar-goto-hebrew-date)
	(mark-hebrew-diary-entries, list-yahrzeit-dates): Ditto.

	* calendar/cal-coptic.el (coptic-prompt-for-date): Ditto.

	* calendar/cal-french.el (calendar-goto-french-date): Ditto.

	* calendar/cal-islam.el (calendar-goto-islamic-date)
	(mark-islamic-diary-entries): Ditto.

	* calendar/cal-julian.el (calendar-goto-julian-date): Ditto.

	* calendar/cal-mayan.el (calendar-read-mayan-haab-date)
	(calendar-read-mayan-tzolkin-date): Ditto.

	* calendar/cal-persia.el (persian-prompt-for-date): Ditto.

1999-01-22  Michael Ernst  <mernst@alum.mit.edu>

	* texnfo-upd.el (texinfo-make-menu): Make region-end a marker.

1999-01-25  Karl Heuer  <kwzh@gnu.org>

	* faces.el (list-faces-display): Multiline case of previous fix.

1999-01-25  Andreas Schwab  <schwab@gnu.org>

	* mail/mailalias.el (mail-complete-alist): Use alist as customize type.

1999-01-24  Richard M. Stallman  <rms@borg.ai.mit.edu>

	* files.el (find-file): If find-file-noselect returns a list,
	do switch-to-buffer on each element.
	(find-file-other-window): Likewise for all but the first element.
	(find-file-other-frame): Same.
	(find-file-noselect): When we expand a wildcard, return a list
	of buffers.

1999-01-24  Eli Zaretskii  <eliz@gnu.org>

	* term/internal.el (dos-codepage-setup): Call prefer-coding-system
	to set the appropriate cpNNN-dos coding system as the
	highest-priority coding system.

1999-01-23  Ken'ichi Handa  <handa@gnu.org>

	* international/fontset.el (generate-fontset-menu): Return a
	sorted list by plain names of fontsets.

	* international/mule-diag.el (list-fontsets): Sort fontsets by
	plain names.

	* language/tibet-util.el (tibetan-vertical-stacking): If the arg
	FIRST is a composite character, decompose it at first.

1999-01-23  Dave Love  <fx@gnu.org>

	* format.el: Doc fixes.
	(format-encode-run-method): Have things happen in the right buffer.
	Deal with errors from method.  Set coding-system-for-write.
	(format-decode-run-method): Have things happen in the right buffer.
	Deal with errors from method.  Set coding-system-for-read.
	(format-alist): Use nil instead of unmatchable regexps.

	* simple.el (shell-command-on-region): Return command's exit status.

1999-01-23  Eric Ludlam  <zappo@gnu.org>

	* speedbar.el (speedbar-item-info-file-helper): Add optional arg
	of the file whose info we want to display.
	(speedbar-easymenu-definition-trailer) Fix list issue w/ customize.
	(speedbar-add-mode-functions-list) Improve doc.
	(speedbar-line-token) New function.
	(speedbar-dired) Fix order of directories in -shown-directories.
	(speedbar-line-path): Default return is default-directory
	(speedbar-buffers-line-path): Return is dir name only.
	(speedbar-mode-functions-list): New variable.
	(speedbar-mouse-item-info): Rewrote to be a replaceable fn.
	(speedbar-item-info-file-helper, speedbar-item-info-tag-helper
	speedbar-files-item-info speedbar-buffers-item-info): New functions.
	(speedbar-fetch-replacement-function,speedbar-add-mode-functions-list):
	New functions.
	(speedbar-line-file): Broke out part that fetches file from a line.
	(speedbar-line-text): New function extracted from speedbar-line-file.
	(speedbar-line-path): Converted into a replaceable function.
	(speedbar-files-line-path, speedbar-buffers-line-path): New functions.

1999-01-23  Ken'ichi Handa  <handa@gnu.org>

	* international/fontset.el (create-fontset-from-x-resource): Make
	style variants.

1999-01-22  Dave Love  <fx@gnu.org>

	* paths.el (Info-default-directory-list): Put sysdir after start.

1999-01-22  Sam Steingold  <sds@goems.com>

	* midnight.el (clean-buffer-list): Do not kill a buffer if it has
	a process associated with it.

1999-01-22  Jason Rumney  <jasonr@altavista.net>

	* term/w32-win.el (w32-standard-fontset-spec): Simplified.

1999-01-22  Felix Lee  <flee@cygnus.com>

	* vc.el (vc-annotate-display): Delete old overlays.  Fix check for
	major-mode.
	(vc-annotate-mode): Delete variable.

1999-01-22  Andrew Innes  <andrewi@gnu.org>

	* startup.el (command-line): [windows-nt]: Check for existence of
	.emacs file so as to notice .emacs.el or .emacs.elc and use them
	in preference to _emacs.

1999-01-22  Dave Love  <fx@gnu.org>

	* textmodes/texinfo.el (texinfo-font-lock-keywords): Match @ref.

1999-01-20  Richard Stallman  <rms@gnu.org>

	* files.el (find-file-noselect): Do wildcard processing only
	if new arg WILDCARDS is non-nil.
	(find-file, find-file-other-window): New arg WILDCARDS.
	Default it to non-nil if interactive.
	(find-file-other-frame): Likewise.
	(find-file-read-only): Likewise.
	(find-file-read-only-other-window): Likewise.
	(find-file-read-only-other-frame): Likewise.

	* wid-edit.el (widget-alist-convert-option): Delete spurious comma.
	(widget-plist-convert-option): Delete spurious comma.

1999-01-19  Jason Rumney  <jasonr@altavista.net>

	* term/w32-win.el (w32-standard-fontspec-spec): Change
	iso8859-5 to koi8-r.  Add iso8859-9.

1999-01-19  Dave Love  <fx@gnu.org>

	* browse-url.el (browse-url-maybe-new-window): Delete macro and
	its uses.

	* progmodes/fortran.el (fortran-narrow-to-subprogram): Ensure mark
	is active.
	(fortran-indent-subprogram): Likewise.

1999-01-19  Dave Love  <d.love@dl.ac.uk>

	* paths.el (Info-default-directory-list): Perhaps add /usr/info.

1999-01-19  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* wid-edit.el (alist): Use sexp as default key-type.

1999-01-18  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* textmodes/tex-mode.el (tex-define-common-keys):
	Remove key binding of tex-feed-input.
	(tex-mode-map): Bind tex-feed-input here.
	(tex-start-shell): Use compilation-shell-minor-mode.  Set
	comint-input-filter-functions before running tex-shell-hook.
	(tex-start-tex): Forget compilation errors.
	(tex-compilation-parse-errors): Rewritten to work also with
	compile-mouse-goto-error and compile-goto-error.  Adjusted to
	change in tex-region.
	(tex-region): For the temp file use file-name without directory.
	(tex-file): Expand file name of tex-print-file.

1999-01-18  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* emacs-lisp/edebug.el (with-temp-message): Add def-edebug-spec call.

1999-01-18  Espen Skoglund  <espensk@stud.cs.uit.no>

	* progmodes/pascal.el (pascal-calculate-indent): Code with an invalid
	beginning could cause Emacs to hang.  Fixed.

1999-01-18  Ken'ichi Handa  <handa@gnu.org>

	* international/ccl.el (ccl-compile-translate-character): Handle
	the case that a tranlation table is CCL register correctly.

	* international/mule-cmds.el (select-safe-coding-system):
	Hightlight at most 256 characters.

1999-01-18  Dave Love  <fx@gnu.org>

	* startup.el (command-line): If the init file changes operation to
	unibyte, make all buffers unibyte and re-set language environment.

	* disp-table.el (standard-display-european): Make all existing
	buffers unibyte.  Fix doc.

1999-01-17  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* wid-edit.el (coding-system): Define this unconditionally.

	* simple.el (shell-command-on-region-default-error-buffer): New var.
	(shell-command-on-region): Use that variable as interactive
	value of ERROR-BUFFER argument.

1999-01-17  Sam Steingold  <sds@goems.com>

	* mail/rmail.el (rmail-quit): Run `rmail-quit-hook'.

1999-01-17  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* progmodes/compile.el (compilation-goto-locus): If already in the
	compilation buffer's window, keep it in that window.
	(compile-mouse-goto-error): Add Doc.  Don't play with windows.
	(compile-goto-error): Don't play with windows.

	* textmodes/tex-mode.el (latex-run-command): Doc fix.
	(tex-command): Doc fix.
	(tex-compilation-parse-errors): Doc fix.
	(tex-generate-zap-file-name): Don't start the name with -.
	(tex-expand-files): Works now also with strings ending with ":".

1999-01-17  Ian T Zimmerman  <itz@transbay.net>

	Patch failed to install:
	* gametree.el: Document scoring functionality.
	(gametree-score-regexp): Add optional plus sign.
	(gametree-score-opener): Replace `:' with `=' as the former
	conflicts with gametree-half-ply-regexp.
	(gametree-transpose-following-leaves): Add.
	(gametree-insert-new-leaf): Make modifying commands barf in read
	only buffers.
	(gametree-break-line-here): Add a call to
	`gametree-transpose-following-leaves'.  This maintains the
	necessary invariant that on each level all leaf children precede
	all nonleaf children.  This has always been implied, but left to
	the user, and, unfortunately, undocumented.

1999-01-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* wid-edit.el (plist, alist): New widget types.

1999-01-17  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el: Tidy up font-lock-keywords definitions and
	fix scope of condition-case therein.

1999-01-17  Andrew Innes  <andrewi@gnu.org>

	* dos-w32.el (find-buffer-file-type-coding-system): Use
	default-buffer-file-coding-system when file doesn't exist (and
	isn't covered by a special case) instead of forcing undecided-dos
	against the user's wishes.

	* dos-w32.el (direct-print-region-helper): New function based on
	direct-print-region-function; sends data to specified printer port
	without further translation.  Recognize and handle specially the
	standard `print' and `nprint' programs, as well as `lpr' and
	similar programs.  Only write directly to the printer port if no
	print program is specified.  Work around a bug in Windows 9x
	affecting Win32 version of Emacs by invoking command.com to write
	to the printer port instead of writing directly.
	(direct-print-region-function): Use direct-print-region-helper to
	do most of the work.
	(direct-ps-print-region-function): New function; analogue of
	direct-print-region-function for ps-print.
	(ps-lpr-command): Comment out setq; leave as example usage.
	(ps-lpr-switches): Ditto.

	* lpr.el (printer-name): Update docstring about usage on MS-DOS
	and MS-Windows.
	(lpr-command) [ms-dos, windows-nt]: Initialize to empty string on
	DOS and Windows platforms, to indicate direct printing.  Update
	the docstring accordingly.

	* ps-print.el (ps-printer-name): Update docstring about usage on
	MS-DOS and MS-Windows.
	(ps-lpr-command): Update docstring as for lpr-command.
	(ps-print-region-function): New variable.
	(ps-do-despool): Use it.
	(ps-do-despool) [ms-dos, windows-nt]: Remove special case code for
	DOS/Windows.

	* subr.el (subst-char-in-string): New function.

1999-01-17  Eli Zaretskii  <eliz@gnu.org>

	* international/codepage.el (cp852-decode-table): Fill a nil entry.

	* ps-bdf.el (bdf-cache-file): Use convert-standard-filename.
	(bdf-find-font-info): New function, looks for the first readable
	file from a list of alternatives.
	(bdf-get-bitmaps, bdf-generate-font): Call bdf-find-font-info
	instead of bdf-get-font-info.
	(bdf-generate-glyphs): If font-name is a cons cell, pass its car
	to ps-mule-generate-bitmap-glyph.

	* ps-mule.el (ps-mule-font-info-database-bdf): Add alternative
	file names that avoid clashes in DOS 8+3 namespace.  FONT-NAME can
	now be a list of alternative names.
	(ps-mule-generate-font): If FONT-NAME is a cons cell, use its car.
	(ps-mule-prepare-font): Likewise.

	* international/codepage.el (cp855-decode-table,
	cp850-decode-table): Fill some nil entries.

1999-01-16  Dave Love  <fx@gnu.org>

	* help.el (temp-buffer-setup-hook, temp-buffer-show-hook): Revert
	last change.

1999-01-15  Dave Love  <fx@gnu.org>

	* help.el (help-make-xrefs): Avoid infloop in keymap substitutions
	and change regexp for command names.
	(help-xref-go-back, function-called-at-point, symbol-file)
	(where-is): Doc fixes.
	(help-xref-go-back): Remove interactive spec.
	(describe-function-1): Fix message for alias.  Buttomize alias
	name.

	* simple.el (join-line): New alias.

1999-01-15  Johan Vromans  <jvromans@squirrel.nl>

	* forms.el (forms--show-record): Convert integers to string
	expicitly since concat will no longer accept integers.
	(forms-print): Use local `total-nb-records' since
	`forms--total-records' will be inaccessible after buffer switching.

1998-01-14  Felix Lee  <flee@cygnus.com>

	* textmodes/flyspell.el (make-flyspell-overlay): Fix front stickiness.

1999-01-14  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/easymenu.el (easy-menu-get-map): Fix bugs in prev change.

1999-01-14  Eli Zaretskii  <eliz@gnu.org>

	* international/codepage.el (cp850-decode-table): Fix previous change.

1999-01-14  Simon Marshall  <simon@gnu.org>

	* shell.el (shell-dirtrack-verbose): New custom variable.
	(shell-dirstack-message): Use it.

1999-01-14  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-conf.el: Coding system alias `dos' for
	`undecided-dos', `mac' for `undecided-mac'.

	* international/mule-cmds.el (describe-language-environment):
	Don't alter input-method-alist.

1999-01-13  Eli Zaretskii  <eliz@gnu.org>

	* international/codepage.el (cp850-decode-table): Replace nil
	entries with codes of similary looking glyphs.  (Suggested by
	Jason Rumney <jasonr@altavista.net>.)

1999-01-13  Dave Love  <fx@gnu.org>

	* browse-url.el (browse-url-netscape): Fix ineffective "-noraise".

	* emacs-lisp/find-func.el (find-function-on-key): Fix previous change.

1999-01-12  Karl Heuer  <kwzh@gnu.org>

	* files.el (auto-save-hook): Defvar this.

1999-01-12  Alex Schroeder  <asc@bsiag.com>

	* progmodes/sql.el (sql-mode-ansi-font-lock-keywords): Quote font-lock
	faces, eliminating the need to load font-lock before loading sql.
	(sql-mode-oracle-font-lock-keywords): Likewise.
	(sql-mode-postgres-font-lock-keywords): Likewise.

1999-01-11  Dave Love  <fx@gnu.org>

	* cus-start.el: Add inhibit-eol-conversion.

	* help.el (temp-buffer-setup-hook, temp-buffer-show-hook): Swap
	the values round.

1999-01-11  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* help.el (help-mode-finish): Renamed from help-mode-maybe.
	Don't switch to Help mode here.
	(temp-buffer-setup-hook): Use help-mode-finish.
	(help-mode-setup): New function.
	(temp-buffer-setup-hook): Use help-mode-setup.

	* progmodes/sql.el: New file.

	* files.el (auto-mode-alist): Add sql-mode.

	* faces.el (list-faces-display): Improve the formatting
	by computing the maximum length required for any face-name.

1999-01-10  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* progmodes/compile.el (compilation-shell-minor-mode): New function.

1999-01-10  Dan Nicolaescu  <dann@ics.uci.edu>

	* term.el (term_send_home): Change the string to
	be the same as the one emitted by xterm and consistent with the
	ones emitted by prior and next.
	(term_send_end): Likewise.

1999-01-10  Dave Love  <fx@gnu.org>

	* emacs-lisp/find-func.el (find-function-on-key): DTRT for mouse
	bindings.

1999-01-10  Eli Zaretskii  <eliz@gnu.org>

	* international/codepage.el (codepage-setup): Doc fix.
	(cp-decoding-vector-for-codepage): Likewise.

1999-01-10  Markus Rost  <rost@gnu.org>

	* cus-edit.el (custom-save-delete): First scan the custom-file.

1999-01-08  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/iso-transl.el: Define a "function name" for
	each translation that isn't ASCII.  Use these function names
	in iso-transl-char-map.

1999-01-08  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-util.el (decompose-region): Do decomposition
	on temporary unibyte buffer.

	* international/mule.el (make-char): Doc-string modified.

1999-01-07  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* simple.el (comment-region): Delete spaces only if we
	deleted a comment starter.

1999-01-07  Dave Love  <fx@gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-warnings): Doc fix.

	* emacs-lisp/edebug.el (edebug-eval-defun): Deal with defcustom
	like eval-defun does.

	* dired.el (dired-mode-map): Fix duplicate [menu-bar regexp mark].

	* generic.el: Re-write `(make-variable-buffer-local (defvar ...'
	constructions.  Doc fixes.
	(generic-create-generic-function): Use defalias, not fset.

	* find-func.el: More doc fixes.

1999-01-06  Stephen Eglen  <stephen@gnu.org>

	* files.el (save-buffers-kill-emacs): Show the list of current
	processes before prompting to kill them and exit.

1999-01-06  Dave Love  <fx@gnu.org>

	* emacs-lisp/find-func.el: Doc fixes.
	(find-function-regexp): Extend for define-generic-mode,
	define-derived-mode, easy-mmode-define-minor-mode.

1999-01-06  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el (fortran-window-create): Account for scroll
	bar width.

	* browse-url.el: Require (noerror) w3-auto when compiling.
	(browse-url-maybe-new-window): Make it a macro and revert last
	change to callers.
	(browse-url-w3): Require w3 for w3-fetch-other-window.

1999-01-06  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* browse-url.el (browse-url-w3): Give w3-fetch-other-window the
	argument.

1999-01-06  Simon Marshall  <simon@gnu.org>

	* subr.el (with-temp-message): Don't display MESSAGE if nil.  Doc fix.

	* font-lock.el (font-lock-default-fontify-buffer): When using
	with-temp-message, use nil rather than current-message.

	* lazy-lock.el (lazy-lock-unstall):
	(lazy-lock-fontify-after-idle): When using with-temp-message, use nil
	rather than current-message.

	* fast-lock.el (fast-lock-save-cache-1):
	(fast-lock-cache-data): When using with-temp-message, use nil rather
	than current-message.

1999-01-06  Eli Zaretskii  <eliz@gnu.org>

	* international/codepage.el (cp-coding-system-for-codepage-1): Add
	the valid-codes property.

	* international/mule-cmds.el (prefer-coding-system): Call
	set-coding-priority, so that the internal array of priorities is
	also updated.

	* international/mule-util.el:
	(coding-system-change-eol-conversion,
	coding-system-change-text-conversion): Don't define here.

	* international/mule-cmds.el: Define them here.  Remove the
	autoload cookies.

1999-01-06  Andreas Schwab  <schwab@gnu.org>

	* emacs-lisp/debug.el (debug): Leave recursive minibuffer enabled
	if it was enabled before.

	* view.el (View-revert-buffer-scroll-page-forward): Bind
	view-scroll-auto-exit instead of obsolete view-mode-auto-exit.

	* files.el (recover-session): Preserve point when inserting
	explanation.

1999-01-06  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* cus-edit.el (custom-save-delete): Don't delete whitespace
	and comments before the sexp that is replaced.

1999-01-05  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* calendar/diary-lib.el (diary-float): Better fix of end-of-year error.

1999-01-05  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-dired-hook): Use the original value of
	dired-move-to-filename-regexp on lines that have not been
	reformatted yet.
	(vc-dired-toggle-terse-mode): Tell vc-dired-hook whether the
	file lines have already been reformatted.

1999-01-05  Dave Love  <fx@gnu.org>

	* progmodes/f90.el (f90-mode): Make imenu-case-fold-search
	buffer-local.

1998-01-05  Torbjorn Einarsson  <T.Einarsson@clab.ericsson.se>

	* progmodes/f90.el: Change of regular expressions for type to
	correct highlighting and identation. Some small fixes for
	compatibility with XEmacs.

1999-01-05  Stephen Eglen  <stephen@gnu.org>

	* mspools.el (mspools-vm-system-mail): Provide an alternative
	value based on rmail-spool-directory if $MAIL is not defined.

1999-01-05  Carsten Dominik  <dominik@strw.leidenuniv.nl>

	* textmodes/reftex.el (reftex-section-levels): Allow negative levels.
	(reftex-section-info): Handle negative section levels.
	(reftex-view-crossref-extra): New option.
	(reftex-view-crossref): Generalized to work in more places.
	(reftex-find-citation-regexp-format, reftex-find-reference-format)
	(reftex-macros-with-labels, reftex-global-search-marker): New variables.
	(reftex-view-cite-locations-from-bibtex): New command.
	(reftex-view-regexp-match, reftex-global-search)
	(reftex-global-search-continue): New functions.
	(reftex-extract-bib-entries): No error for non-existing BibTeX file,
	just a message.
	(reftex-extract-bib-entries): Better error handling.
	(reftex-select-with-char): Use `*RefTeX Select*' for selection
	help and force it on current frame.
	(reftex-default-bibliography): New function.
	(reftex-access-parse-file): Check consistency after loading a
	parse file.  When inconsistent, enfore rescan.
	(reftex-check-parse-consistency): New function.
	(easy-menu-define): Options section drastically shortened.

1999-01-05  Kenichi Handa  <handa@etl.go.jp>

	* language/thai-util.el (thai-compose-string): New function.

1999-01-04  Inge Frick  <inge@nada.kth.se>

	* easymenu.el (easy-menu-define): Doc fix.
	(easy-menu-create-menu): New keyword :included.
	(easy-menu-do-add-item): New keyword :included.  SUFFIX may
	be an expression, not only a string.  Simulate style `button'.
	Use easy-menu-define-key-intern instead of easy-menu-define-key.
	(easy-menu-define-key-intern): New function.
	(easy-menu-add-item): Understand value returned from
	easy-menu-item-present-p and easy-menu-remove-item.
	(easy-menu-return-item): New function.
	(easy-menu-item-present-p, easy-menu-remove-item): Use it.

1999-01-03  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/rmailsum.el (rmail-summary-output-to-rmail-file):
	Use rmail-output-read-rmail-file-name to read the file name.
	Always call rmail-output-to-rmail-file noninteractively.
	When count > 1, do the loop here.
	Handle rmail-delete-after-output here.
	(rmail-summary-output): Similar changes.

	* mail/rmailout.el: Provide `rmailout'.
	(rmail-output-read-rmail-file-name): New function.
	(rmail-output-to-rmail-file): Use that.
	(rmail-output-read-file-name): New function.
	(rmail-output): Use that.

	* files.el (find-file-noselect): Let /: suppress wildcard matching.
	Error if wildcard matches no files.

1999-01-02  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* menu-bar.el (clipboard-yank): Doc fix.

	* info.el (Info-insert-dir): Chase symlinks for file-attributes.

1998-12-31  Markus Rost  <rost@delysid.gnu.org>

	* textmodes/page-ext.el (pages-copy-header-and-position): Fix typo.

1998-12-31  Andrew Innes  <andrewi@harlequin.co.uk>

	* rmail.el (rmail-encode-string): Make sure mask value is
	positive; (emacs-pid) returns a negative number on Windows 9x
	which causes odd behaviour.

1998-12-31  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* cus-start.el: Don't warn about dos-* variables unless on MS-DOS,
	and about w32-* variables unless on Windows/NT.

1998-12-31  Boris Goldowsky  <boris@alum.mit.edu>

	* textmodes/sgml-mode.el (sgml-validate): Ask whether to save only
	if buffer is modified; ask about all modified buffers.

1998-12-30  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* simple.el (what-cursor-position): Fix previous change.

1998-12-30  Richard Stallman  <rms@sucrose.ai.mit.edu>

	* mail/sendmail.el (mail-mode): Eliminate ambiguous match
	from paragraph-start.

1998-12-30  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* international/mule-cmds.el (prefer-coding-system): If the
	argument requires specific EOL conversion type, make the default
	coding systems use that.

1998-12-30  Drew Csillag  <drew_csillag@geocities.com>

	* progmodes/m4-mode.el (m4-m4-region, m4-m4-buffer):
	Use shell-command-on-region.
	(m4-start-m4, m4-end-m4): Functions deleted.

1998-12-30  Michael Ernst  <mernst@alum.mit.edu>

	* vc.el (vc-backend-diff): Use `diff-switches-list' throughout.

1998-12-29  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* browse-url.el (browse-url-mail): Give argument SEND-ACTION
	to compose-mail in the correct places and as a list.

1998-12-29  Masatake Yamato  <masata-y@tori.aist-nara.ac.jp>

	* page-ext.el: Added mouse-selection feature for pages directory buffer.
	(pages-directory-map): Bind mouse-2
	(pages-copy-header-and-position): Put text property.
	(pages-directory-goto-with-mouse): New function.

1998-12-29  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* international/codepage.el (cp-make-coding-systems-for-codepage):
	Doc fix.
	(cp-coding-system-for-codepage-1): Likewise.

1998-12-29  Kenichi Handa  <handa@etl.go.jp>

	* language/thai-util.el (thai-post-read-conversion): Handle Thai
	composition sequence correctly here instead of calling
	thai-compose-region.

	* textmodes/fill.el (fill-region-as-paragraph): While deleting a
	newline in multibyte buffer, if previous or next character is a
	composite char, check the first component of the composite char.

1998-12-28  Andreas Schwab  <schwab@delysid.gnu.org>

	* emacs-lisp/advice.el (ad-special-forms): Add save-current-buffer
	and track-mouse.

1998-12-27  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

	* mail/sendmail.el (mail-yank-original): Remove text properties
	after insertion.
	(mail-yank-region): Barf if no mark is set in the message
	being replied to.

	* help.el (function-called-at-point): First look for function at point.

1998-12-27  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* edmacro.el (edit-kbd-macro): Recognize electric-view-lossage.

1998-12-26  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* simple.el (what-cursor-position): Print character encoding also.

1998-12-26  Dave Love  <fx@gnu.org>

	* textmodes/flyspell.el: If local-maps work, don't put
	flyspell-mode-map in minor-mode-map-alist; bind mouse-2 and M-TAB
	in flyspell-mouse-map (only).
	(flyspell-use-local-map): New variable.
	Use a different mouse-2 binding in that case,
	and don't add to minor-mode-map-alist.
	(make-flyspell-overlay, flyspell-correct-word):
	Test flyspell-use-local-map.

1998-12-26  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* files.el (file-expand-wildcards): Handle wildcards in directory name.
	Be careful about whether to return a relative file name,
	and if so, relative to what directory.

1998-12-25  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/easymenu.el (easy-menu-get-map):
	Change global map only if this menu exists in the global map already,
	and not in the local map.
	(easy-menu-do-add-item): Fix error message.

	* foldout.el (foldout-inhibit-key-bindings):
	Avoid concatenating onto outline-minor-mode-prefix.
	Make a new keymap for that prefix, if it does not already have one.

1998-12-25  Ilya Zakharevich  <ilya@math.ohio-state.edu>

	* cperl-mode.el:
	Can use linear algorithm for indentation if Emacs supports it.
	(cperl-after-expr-p): It is BLOCK if we reach lim when backup sexp.
	(cperl-after-block-p): Likewise.
	(cperl-after-block-and-statement-beg): Likewise.
	(cperl-after-block-p): After END/BEGIN we are a block.
	(cperl-after-expr-p): Skip labels when checking
	(cperl-indent-region): Make a marker for END - text added/removed.
	Disable hooks during the call (how to call them later?).
	Now indents 820-line-long function in 6.5 sec (including
	syntaxification) the first time (when buffer has few
	properties), 7.1 sec the second time.
	(cperl-indent-region): Do not indent whitespace lines.
	(cperl-style-alist): Include `cperl-merge-trailing-else' where the
	value is clear.
	(cperl-styles-entries): Likewise.
	(cperl-problems): Improvements to docs.
	(cperl-tips): Likewise.
	(cperl-non-problems): Likewise.
	(cperl-mode): Make lazy syntaxification possible.
	Loads pseudo-faces for the sake of `cperl-find-pods-heres' (for 19.30).
	`font-lock-unfontify-region-function' was set to a wrong function.

	(cperl-find-pods-heres): Safe a position in buffer where it is safe to
	restart syntaxification.  Changed so that -d ?foo? is a RE. Do
	not warn on `=cut' if doing a chunk only. 1 << 6 was OK,
	but 1<<6 was considered as HERE-doc.
	<file/glob> made into a string.
	Postpone addition of faces after syntactic step.
	Recognition of <FH> was wrong.
	Highlight `gem' in s///gem as a keyword.  `qr' recognized.
	Knows that split// is null-RE.
	Highlights separators in 3-parts expressions as labels.
	<> was considered as a glob.
	Would err if the last line is `=head1'.
	$a-1 ? foo : bar; was a considered a regexp.
	`<< (' was considered a start of HERE-doc.
	mark qq[]-etc sections as syntax-type=string
	Was not processing sub protos after a comment ine.
	Was treating $a++ <= 5 as a glob.
	Tolerate unfinished REx at end-of-buffer.
	`unwind-protect' was left commented.
	/ and ? after : start a REx.

	(cperl-syntaxify-by-font-lock): Set to t, should be safe now.
	Better default, customizes to `message' too, off in text-mode.

	(cperl-array-face): Renamed from `font-lock-emphasized-face',
	`defface'd.
	(cperl-hash-face): Renamed from `font-lock-other-emphasized-face'.
	`defface'd.
	(cperl-emacs-can-parse): New state variable.
	(cperl-indent-line): Corrected to use global state.
	(cperl-calculate-indent): Likewise.
	(cperl-fix-line-spacing): Likewise (not used yet).
	(cperl-calculate-indent): Did not consider `,' as continuation mark
	for statements.
	(cperl-calculate-indent): Avoid parse-data optimization at toplevel.
	Remove another parse-data optimization at toplevel: would
	indent correctly.
	Correct for labels when calculating indentation of continuations.
	Docstring updated.
	(cperl-choose-color): Converted to a function (to be
	compilable in text-mode).
	(cperl-dark-background): Disable without window-system.
	Do `defface' only if window-system.
	(cperl-fix-line-spacing): Sped up to bail out early.
	(x-color-defined-p): Was not compiling on XEmacs
	Was defmacro'ed with a tick.  Remove another def.
	(cperl-clobber-lisp-bindings): If set, C-c variants are the old ones
	(cperl-unwind-to-safe): New function.
	(cperl-fontify-syntaxically): Use `cperl-unwind-to-safe' to start at
	reasonable position.
	(cperl-fontify-syntaxically): Unwinds start and end to go out of long
	strings (not very successful).
	(cperl-forward-re): Highlight the trailing / in s/foo// as string.
	Highlight the starting // in s//foo/ as function-name.
	Emit a meaningful error instead of a cryptic one for an
	uncomplete REx near end-of-buffer.

	(cperl-electric-keyword): `qr' recognized.
	(cperl-electric-else): Likewise.
	(cperl-to-comment-or-eol): Likewise.
	(cperl-make-regexp-x): Likewise.
	(cperl-init-faces): Likewise, and `lock' (as overridable?).
	Corrected to use new macros;
	`if' for copying `reference-face' to `constant-face' was backward.
	Remove init `font-lock-other-emphasized-face',
	`font-lock-emphasized-face', `font-lock-keyword-face'.
	Interpolate `cperl-invalid-face'.
	(cperl-make-regexp-x): Misprint in a message.
	(cperl-syntaxify-unwind): New configuration variable.
	(cperl-fontify-m-as-s): New configuration variable.
	(cperl-electric-pod): Check for after-expr was performed
	inside of POD too.
	(cperl-backward-to-noncomment): Cetter treatment of PODs and HEREs.
	(cperl-clobber-mode-lists): New configuration variable.
	(cperl-not-bad-style-regexp): Updated.
	Init: `cperl-is-face' was busted.
	(cperl-make-face): New macros.
	(cperl-force-face): New macros.
	(font-lock-other-type-face): Done via `defface' too.
	(cperl-nonoverridable-face): New face.  Renamed from
	`font-lock-other-type-face'.
	(cperl-init-faces-weak): Use `cperl-force-face'.
	(cperl-comment-indent): Commenting __END__ was not working.
	(cperl-indent-for-comment): Likewise.
	(cperl-write-tags): Correct for XEmacs's `visit-tags-table-buffer'.
	When removing old TAGS info was not relativizing filename.
	(cperl-tags-hier-init): Gross hack to pretend we work (are we?).
	Another try to work around XEmacs problems.  Better progress messages.
	(toplevel): Require custom unprotected => failure on 19.28.
	(cperl-xemacs-p): Defined when compile too.
	(cperl-find-tags): Was writing line/pos in a wrong order,
	pos off by 1 and not at beg-of-line.
	(cperl-etags-snarf-tag): New macro.
	(cperl-etags-goto-tag-location): New macro.
	(cperl-version): New variable.  New menu entry
	random docstrings: References to "future" 20.3 removed.
	Menu was described as `CPerl' instead of `Perl'
	(perl-font-lock-keywords): Would not highlight `sub foo($$);'.
	(cperl-toggle-construct-fix): Was toggling to t instead of 1.
	(cperl-ps-print-init): Associate `cperl-array-face', `cperl-hash-face'
	Remove `font-lock-emphasized-face', `font-lock-other-emphasized-face',
	`font-lock-reference-face', `font-lock-keyword-face'.
	Use `eval-after-load'.
	Remove not-CPerl-related faces.
	(cperl-tips-faces): New variable and an entry into Mini-docs.
	(cperl-indent-exp): Was not processing else-blocks.
	(cperl-get-state): NOP line removed.
	(cperl-ps-print): New function and menu entry.
	(cperl-ps-print-face-properties): New configuration variable.
	(cperl-invalid-face): New configuration variable.
	(perl-font-lock-keywords): Highlight trailing whitespace.
	(cperl-contract-levels): Documentation corrected.
	(cperl-contract-level): Likewise.
	(cperl-ps-extend-face-list): New macro.
	(cperl-invalid-face): Change to ''underline.

1998-12-25  Markus Rost  <rost@delysid.gnu.org>

	* mail/rmailout.el (rmail-output): Abbreviate name of default-file
	for read-file-name.
	(rmail-output-to-rmail-file): Likewise.

1998-12-25  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/easymenu.el (easy-menu-get-map):
	If MENU is nil, use global menu-bar map.
	(easy-menu-add-item, easy-menu-remove-item): Argument renamed.
	(easy-menu-item-present-p, easy-menu-get-map): Argument renamed.

1998-12-22  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-mule.el (ps-mule-begin-job): Programming uniformization.

1998-12-22  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el (ps-print-version): New version number (4.1.3).

1998-12-21  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* international/mule-cmds.el: Use make-sparse-keymap instead of
	define-prefix-key when defining MULE menu items.

	* info.el (Info-node-at-bob-matching): New function.
	(Info-find-node, Info-build-node-completions): Call it.

1998-12-21  Andreas Schwab  <schwab@delysid.gnu.org>

	* help.el (describe-function-1): Say "keymap", not "Lisp macro",
	when this is an autoloaded keymap.

1998-12-20  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* international/codepage.el (cp-coding-system-for-codepage-1):
	Create separate encoders and decoders, for DOS and Unix.  Make the
	usual family of 3 coding systems, so that automatic detection of
	EOL type works.
	(cp-make-coding-systems-for-codepage): Don't intern DOS- and
	Unix-specific symbols here, and don't call
	cp-coding-system-for-codepage-1 twice.  (Suggested by Ken'ichi
	Handa <handa@etl.go.jp>.)

	* dos-vars.el (dos-codepage-setup-hook): New defcustom.

	* term/internal.el (IT-character-translations): New variable, an
	alist used to display characters for which there's no glyphs in
	the current codepage.
	(IT-display-table-setup): New function, sets up the DOS terminal
	for a given codepage.
	(dos-codepage-setup): New function, sets up the MULE environment
	for the current value of dos-codepage.
	(top-level if): In the multibyte mode, turn on
	unibyte-display-via-language-environment.  In the unibyte mode, set up
	the special syntax tables to map lower- to upper case and back.

1998-12-19  Eric Ludlam  <zappo@delysid.gnu.org>

	* speedbar.el (speedbar-frame-parameters): Add : to custom prompt.
	(speedbar-frame-plist) Remove useless comments.
	(speedbar-frame-mode) Do not specify height if it is in the param list.
	Use default y position w/out changing it.
	If default x position is a list, keep, calculate the non-list X
	value when devining an initial position.
	(speedbar-this-file-in-vc) Fix SCCS to use s. not p. files.
	(speedbar-tag-group-name-minimum-length): New variable.
	(speedbar-frame-parameter): New compatibility function.
	(speedbar-frame-mode): Updated to use speedbar-frame-parameter.
	(speedbar-apply-one-tag-hierarchy-method): Fixed up taging sub
	groups to keep things in the right order, and to help with some
	naming conventions.
	(speedbar-create-tag-hierarchy): Enable buffer local version of
	`speedbar-tag-hierarchy-method' in the buffer we are tagging.
	(speedbar-line-path) Make DEPTH param optional.  Devine it if absent.
	the case, derive it from the cursor location in speedbar.

1998-12-17  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* international/mule-cmds.el (set-language-environment): On MS-DOS
	terminals, install DOS-specific nonascii-translation-table if the
	language info doesn't specify one.  Pass the default eol-type to
	set-language-environment-coding-systems.
	(set-default-coding-systems): Copy the eol-type property for the
	new default values of {buffer-file,process}-coding-system from the
	old defaults.
	(set-language-environment-coding-systems): Accept an optional
	argument EOL-TYPE, and set the eol-type property of the default
	coding systems accordingly.
	(set-terminal-coding-system): Enable menu item on MS-DOS terminals.
	(set-keyboard-coding-system): Likewise.
	(set-default-coding-systems): Don't set
	default-terminal-coding-system on MS-DOS to anything but nil.
	(prefer-coding-system): Describe in the doc string that
	default-terminal-coding-system is not changed on MS-DOS.
	(set-language-environment): For MS-DOS, set standard syntax table
	and display table for all characters with code above 127.
	(standard-display-european-internal): For MS-DOS, pass all
	characters with code above 127 directly to the terminal, and don't
	remap characters 160 and 146 in the unibyte case.

	* international/codepage.el: New file.

1998-12-16  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* diary-lib.el (diary-float): Fix end-of-year error and typos
	in comments.

1998-12-16  Oleg S. Tihonov  <tihonov@ffke-campus.mipt.ru>

	* map-ynp.el (map-y-or-n-p): Ignore input methods.

	* subr.el (read-passwd): Likewise.

1998-12-16  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* info.el (Info-find-node): Add 1 to the position read from the
	tag table.  Don't fail if the node delimiter ^_ is the first
	character in the file.
	(Info-insert-dir): Don't fail when the node delimiter ^_ is the
	first character in the file.
	(Info-read-subfile): Likewise.
	(Info-select-node): Likewise.
	(Info-build-node-completions): Likewise.

1998-12-16  Richard Stallman  <rms@gnu.org>

	* term/x-win.el (x-cut-buffer-or-selection-value):
	If clipboard is enabled, try it before PRIMARY selection.

1998-12-15  Emilio Lopes  <Emilio.Lopes@Physik.TU-Muenchen.DE>

	* international/iso-acc.el (iso-languages): For Portuguese ~c and ~C
	insert c-cedilla and C-cedilla respectively, like in latin-1.

1998-12-15  Eli Zaretskii  <eliz@delysid.gnu.org>

	* language/hebrew.el: Don't use sublists in the flags argument
	passed to make-coding-system.

1998-12-15  Kenichi Handa  <handa@etl.go.jp>

	* ps-mule.el (ps-mule-begin-job): Delete nil and unknown from a
	list of character sets found by find-charset-region.

	* ps-mule.el: Always require ps-print.  Move some function
	definitions for Emacs 20.2 and the earlier to ps-print.el.
	(ps-mule-find-wrappoint): Make it work also with Emacs 20.2.

	* ps-print.el: Define several functions for Emacs 20.2 and the
	earlier version.
	(ps-printer-name): Check if printer-name is bound.

1998-12-15  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-mule.el: Programming uniformization and little code improvement.
	(ps-mule-prepare-font): Programming uniformization.
	(ps-mule-find-wrappoint, ps-mule-plot-rule-cmpchar)
	(ps-mule-string-encoding, ps-mule-begin-job): Little code improvement.

	* ps-bdf.el: Programming uniformization and little code improvement.
	(bdf-search-and-read): New fun.
	(bdf-write-cache, bdf-initialize, bdf-info-absolute-path)
	(bdf-info-mod-time, bdf-info-size, bdf-info-font-bounding-box)
	(bdf-info-relative-compose, bdf-info-baseline-offset)
	(bdf-info-code-range, bdf-info-maxlen, bdf-info-offset-vector)
	(bdf-read-bitmap, bdf-get-bitmaps): Programming uniformization.
	(bdf-expand-file-name, bdf-file-newer-than-time, bdf-find-file)
	(bdf-read-cache, bdf-read-font-info, bdf-generate-glyphs):
	Little code improvement.

1998-12-15  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el (ps-print-version): New version number (4.1.2), doc fix
	and mule related code extraction. Autoload ps-mule funs.

	* ps-mule.el: Doc fix. Require ps-print only when compiled.
	(ps-mule-prologue-generated): New fun.
	(ps-mule-plot-string): Add autoload cookie.
	(ps-mule-begin-job): Call ps-mule-prologue-generated.

1998-12-15  Kenichi Handa  <handa@etl.go.jp>

	* ps-bdf.el: Require ps-mule instead of ps-print.
	(bdf-directory-list): Add autoload cookie.

	* ps-mule.el: New file.  Mule related code extracted from
	ps-print.el.  Require ps-print, provide ps-mule.
	(ps-multibyte-buffer): Add autoload cookie.
	(ps-mule-prepare-ascii-font): New fun.
	(ps-mule-set-ascii-font): New fun.
	(ps-mule-skip-same-charset): Fun deleted.
	(ps-mule-plot-string): Set ps-mule-current-charset.
	(ps-mule-initialize): Add autload cookie.  Don't set
	ps-mule-font-info-database here.
	(ps-mule-begin-job): Renamed from ps-mule-begin.  Update
	ps-mule-font-info-database and ps-control-or-escape-regexp.
	(ps-mule-begin-page): New fun.

	* ps-print.el: Mule related code moved to ps-mule.el.
	(ps-begin-job): While setting ps-control-or-escape-regexp, don't
	check ps-mule-charset-list.
	(ps-begin-page): Don't set ps-mule-current-charset, instead call
	ps-mule-begin-page.
	(ps-basic-plot-string): Call ps-mule-prepare-ascii-font.
	(ps-plot-region): Don't set ps-mule-current-charset, instead call
	ps-mule-set-ascii-font.  Don't call ps-mule-skip-same-charset,
	instead skip same charsets by itself.
	(ps-generate): Call ps-mule-initialize of needs-begin-file is
	non-nil.  Call ps-mule-begin-job.

1998-12-15  Kenichi Handa  <handa@etl.go.jp>

	* ps-bdf.el: File name changed from bdf.el.  Provide ps-bdf
	instead of bdf.

	* ps-print.el (ps-mule-font-info-database): Doc-string modified.
	(ps-mule-external-libraries): New element FEATURE.
	(ps-mule-init-external-library): Ajusted for the above change.
	(ps-mule-generate-font): Likewise.
	(ps-mule-generate-glyphs): Likewise.
	(ps-mule-prepare-font): Likewise.
	(ps-mule-initialize): Likewise.
	(ps-begin-file): Superfluous tailing parenthesis deleted.

1998-12-15  Kenichi Handa  <handa@etl.go.jp>

	* international/fontset.el (x-decompose-font-name): If PATTERN
	doesn't have any wild cards, return a vector made from a name that
	is found by x-resolve-font-name found.  Comments added.

	* international/mule-cmds.el (find-coding-systems-for-charsets):
	Handle the case of unknown charset.
	(find-multibyte-characters): If invalid multibyte characters are
	found, return the corresponding strings instead of character codes.
	(find-multibyte-characters): Adjusted for the above change.
	(select-safe-coding-system): For a unibyte buffer, always returns
	DEFAULT-CODING-SYSTEM.
	(get-charset-property): Fix previous change.  Make it a function.
	(put-charset-property): Make it a function.

	* international/mule.el (make-coding-system): Set mime-charset
	property of *-with-esc coding system to nil.

	* international/quail.el (quail-point-in-conversion-region):
	New function.
	(quail-conversion-backward-delete-char): When a key sequence is
	being translated, call quail-delete-last-char.

	* language/devan-util.el
	(devanagari-reorder-glyphs-for-decomposition): Fix the way to
	handle devanagari-decomposition-rules.

1998-12-14  Andreas Schwab  <schwab@delysid.gnu.org>

	* textmodes/texinfo.el (texinfo-tex-buffer): Bind
	tex-start-options-string to empty string.
	(texinfo-tex-region): Use texinfo-tex-trailer as documented.

1998-12-14  Andrew Innes  <andrewi@delysid.gnu.org>

	* gnus/nntp.el (nntp-request-group): Undo previous change (4xx and
	5xx responses are already handled properly).

1998-12-13  Richard Stallman  <rms@gnu.org>

	* progmodes/compile.el (compilation-error-regexp-alist):
	Insist on a non-digit in the file name.

	* simple.el (comment-region): Handle comment-padding
